2013-01-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/splitconfig:
 - Rewrote in python.
 - Much shorter: most of the code was detecting & handling grep flavours!
 - Should fix BSD build problem.  Thanks Martin van den Nieuwelaar.
2013-01-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, src/binarystring.cxx:
 - C++11 fix: instantiate on non-const unsigned char.  Thanks Linus Kallberg.
2013-01-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/isolation.hxx:
 - Updated documentation for isolation levels.
2013-01-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/isolation.hxx:
 - Support for REPEATABLE READ isolation level.  Thanks pawsa.
 - Fixes #259.
2013-01-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/mingw.mak.template:
 - Build fix for MinGW: LIBPQPATH, not LIBPATH.  Thanks Maxwell (?)
 - Fixes #261.
2013-01-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/strconv.cxx, test/unit/test_string_conversion.cxx:
 - Backport fix for #263.
2013-01-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
 - Fix w clang++ 3.0: basic C-library test broke.
2012-08-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx:
 - Backported fix for #252: clang++ 3.2 compile error.  Thanks Amy Troschinetz.
 src/strconv.cxx:
 - Backported fix for #253: clang++ 3.2 compile error.  Thanks Amy Troschinetz.
2012-03-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test002.cxx, test/test007.cxx, test/test011.cxx, test/test012.cxx,
 test/test016.cxx, test/test030.cxx, test/test031.cxx, test/test049.cxx,
 test/test067.cxx, test/test082.cxx, test/test093.cxx:
 - C++11 fixes.
2012-03-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
 - Compatibility typedefs: pqxx::result::tuple and pqxx::result::field.
 - Not going into trunk, only in the 4.0 series.
 - Thanks Maxime van Noppen.
2012-03-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/prepared_statement.hxx:
 - Updated docs for prepared-statement parameters: no longer need declarations.
 - Thanks Maxime van Noppen.
2012-03-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
 - Fixed compile error and warnings in example code.
 - Thanks Martin van den Nieuwelaar and Chris Angelico.
2012-02-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/extract_version:
 - Compatibility fix for OS X.  Thanks Torsten Hilgenberg.
2012-01-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_prepared_statement.cxx:
 - Test was brittle w.r.t. result ordering.  Rewrote it.
 - Thanks Jean Marie de Montarby (did I spell that right?) for the report.
2012-01-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test004.cxx, test/test023.cxx, test/test078.cxx, test/test079.cxx,
 test/test087.cxx:
 - Stop using deprecated notify_listener.
 - Stop using deprecated connection-unaware escaping functions.
2011-12-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tuple.hxx:
 - Forward-declare pqxx::range_error.
 - pqxx::range_error, not just range_error (problem with g++ -std=c++0x).
 src/Makefile.am:
 - Cosmetic.
 test/unit/test_result_slicing.cxx:
 - Disambiguate tuple as pqxx::tuple, not std::tuple, for C++0x.
 tools/Makefile.am:
 - Prevent include/pqxx from going into the include path.
 - Include path was breaking #include <tuple> in C++0x standard headers!
2011-11-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease:
 - Removed.
2011-11-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/sign-tarball:
 - New tool.
 - Creates GPG signature & hash sums for tarball.
2011-11-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 debian/changelog:
 - Real start of 4.0 series.
2011-11-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/subtransaction.hxx, src/subtransaction.cxx:
 - Explicit subtransaction(subtransaction &) constructor.
 - Makes it easier to nest subtransactions inside subtransactions.
 - Thanks Chris Angelico for reporting the problem.
2011-11-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, doc/Makefile.am:
 - Fixed fail-if-no-doxygen logic.  Really fails now.
 - Also fail if xmlto is missing (and documentation build not disabled).
 - Really fixes #245 (I hope).
2011-11-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Makefile.am:
 - Fail if doxygen not available (and documentation build not disabled).
 - Fixes #245.  Thanks Chris Angelico.
2011-11-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/performance.hxx:
 - Don't mention tablestreams any more.
 - Fixes #246.  Thanks Chris Angelico.
2011-11-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx,
 include/pqxx/internal/gates/connection-pipeline.hxx, src/connection_base.cxx:
 - encoding_code() can't be "throw ()"; it calls activate().
 - Crashed program when connection was lost before transaction started.
 - Thanks Vasya Pupkin for reporting this with a great little test program.
2011-11-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/subtransaction.hxx:
 - Fixed broken example.  Thanks Chris Angelico.
2011-11-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt, win32/mingw.mak.template:
 - Remove quotes that confused MinGW make.
 - MinGW's make tool has a different name.
 - As per patch in #244, thanks Sam Kapilivksy.
2011-11-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 debian/libpqxx.docs, debian/libpqxx-dev.docs:
 - Removed reference to old TODO file.
2011-11-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
 - Cosmetic.
2011-11-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
 - Documentation patch from #243.  Thanks Sam Kapilivsky.
2011-11-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx,
 test/unit/test_errorhandler.cxx:
 - Provide access to a connection's errorhandlers list.
 - Fixes #242.  Thanks Sam Kapilivsky for pointing out the need.
2011-11-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/errorhandler.hxx, src/notify-listen.cxx:
 - Added missing #include <functional>
 - Fixes #241.  Thanks Sam Kapilivsky.
2011-11-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-libpqxx.mak.template:
 - Use debug library where appropriate, as per #238 (thanks Sam Kapilivksy).
 win32/vc-test-unit.mak.template:
 - Build test/unit, not test, also as per #238
2011-11-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
 - Overhaul by Sam Kapilivsky.  Thanks once again!
2011-11-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test_main.hxx:
 - Workaround in create_pqxxevents for older backends without multi-insert.
2011-11-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh, win32/vc-test-unit.mak.template:
 - Support building of new-style unit tests on Visual C++.
 - As per patch in #238; thanks Sam Kapilivsky.
 win32/common-sample, win32/vc-libpqxx.mak.template,
 win32/vc-test.mak.template:
 - Easier Visual C++ setup.
 - As per patch in #238; thanks Sam Kapilivsky.
2011-11-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
 - Removed reference to tablestreams.
2011-11-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablereader.hxx, include/pqxx/tablestream.hxx,
 include/pqxx/tablewriter.hxx:
 - Deprecated tablestream classes (tablereader, tablewriter).
 - Fixes #199, #223.
 - Thanks to cuboci and Andreas Freund for pointing out the problems.
 include/pqxx/transaction_base.hxx, include/pqxx/transactor.hxx,
 include/pqxx/util.hxx, test/test000.cxx, test/test007.cxx, test/test010.cxx,
 test/test013.cxx, test/test018.cxx, test/test020.cxx, test/test026.cxx,
 test/test029.cxx, test/test032.cxx, test/test037.cxx, test/test039.cxx,
 test/test066.cxx, test/test075.cxx, test/test082.cxx, test/test083.cxx,
 test/test088.cxx, test/test_helpers.hxx, test/test_main.hxx:
 - Create pqxxevents only on demand, locally per test (and as temporary).
 - Move test coverage from deleted tests to remaining ones.
 src/transaction_base.cxx:
 - Removed unneeded tablestream include.
 test/test005.cxx, test/test006.cxx, test/test008.cxx, test/test009.cxx,
 test/test024.cxx, test/test025.cxx, test/test027.cxx, test/test028.cxx,
 test/test068.cxx, test/test080.cxx, test/unit/test_tablestream.cxx:
 - Deleted tablestream tests.
 - No longer create permanent pqxxevents table.
 test/test083.cxx:
 - No longer create permanent pqxxnumbers table.
2011-11-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection.cxx:
 - Fix #232: long-standing asyncconnection bug (especially with SSL).
 - Thanks again Sam Kapilivksy for tracking this down.
2011-11-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, include/pqxx/util.hxx, src/binarystring.cxx,
 src/util.cxx:
 - Always free binarystring buffer using std::free().
 - Fixes #227: on Windoes, must free() from same library that malloc()ed.
 - Thanks Sam Kapilivsky for diagnosing the error and working out the fix.
2011-11-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection.cxx:
 - Work around compiler warning for removed PGRES_POLLING_ACTIVE in switch.
 src/cursor.cxx:
 - Hopefully the right fix for that Visual Studio warning this time.
 - Fixes #239.  Thanks Sam Kapilivsky.
2011-11-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/VisualStudio2005/pqxx/config-public-compiler.h,
 config/sample-headers/compiler/VisualStudio2008/pqxx/config-public-compiler.h,
 config/sample-headers/compiler/VisualStudio2010/pqxx/config-public-compiler.h:
 - Removed PQXX_HAVE_STRERROR_R; Visual Studio has strerror_s.
 - Fixes #240.  Thanks Sam Kapilivsky.
2011-11-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection.cxx:
 - Removed support for obsolete PGRES_POLLING_ACTIVE.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/VisualStudio2005,
 config/sample-headers/compiler/VisualStudio2008,
 config/sample-headers/compiler/VisualStudio2010:
 - New sample headers by Sam Kapilivksy.
 include/pqxx/util.hxx, test/unit/test_thread_safety_model.cxx:
 - Renamed have_strerror_r to have_safe_strerror; it's not just strerror_r.
 src/util.cxx:
 - Support Windows strerror_s as other safe alternative to strerror.
 - Fixes #235.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
 - Made PQAlloc contain a std::shared_ptr, not derive from it.
 - As per patch in #236; fixes Visual Studio build problems.
 - Thanks Sam Kapilivsky.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test_helpers.hxx:
 - New trick for accepting (and requiring) semicolon after PQXX_CHECK_THROWS.
 - Less idiomatic, but avoids Visual Studio warning.
 - Completes the fix for #231.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-internal.hxx, test/test087.cxx:
 - Suppress pointless Visual Studio warnings.
 - Fixes most of #231; more discussion about test_helpers.hxx patch.
 - Thanks Sam Kapilivsky.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
 - Cast around std::streamsize/icursorstream::difference_type mismatch.
 - Fixes icursorstream::ignore, as per #230.
 - Thanks once more Sam Kapilivsky.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-internal.hxx, include/pqxx/cursor.hxx,
 include/pqxx/util.hxx, test/unit/test_prepared_statement.cxx:
 - Moved distance() wrapper from compiler-internal into util.
 - Added some missing PQXX_LIBEXPORT directives.
 - Fixes #237.
 - Thanks Sam Kapilivsky for knocking the Visual Studio build into shape.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/strconv.hxx:
 - Add redundant string_traits<const char[N]> to keep Visual Studio happy.
 - Fixes #233; thanks Sam Kapilivsky.
 test/unit/test_string_conversion.cxx:
 - New.
 - Unit-tests string conversions (for now, only of various string types).
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_prepared_statement.cxx:
 - Fixed two Visual Studio warnings.
 - Fixes #234.  Thanks (you guessed it) Sam Kapilivsky.
2011-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-libpqxx.mak.template:
 - Fixed typos introduced in my application of the patch in #228.
 - Should get Visual Studio build working again.
 - Fixes #229.  Thanks Sam Kapilivsky.
2011-10-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx:
 - Very slight wording change; hope it's a bit clearer.
 - Thanks Sam Kapilivsky for pointing this out in #222.
2011-10-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-libpqxx.mak.template, win32/vc-test.mak.template:
 - The rest of the patch in #228.  Thanks Sam Kapilivsky.
2011-10-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test000.cxx, test/test002.cxx, test/test060.cxx, test/test061.cxx,
 test/test062.cxx, test/test064.cxx, test/test071.cxx, test/test075.cxx:
 - Removed unneeded headers as per #228 (though it has more changes).
 - Thanks Sam Kapilivsky for the patch.
2011-10-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test051.cxx:
 - Work around problem with Visual C++ 2010.  Should fix #225.
 - Thanks Sam Kapilivsky.
2011-10-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Fix gcc warning.
2011-10-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-test.mak.template:
 - Fix build on Visual C++ 2010.  Fixes #226.  Thanks Sam Kapilivsky.
2011-10-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Fixed compile errors on gcc 3.3.
2011-10-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/connection.hxx,
 src/connection_base.cxx, test/test013.cxx, test/test018.cxx,
 test/test032.cxx, test/test037.cxx, test/test056.cxx, test/test060.cxx,
 test/test061.cxx, test/test064.cxx, test/test070.cxx, test/test072.cxx,
 test/test073.cxx, test/test083.cxx, test/test086.cxx,
 test/unit/test_errorhandler.cxx:
 - Removed remaining references to noticer.
 - Made all remaining noticer support conditional on auto_ptr.
2011-10-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/errorhandler.hxx:
 - Forgot PQXX_LIBEXPORT.  Thanks Kirit Saelensminde.
2011-10-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/basic_connection.hxx, include/pqxx/robusttransaction.hxx,
 include/pqxx/transaction.hxx, src/connection_base.cxx, src/largeobject.cxx,
 src/notification.cxx, src/pipeline.cxx, src/tablereader.cxx,
 src/tablewriter.cxx, src/transaction_base.cxx:
 - Updated "quiet destructors" to use quiet_errorhandler.
 - Fixes #224.  Thanks Kirit Saelensminde for testing this when asked.
2011-10-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Refuse to escape "tricky" identifier without PQescapeIdentifier.
 - Fixes remaining issue with #221.  Thanks Andreas Freund.
2011-10-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/Makefile.am, include/pqxx/binarystring.hxx,
 include/pqxx/internal/gates/connection-parameterized-invocation.hxx,
 include/pqxx/internal/gates/connection-prepare-declaration.hxx,
 include/pqxx/internal/gates/connection-prepare-invocation.hxx,
 include/pqxx/internal/gates/connection-transaction.hxx,
 include/pqxx/internal/statement_parameters.hxx,
 include/pqxx/prepared_statement.hxx, include/pqxx/transaction_base.hxx,
 src/binarystring.cxx, src/connection_base.cxx, src/prepared_statement.cxx,
 src/statement_parameters.cxx, src/transaction_base.cxx, test/test092.cxx,
 test/unit/test_prepared_statement.cxx:
 - Require server version 8.0 or better.
 - Require backend protocol 3 or better.
 - No longer need to declare parameter lists for prepared statements.
 - Same for parameterized statements.
 - binarystring can now also come from a std::string, or {void *, size_t}.
 - To produce a binary parameter, simply pass a binarystring.
 - No longer need connection-prepare-declaration call gate.
2011-10-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure/sample-headers/libpq/7.3, configure/sample-headers/libpq/7.4:
 - Removed.
 configitems, configure.ac.in, include/pqxx/field.hxx,
 include/pqxx/result.hxx, include/pqxx/tuple.hxx, include/pqxx/util.hxx,
 src/binarystring.cxx, src/connection_base.cxx, src/result.cxx,
 src/subtransaction.cxx, src/transaction_base.cxx, src;util.cxx:
 - Require PQescapeStringConn, PQescapeByteaConn, PQunescapeBytea.
 - Require PQprotocolVersion and PQserverVersion.
 - Require PQftable and PQftablecol.
 - Require PQPutCopyData and friends.
 - Require PQprepare, PQexecPrepared, and PQexecParams.
 - Require PQresultErrorField and PQsetErrorVerbosity.
 - Forget about PQfreeNotify; require PQfreeMem.
 - Basically, require libpq 8.0 or better.
2011-10-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/Makefile.am, include/pqxx/binarystring.hxx,
 include/pqxx/connectionpolicy.hxx, include/pqxx/cursor.hxx,
 include/pqxx/field, include/pqxx/field.hxx,
 include/pqxx/internal/gates/connection-largeobject.hxx,
 include/pqxx/internal/gates/connection-pipeline.hxx,
 include/pqxx/internal/libpq-forward.hxx,
 include/pqxx/internal/result_data.hxx, include/pqxx/libpq-forward.hxx,
 include/pqxx/pqxx, include/pqxx/result.hxx, include/pqxx/tuple,
 include/pqxx/tuple.hxx, include/pqxx/util.hxx, src/binarystring.cxx,
 src/cursor.cxx, src/field.cxx, src/Makefile.am, src/result.cxx,
 src/tuple.cxx, test/test002.cxx, test/test007.cxx, test/test011.cxx,
 test/test012.cxx, test/test016.cxx, test/test030.cxx, test/test031.cxx,
 test/test049.cxx, test/test067.cxx, test/test082.cxx, test/test093.cxx,
 test/test_helpers.hxx, test/test_main.hxx, test/unit/test_result_slicing.cxx:
 - const_fielditerator is now const_tuple_iterator (similar for reverse).
 - result::const_iterator is now const_result_iterator (similar for reverse).
 - field and tuple classes are no longer nested in result.
 - field has its own source file and headers.
 - tuple and iterators have their own source file and headers.
 - tuple and result iterator classes are no longer nested in result.
 - libpq-forward has moved into <pqxx/internal>.
 - internal::result_data has moved into <pqxx/internal>.
 - field no longer contains a tuple.
 - Iterator classes are no longer mentioned by independent name.
2011-10-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/html/Reference/.cvsignore:
 - Ignore JavaScript files now generated as part of documentation.
 include/pqxx/pqxx, include/pqxx/internal/gates/errorhandler-connection.hxx,
 include/pqxx/internal/gates/connection-errorhandler.hxx,
 include/pqxx/errorhandler, include/Makefile.am, src/errorhandler.cxx,
 src/connection_base.cxx, src/Makefile.am, test/test014.cxx,
 test/unit/test_errorhandler.cxx:
 - New class "errorhandler" to replace noticers.
 - No more auto_ptr or unique_ptr.
 - Test 014 no longer mixes purposes.
 - Thanks Kirit Saelensminde for help with design.
2011-09-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 COPYING:
 - Included copyright notice; makes more sense now.
 - Thanks Arkadiusz at GoAhead Software for pointing this out.
2011-09-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablewriter.hxx, test/unit/test_tablestream.cxx:
 - Fixed glaring templating error in null-escaping.  Thanks sth.dev at tejp!
 - Fixes #200.
2011-09-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx, test/unit/test_escape.cxx:
 - Support PQescapeIdentifier as quote_name.  Thanks Andreas Freund.
 - Fixes #66.
2011-09-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
 - Test for PQescapeIdentifier.
2011-09-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Make timeval initializers compatible with more platforms.
2011-09-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/Makefile.am:
 - Renamed test_except.cxx to test_exceptions.cxx.
 test/unit/test_notification.cxx:
 - Clearer comment.
2011-08-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_exceptions.cxx:
 - New
 - Tests pqxx_exception downcast example given in except.hxx.
2011-07-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Use reinterpret_cast for void* downcast, thanks Kirit Saelensminde.
2011-07-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/strconv.hxx:
 - Removed string conversion template to char[].  Fixes #215.  Thanks oobermick.
 src/utils.cxx:
 - Fixed #ifdefs around strerror_r workarounds, thanks Kirit Saelensminde.
 tools/Makefile.am:
 - Distribute tools/lint.
2011-07-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Makefile.am:
 - Refer to lint as tools/lint, not ./tools/lint.  Server tests breaking.
2011-07-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/lint:
 - New.  Routine sanity checks on the source tree.
 test/test_main.hxx:
 - Failure summary.
 tools/pre-release-check:
 - New.  Part of release process re-tooling.
2011-07-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/notification.cxx:
 - Fixed workaround for VC++, which can't handle console output in destructors.
 - Thanks Kirit Saelensminde.
2011-07-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/strconv.cxx:
 - Support "inf" as representation of infinity (C++0x standard?).
 test/test000.cxx:
 - Broke because 0.0 isn't always represented as "0"; loosened test.
 test/test_helpers.cxx:
 - Added "less than" assertion.
 test/unit/test_float.cxx:
 - Don't ==-compare FP values; may elicit warnings even for infinity.
2011-07-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/compiler-public.hxx:
 - Check for std::auto_ptr.
 - Check for std::move().
 - Check for std::unique_ptr.
 - Workaround for missing std::move().
 include/pqxx/basic_connection.hxx, include/pqxx/connection_base.hxx,
 src/connection_base.cxx, test/test014.cxx:
 - Replace auto_ptr with unique_ptr for managing noticers, if available.
 - New typedef: noticer_ptr to hide the difference (a little).
 - Provide compatibility with auto_ptr on systems with both.
 - set_noticer now needs reference to smart pointer.
 - Fixes #214.
2011-05-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-internal.hxx:
 - Include <cstddef>; may fix #213 on Fedora 15.  Thanks zelda.
2011-05-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
 - Always exit when "make check" fails.  Missed a spot earlier.
 - Work harder to get a user name.
2011-04-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
 - Support --enable-documentation (defaults to yes).
 tools/pqxx-fulltest:
 - Use --disable-documentation for test runs.
 - Add sbin to path; that's where start-stop-daemon lives.
2011-04-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
 - Quiesce for a bit after stopping backends.
 - Don't wait after create_database; latency covered by build.
2011-04-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
 - Don't break if start-stop-daemon has no work to do.
 - Remove pidfile after stopping a backend.
2011-04-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
 - Complete rewrite.  Faster, cleaner.
2011-04-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
 - Fixed some warnings in clang++ (fatal with -Werror).
2011-04-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
 - Workaround for "noreturn" attribute in clang++ 2.8.
 src/pipeline.cxx:
 - Cosmetic: std-qualify throw spec.
2011-03-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/binarystring.hxx,
 include/pqxx/compiler-public.hxx, include/pqxx/connection_base.hxx,
 include/pqxx/except.hxx, include/pqxx/largeobject.hxx,
 include/pqxx/pipeline.hxx, include/pqxx/result.hxx, include/pqxx/strconv.hxx,
 src/connection_base.cxx, src/except.cxx, test/test_main.hxx:
 - Support for gcc "pure" and "const" attributes.
 - Marked some functions with the "pure" and "const" attributes.
 - A bit more of the "noreturn" attribute.
2011-03-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/compiler-internal.hxx,
 test/unit/test_escape.cxx:
 - Minor changes for gcc 4.6.0.
2011-03-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, include/pqxx/largeobject.hxx,
 include/pqxx/result.hcxx, test/test000.cxx, test/test049.cxx,
 test/test050.cxx, test/test051.cxx, test/test053.cxx, test/test055.cxx,
 test/test061.cxx, test/test062.cxx, test/test082.cxx, test/test084.cxx,
 test/test093.cxx, test/unit/test_prepared_statement.cxx:
 - More clang fixes.
2011-03-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
 - Check for GNU-style strerror_r.
 src/util.cxx:
 - Dump Bart's wonderful strerror_r trick; clang didn't like it.
2011-03-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/result.hxx, src/binarystring.cxx,
 src/connection_base.cxx, src/cursor.cxx, src/largeobject.cxx,
 src/pipeline.cxx, src/result.cxx, src/statement_parameters.cxx,
 src/tablewriter.cxx, src/util.cxx:
 - Fixed clang errors; mostly signedness issues.
2011-02-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_notification.cxx:
 - Eliminated some more use of already-committed nontransaction.
 - Payload should be single-quoted, not double-quoted.
 test/test_helpers.hxx, test/test_main.hxx, test/test025.cxx:
 - New helper drop_table.
 - Fixed test for older backends, which don't have "DROP TABLE IF EXISTS."
2011-02-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx, include/pqxx/result.hxx, include/pqxx/util.hxx:
 - Fixes for problems spotted by clang++.
 tools/preprelease
 - Test against clang as well as gcc.
2011-02-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/basic_connection.hxx, include/pqxx/cursor.hxx:
 - Fixed "don't include this" directions; fixes #211.  Thanks ehoeks.
 include/pqxx/basic_connection:
 - Cosmetic.
2011-02-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml, include/Makefile.am, include/pqxx/connection_base.hxx,
 include/pqxx/internal/gates/connection-notify-listener.hxx,
 include/pqxx/notification, include/pqxx/notification.hxx,
 include/pqxx/notify-listen, include/pqxx/notify-listen.hxx,
 include/pqxx/pqxx, include/pqxx/trigger.hxx, src/connection_base.cxx,
 src/Makefile.am, src/notification.cxx, src/notify-listen.cxx,
 test/unit/test_notification.cxx:
 - Deprecated in favour of new notification_receiver.
 - Takes payload argument (in addition to existing backend_pid).
 include/pqxx/internal/gates/connection-notify-listener.hxx:
 - Renamed to connection-notification_receiver.hxx.
2011-02-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test025.cxx:
 - Use DROP TABLE IF EXISTS, not transactor, to drop/create test table.
2011-01-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/subtransaction.hxx:
 - Corrected documentation.  Thanks Maxime van Noppen.
2010-10-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Quote bytea as '', not E''.  Thanks RhodiumToad.
2010-10-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt, win32/mingw.mak.template, win32/vc-libpqxx.mak.template,
 win32/vc-test.mak.template:
 - Use ws2_32, not wsock32.  Thanks Christian Freund.
 - Don't use /GX and /YX for test build, thanks Christian Freund.
 - Link in shell32.lib, secur32.lib, wldap32.lib, thanks Christian Freund.
2010-10-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
 - Check for PQescapeLiteral (not used yet).
2010-10-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
 - std-qualified use of FILE; fixes #208.
 include/pqxx/transaction_base.hxx, test/test090.cxx,
 test/unit/test_escape.cxx:
 - Removed duplicate test coverage from test090.
 - Don't test exactly what esc() does; meant for use with quote().
 - Full roundtrip tests for quote(): less brittle for quoting changes.
2010-09-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/notify-listen.hxx:
 - Fixed mistaken implication in documentation, thanks Michael Krelin.
 src/connection_base.cxx:
 - Cosmetic.
2010-08-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, src/result.cxx:
 - Include approximate location of error in syntax_error.
2010-08-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
 - Fixed some breakage with 9.0 hex-escaping support detection.
 test/test007.cxx:
 - "Affected rows" also works for SELECT in 9.0.
 test/test090.cxx:
 - Retired binary-escaping tests that don't apply to the hex format.
 test/unit/test_binarystring.cxx:
 - Check that binary-escaped string contains no "high bytes."
2010-08-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
 - Check for PostgreSQL 9.0 hex binary-escaping format.
 src/binarystring.cxx:
 - Refactor unescaping.
 - Work around hex-format support in PQunescapeBytea.
2010-06-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx, src/transaction_base.cxx,
 test/unit/test_binarystring.cxx:
 - Added quote() for binarystring.
 - More testing of escaping/unescaping.
2010-06-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
 - Added missing 10 to hex digits.
2010-06-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
 - Support 9.0-style hex-escaping on ancient libpq.
 test/unit/test_binarystring.cxx:
 - New
2010-06-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/libpq/*:
 - Lots more automatically-stored libpq config headers.
2010-06-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/libpq/7.3/config-internal-libpq.h:
 - Sample header for libpq 7.3.
 test/unit/test_error_verbosity.cxx:
 - Skip test of enum correspondence if libpq doesn't define the enum.
2010-06-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest, tools/preprelease:
 - Save copies of generated config headers.
2010-02-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure, configure.ac, configure.ac.in:
 - Fixed #104: -Werror option always used.  Thanks Ray Dassen.
 - Works around RedHat gcc 4.1 problem.
 include/pqxx/util.hxx:
 - Removed failed attempt at working around RedHat gcc 4.1 problem.
2010-02-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
 - Hopefully fix problem with CentOS gcc 4.1, thanks Devrim Gunduz.
2010-01-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx, src/result.cxx:
 - Added empty()
 - Documented risk of empty slices triggering bugs.
 - Deprecation warning for tuple constructor; it's to become private.
2010-01-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 aclocal.m4:
 - Still struggling to get everything needed for ./configure into the repo.
 autogen.sh:
 - Try automake-1.11.
 include/Makefile.am:
 - Do need to distribute performance.hxx.
 tools/preprelease:
 - Don't run autogen.sh; just take the setup that comes out of svn.
2010-01-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx, src/result.cxx, test/unit/test_result_slicing.cxx:
 - Applied Daniel Frey's slicing implementation for result tuples.
2009-12-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/Makefile.am, include/pqxx/performance.hxx:
 - Added documentation-only header for performance features. 
 include/pqxx/connection_base.hxx, include/pqxx/prepared_statement.hxx,
 include/pqxx/util.hxx:
 - Improvements to reference documentation.
2009-12-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
 - Docs wording.
2009-11-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure:
 - Put configure script under revision control.
 include/pqxx/util.hxx:
 - Bit of documentation work.
2009-10-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/internal/statement_parameters.hxx:
 - Qualified some function calls, thanks Daniel Frey.
2009-10-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test_helpers.hxx, test/test0*.cxx, test/unit/test_*.cxx:
 - Don't pass connection to test functions.  Closes #198.
2009-10-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
 - Check for PQexecParams.
 include/Makefile.am, include/pqxx/connection_base.hxx,
 include/pqxx/internal/gates/connection-parameterized_invocation.hxx,
 include/pqxx/internal/statement_parameters.hxx,
 include/pqxx/prepared_statement.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx, src/Makefile.am, src/prepared_statement.cxx,
 src/transaction_base.cxx, test/unit/test_parameterized.cxx:
 - Support parameterized statements.  Thanks Trigve Siver.
 - Splice parameter marshalling out of prepared::invocation.
2009-10-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TODO:
 - Finally replaced with bug tickets.  Closes #29.
2009-09-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/notify-listen.cxx:
 - Added missing include: compiler-internal.hxx
 - Should fix link errors on Visual C++ from when callgates were introduced.
2009-08-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
 - Use bitset for capabilities array, thanks Kirit Saelensminde.
 - Rearranged member variables by size.
2009-08-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Unnamed statements don't work with libpq 8 on 7.3 backend.
 - Guessing they require protocol 3.
2009-08-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test_helpers.hxx:
 - Create connection/transaction in run(), so only when needed.
 - Should fix test bailouts with 7.3 backends.
 - Makes it easier to catch & report connection failures better in the future.
 test/unit/test_cancel_query.cxx:
 - Pretty much nothing we can test about cancel_query, apart from no segfault.
2009-08-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - libpq versions without PQcancel don't have PGcancel either.
 - Never consider unnamed statement prepared, thanks Trigve Siver.
 test/unit/test_cancel_query.cxx:
 - Added test for cancel_query, thanks Don Madden.
 test/unit/test_prepared_statement.cxx:
 - Test less volatile unnamed prepared statement, thanks RhodiumToad.
2009-08-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
 - Made cancel_query public, thanks Don Madden.
 - Hid support for pre-PQcancel libpq versions a bit deeper.
 - Try harder to be graceful about canceling deactivated connections.
2009-08-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Mark statement definition as complete when varargs are added.
2009-08-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
 - Tiny warning fix for 7.3 libpq versions.
2009-08-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/robusttransaction.hxx, src/robusttransaction.cxx:
 - Redid robusttransaction logic; may actually work now.
 src/connection_base.cxx:
 - Use string::empty.
 test/test018.cxx, test/test037.cxx:
 - Better transactor names.
 tools/preprelease:
 - Keep absolute tarball path out of md5sum file.
2009-08-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/internal/callgate.hxx:
 - Cleaned up constness, thanks Kirit Saelensminde.
2009-07-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/robusttransaction.hxx, src/connection_base.cxx,
 src/robusttransaction.cxx:
 - Redid robusttransaction.  Was completely broken.
2009-07-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/transaction_base.cxx:
 - Throw in_doubt again when trying to commit again while doubt.
2009-07-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx,
 include/pqxx/internal/gates/icursorstream_icursor_iterator.hxx,
 include/pqxx/internal/gates/icursor_iterator-icursorstream.hxx,
 src/cursor.cxx:
 - More call gates.
2009-07-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx,
 include/pqxx/internal/gates/connection-reactivation_avoidance_exemption.hxx,
 src/connection_base.cxx:
 - Set up another call gate.
2009-07-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/Makefile.am, include/pqxx/internal/callgate.hxx,
 include/pqxx/internal/*, src/*.cxx:
 - Moved "gate" headers into include/pqxx/internal/gates.
 - Replaced gate-class name suffix with namespace.
 - Extracted common base class for call gates.
2009-07-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx,
 test/unit/test_prepared_statement:
 - Unnamed prepared statements require PQprepare().
 - Bugfix: unnamed prepared statement kept using its first definition.
 include/pqxx/result.hxx:
 - Fix up PQAlloc deletion handling if shared_ptr not available.
 src/connection_base.cxx:
 - Conditionally-compiled code wasn't using the proper gate.
2009-07-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
 - Substitute full version information.
 doc/Doxyfile.in, src/util.cxx:
 - Make Doxygen see through some cpp macros and such that get in the way.
 - Removed obsolete Doxygen directive DETAILS_AT_TOP.
 src/transaction_base.cxx:
 - gcc 3.3 stumbles over foo_gate(bar).splat()
2009-07-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
 - Get ABI version as well as library version.
 - Single "substitute" function for configure.ac and version header.
 doc/Doxyfile.in:
 - Don't generate huge HTML versions of source, thanks Eugene V. Lyubimkin.
 include/pqxx/result.hxx, include/pqxx/util.hxx src/connection_base.cxx,
 src/util.cxx:
 - Clean up deleter handling in PQAlloc, thanks Kirit Saelensminde.
 - Should fix a case of mismatched allocation/deallocation.
 include/pqxx/version.hxx.template:
 - Include ABI version.
 src/Makefile.am:
 - Version according to ABI version, not full library version.
 tools/extract_version:
 - New --abi option to extract library ABI version.
 - New --help option.
2009-07-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx:
 - Fixed compile warnings on some 32-bit configurations.
2009-06-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
 - Fixed mistake in tutorial example.  Thanks Patrick Daryll Glandien.
 - Closes #187.
2009-06-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease:
 - Don't build tarball again.
 - Deal with changed "make check" output.
 - Clean up and rebuild reference documentation.
2009-06-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx,
 include/pqxx/internal/connection-dbtransaction-gate.hxx,
 include/pqxx/internal/connection-largeobject-gate.hxx, 
 include/pqxx/internal/connection-notify-listener-gate.hxx, 
 include/pqxx/internal/connection-pipeline-gate.hxx, 
 include/pqxx/internal/connection-prepare-declaration-gate.hxx, 
 include/pqxx/internal/connection-prepare-invocation-gate.hxx, 
 include/pqxx/internal/connection-sql_cursor-gate.hxx, 
 include/pqxx/internal/connection-transaction-gate.hxx, 
 include/pqxx/internal/result-connection-gate.hxx, 
 include/pqxx/internal/result-creation-gate.hxx, 
 include/pqxx/internal/result-sql_cursor-gate.hxx, 
 include/pqxx/internal/transaction-subtransaction-gate.hxx, 
 include/pqxx/internal/transaction-tablereader-gate.hxx, 
 include/pqxx/internal/transaction-tablewriter-gate.hxx, 
 include/pqxx/internal/transaction-transactionfocus-gate.hxx, 
 include/pqxx/largeobject.hxx, include/Makefile.am,
 include/pqxx/notify-listen.hxx, include/pqxx/result.hxx,
 include/pqxx/transaction_base.hxx, src/connection_base.cxx, src/cursor.cxx,
 src/dbtransaction.cxx, src/Makefile.am, src/notify-listen.cxx,
 src/pipeline.cxx, src/prepared_statement.cxx, src/subtransaction.cxx,
 src/tablereader.cxx, src/tablewriter.cxx, src/transaction_base.cxx:
 - New "gates" system to control friendships between library classes.
 - New header directory.
 - Moved tiny bit of notify-listener code into new source file.
 test/test023.cxx:
 - Deprecated Conn() in favour of conn().
2009-06-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
 - New capability for prepared-statement varargs.
 test/unit/test_prepared_statement.cxx:
 - Skip varargs test in environments that don't support the feature.
2009-06-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/compiler-public.hxx:
 - Check for BOOST smart_ptr header, include it if available.
 - Fixed configuration of TR1 namespace choice.
 - Build with BOOST shared_ptr by configuring --with-tr1=boost
 - Thanks Kirit Saelensminde.
2009-06-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx, src/result.cxx:
 - result used wrong deallocation function after result_data became const.
 - Thanks Kirit Saelensminde for figuring this out and fixing it!
2009-05-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_tablestream.cxx:
 - Also demonstrate column lists.  Thanks Robert Backhaus.
2009-05-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
 - Provide iterator as well as const_iterator
 - Fixes bug #184
2009-05-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh, include/Makefile.am, include/pqxx/Makefile.am,
 include/pqxx/pqxx, include/pqxx/version, include/pqxx/version.hxx.template:
 - Provide version info preprocessor macros, thanks jdennis at redhat.
2009-04-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx, test/unit/test_prepared_statement.cxx:
 - Support unnamed prepared statement.
 include/pqxx/strconv.hxx:
 - Specialized string_traits for const string.
 - Made from_string on const break at compile time, thanks Robert Barnett.
 - Empty definition for default string_traits, thanks Daniel Frey.
2009-04-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/dbtransaction.hxx:
  - Made constructor public again, thanks Maurice Gittens.
2009-04-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/prepared_statement.hxx, test/unit/test_prepared_statement.cxx:
  - Documented & tested binary parameters, thanks Michael Akinde.
2009-04-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - When preparing varargs statement in SQL, don't skip parameter list.
2009-04-15  Eugene V. Lyubimkin <jackyf.devel@gmail.com>
 NEWS:
  - Typo fix.
2009-04-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/prepared_statement.hxx,
 include/pqxx/transaction_base.hxx, src/connection_base.cxx,
 src/prepared_statement.cxx, src/transasction_base.cxx,
 test/unit/test_prepared_statement.cxx:
  - Got varargs for prepared statements working.
  - Let you do conn.prepared("foo").exists(), thanks Maurice Gittens.
2009-01-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Use PQXXTR1, not PGSTD::tr1, thanks Eugene V. Lyubimkin
2009-01-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 libpqxx.spec.in:
  - Depend on postgresql-libs and postgresql-devel, thanks Bob Knock
  - Install x86_64 libs in /usr/lib64, thanks Bob Knock
  - Use %configure, not ./configure, thanks Bob Knock
  - Removed some hard-coding of directories, thanks Bob Knock
 win32/vc-test.mak.template:
  - Removed superfluous dot in library name.
  - Got rid of unnecessary quotes, thanks Andrew Maclean.
2009-01-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-test.mak.template:
  - Found better place to have $(INTDIR) created, thanks Andrew Maclean.
  - Factored 4-way "if" structure out into two 2-way ones.
2009-01-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/strconv.hxx:
  - Export throw_null_conversion, thanks Andrew Maclean
 win32/INSTALL.txt:
  - Tiny wording fix
2009-01-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-test.mak.template:
  - Link individual tests' object files into test runner
  - Consistently place all object files and executables in $(INTDIR)
  - Fixed typo in filename "runner.success"
2009-01-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/util.hxx, src/util.cxx,
 test/unit/test_thread_safety_model.cxx:
  - Provide thread-safety information to the program
 tools/Makefile.am, tools/pqxxthreadsafety.cxx:
  - New tool to print thread-safety information
 tools/rmlo.cxx:
  - Use PGSTD, not std
2009-01-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Separate doc page about accessing results
2009-01-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, include/pqxx/result.hxx,
 include/pqxx/util.hxx, src/connection_base.cxx, src/binarystring.cxx,
 src/result.cxx:
  - Made PQAlloc API conform more (almost entirely) to shared_ptr
  - Renamed scoped_array::clear() to reset() to match shared_ptr
  - Hid PQAlloc's derivation from shared_ptr a bit more to narrow interface
2009-01-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/util.hxx:
  - Check for separate TR1 header directory
  - Configure check & option for TR1 namespace
  - Include <tr1/memory> if available, or <memory> otherwise
2009-01-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Yet more introductory documentation
 README-UPGRADE:
  - Added 3.1 section
2009-01-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/basic_connection.hxx, src/binarystring.cxx, src/util.cxx:
  - Added includes that may be needed in some situations
 test/test000.cxx:
  - More consistent spacing
2009-01-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/Makefile.am:
  - Forgot to add new strconv headers
 include/pqxx/pqxx:
  - Ordered alphabetically
  - Updated for completeness (probably no practical difference)
 include/pqxx/strconv.hxx:
  - Provide string_traits<> for non-const "char *"
 include/pqxx/util.hxx:
  - Added extra example to "getting started" page
  - Compile fixes for examples
 src/connection_base.cxx, src/cursor.cxx:
  - Include strconv where (sometimes) needed
2008-12-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/prepared_statement.hxx,
 include/pqxx/result.hxx, include/pqxx/strconv, include/pqxx/strconv.hxx,
 include/pqxx/util.hxx, src/Makefile.am, src/strconv.cxx, src/util.cxx:
  - Broke string conversion out into its own module
2008-12-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - Restructured chapters for more balance
  - Made text less tedious in places
 include/pqxx/connection_base.hxx, src/connection_base.cxx, src/cursor.cxx,
 src/dbtransaction.cxx:
  - Added capability for read-only transactions
  - Added capability for cursor "fetch 0"
 include/pqxx/cursor.hxx, include/pqxx/tablewriter.hxx,
 include/pqxx/transaction_base.hxx:
  - Documented some more parameters to keep doxygen happy.
 include/pqxx/util.hxx:
  - Updated threading documentation
  - Created "getting started" page
  - Linked to threading & getting-started pages from front page
2008-12-27  Eugene V. Lyubimkin <jackyf.devel@gmail.com>
 debian/rules, debian/control:
 - Deal better with config.{sub,guess} files, thanks Roger Leigh.
 - Prepare for future 3.1 release, now Debian package builds correctly.
2008-12-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/dbstransaction.hxx, src/dbtransaction.cxx:
  - Use regular transaction if backend doesn't support read transactions
 src/binarystring.cxx:
  - Workaround for 7.3 libpq without PQunescape() still used m_str
  - Missing include for workaround
  - Use memcpy(), not strcpy() in workaround; there may be nul bytes
  - Fixed int-to-unsigned-char warnings in workaround
 src/util.cxx:
  - Missing include for workaround to missing PQfreemem()
  - Fixed const error in workaround
 tools/pqxx-fulltest:
  - Rearranged "find" options to silence warning.
2008-12-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, include/pqxx/util.hxx, src/binarystring.cxx,
 src/connection_base.cxx:
  - Disallow pointer-to-smart-pointer assignment, thanks Kirit Saelensminde
  - Removed caching of str(); binarystring is now immutable
2008-12-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx:
  - Made binarystring contents const
2008-12-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/result.hxx, include/pqxx/util.hxx,
 src/util.cxx:
  - Check for shared_ptr (still needs work; won't always be in std::tr1)
  - Implement PQAlloc as a shared_ptr if available
  - Turn PQ memory freeing functions into shared_ptr-style deleters
  - Make result's result_data const.
2008-12-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/dbtransaction.hxx, include/pqxx/transaction.hxx,
 src/dbtransaction.cxx, src/transaction.cxx,
 test/unit/test_read_transaction.cxx:
  - Added support for read-only transactions.
 tools/pqxx-fulltest:
  - Tried to augment postgresql.conf in wrong place
  - Build postgres without readline
2008-12-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/Makefile.am:
  - Fixed glitch that broke with Solaris "make," thanks Doug.
 test/test_helpers.hxx:
  - Bounds check failure message now includes value of violated boundary
2008-11-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Write postgres config data after initdb, not after building.
2008-11-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/extract_version, tools/preprelease, tools/release:
  - Automating part of release process
 VERSION
  - Use 2-level versions for x.0; more stability among 3-level versions
2008-10-31  Eugene V. Lyubimkin <jackyf.devel@gmail.com>
 test/unit/Makefile.am.template:
  - Added includes to fill 'make check' missing includes when building in
    non-stardard build directory.
 debian/rules:
  - Updated, deleted some cruft.
  - Corrected to pass '--enable-maintainer-mode' to configure. Now 'make
    check' in 'debian/build' directory creats properly linked 'runner'.
2008-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablewriter.hxx, src/tablewriter.cxx,
 test/unit/test_tablestream.cxx:
  - Turned private WriteRawLine() into public write_raw_line()
  - Now supports tablereader-to-tablewriter copying
 tools/pqxx-fulltest:
  - Starting postmaster again, but was still killing postgres
2008-10-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Went back to invoking postmaster for compatibility with older versions
2008-10-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx:
  - Removed warning; pipeline is stable now
 tools/pqxx-fulltest:
  - Sod testing against the 7.3 backend; too complicated for now
2008-10-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - More tweaks to backend startup
2008-10-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Allow some time for database to be created
  - Run postgres instead of postmaster
2008-10-16  Eugene V. Lyubimkin <jackyf.devel@gmail.com>
 include/pqxx/largeobject.hxx, test/unit/test_prepared_statement.cxx:
  - Fixed last g++ 4.3 warnings on 64-bit platforms.
2008-10-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx:
  - Fixed more g++ 4.3 warnings, thanks Eugene V. Lyubimkin
2008-10-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx, include/pqxx/result.hxx, test/test009.cxx,
 test/test028.cxx:
  - Fixed g++ 4.3 warnings, thanks Eugene V. Lyubimkin
2008-10-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README-UPGRADE:
  - Updated for 3.0.
 src/util.cxx:
  - Preserve slightly more precision in floats, thanks Kirit Saelensminde
 test/test005.cxx:
  - Removed use of "IF EXISTS" in DROP TABLE (older backends don't have it)
 test/test_main.hxx:
  - Test runner no longer considers "unsupported feature" a test failure
 test/unit/test_sql_cursor.cxx:
  - Fixed test failure on old backends that need test workaround
2008-10-11  Eugene V. Lyubimkin <jackyf.devel@gmail.com>
 debian/libpqxx*, debian/rules, debian/compat, debian/control,
 debian/watch:
  - Significantly reworked to make ready for upcoming 3.0.0 release.
 debian/Makefile.am:
  - Corrected to let 'make deb' working.
2008-10-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/prepared_statement.hxx:
  - Made treat_direct the default, thanks maho at pagema net
 test/test062.cxx:
  - Made it easier to diagnose a test failure, maybe even solved it
2008-10-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, config/sample-headers/libpq/8.*/pqxx/config-internal-libpq.h,
 configure.ac.in:
  - Check for PQcancel() (and friends, PQgetCancel() and PQfreeCancel())
 include/pqxx/connection_base.hxx, include/pqxx/pipeline.hxx,
 src/connection_base.cxx, src/pipeline.cxx, test/unit/test_pipeline.cxx:
  - Implemented pipeline::cancel_query()
2008-10-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/largeobject.cxx, src/pipeline.cxx, src/prepared_statement.cxx,
 src/result.cxx, src/util.cxx:
  - Fixed gcc 4.3 warnings (I hope), thanks Eugene V. Lyubimkin
2008-09-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/Makefile.am.template, test/runner.cxx, test/test/helpers.hxx,
 test/test_main.hxx, test/unit/runner.cxx:
  - Moved test runners' main() into a header of its own; not a macro anymore
  - Test runners check for failure
2008-09-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Fixed compile warning on poll(), thanks Eugene V. Lyubimkin
2008-09-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sampledata/*:
  - Moved all sample headers into "pqxx" subdirectories
  - No longer need to copy headers, thanks Kirit Saelensminde
 include/pqxx/util.hxx:
  - Simplified default_null, eliminated warning; thanks Kirit Saelensminde
 src/connection_base.cxx:
  - Suppressed stupid Visual C++ warnings, thanks Kirit Saelensminde
2008-09-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, src/result.cxx:
  - PL/pgSQL exceptions, thanks Michal Jankowsk
2008-08-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, test/test085.cxx,
 test/unit/test_prepared_statement.cxx:
  - Re-branded test085 as a unit test
 include/pqxx/transaction_base.hxx, sr/transaction_base.cxx:
  - New function activate() for explicit bracketing
  - Activate before executing prepared statement, thanks qelo
2008-08-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-public.hxx:
  - Apply PQXX_AUTOLINK to static link as well, thanks Kirit
2008-08-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Export encrypt_password, thanks boto
2008-08-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test_helpers.hxx:
  - Fixed nested template syntax, thanks Bjorn Munch
2008-08-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test000.cxx, test/test001.cxx, test/test002.cxx, test/test004.cxx,
 test/test006.cxx, test/test007.cxx, test/test020.cxx, test/test023.cxx,
 test/test075.cxx, test/test079.cxx, test/test084.cxx, test/test087.cxx,
 test/test089.cxx, test/test092.cxx, test/test094.cxx:
  - Replaced throws with test helpers.
 test/unit/test_sql_cursor.cxx:
  - Fixed test failure that only showed up on older gcc versions
 win32/vc-test.mak.template:
  - First stab at adjusting to new test configuration
2008-08-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/Makefile.am.template, test/runner.cxx, test/test027.cxx,
 test/test028.cxx, test/test029.cxx, test/test039.cxx, test/test_helpers.hxx,
 test/unit/Makefile.am.template, test/unit/runner.cxx:
  - Missed some spots in converting to test framework
  - Run all tests in directory as single program!
  - Test build & run now 20% faster on my laptop
  - Should be easier to build tests with Visual C++'s stupid project files
2008-08-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test072.cxx, test/test073.cxx, test/test074.cxx, test/test075.cxx,
 test/test076.cxx, test/test077.cxx, test/test078.cxx, test/test079.cxx,
 test/test080.cxx, test/test082.cxx, test/test083.cxx, test/test084.cxx,
 test/test085.cxx, test/test086.cxx, test/test087.cxx, test/test088.cxx,
 test/test090.cxx, test/test092.cxx, test/test093.cxx, test/test094.cxx:
  - Converted to test framework
  - All tests done now!
2008-08-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test001.cxx, test/test013.cxx, test/test016.cxx, test/test017.cxx, 
 test/test018.cxx, test/test020.cxx, test/test021.cxx, test/test023.cxx, 
 test/test024.cxx, test/test025.cxx, test/test026.cxx, test/test030.cxx, 
 test/test031.cxx, test/test032.cxx, test/test033.cxx, test/test034.cxx, 
 test/test035.cxx, test/test036.cxx, test/test037.cxx, test/test038.cxx, 
 test/test035.cxx, test/test046.cxx, test/test048.cxx, test/test049.cxx, 
 test/test050.cxx, test/test051.cxx, test/test052.cxx, test/test053.cxx, 
 test/test054.cxx, test/test055.cxx, test/test056.cxx, test/test057.cxx, 
 test/test058.cxx, test/test059.cxx, test/test060.cxx, test/test061.cxx, 
 test/test062.cxx, test/test063.cxx, test/test064.cxx, test/test065.cxx, 
 test/test066.cxx, test/test067.cxx, test/test068.cxx, test/test069.cxx, 
 test/test070.cxx, test/test071.cxx, test/test085.cxx, test/test088.cxx, 
 test/test089.cxx, test/test090.cxx, test/test092.cxx,
 test/test_helpers.hxx, test/unit/test_test_helpers.cxx:
  - Converted lots more tests to test framework
  - Removed all asserts from tests
  - New test helper: boundary check
  - Removed non-encoded "text" output from test062.
2008-08-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test011.cxx, test/test012.cxx, test/test013.cxx, test/test014.cxx, 
 test/test015.cxx, test/test016.cxx, test/test_helpers.hxx:
  - Converted to test framework
  - Replaced assertions with test helpers
  - Testing string conversions for result tuples & iterators
  - Simplified testing string conversion for result
2008-08-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx, src/connection.cxx:
  - Doc/comment update
 include/pqxx/util.hxx:
  - Fixed broken is_null for C-style strings
 test/test000.cxx, test/test001.cxx, test/test002.cxx, test/test004.cxx,
 test/test005.cxx, test/test006.cxx, test/test007.cxx, test/test008.cxx,
 test/test009.cxx, test/test010.cxx, test/test085.cxx, test/test090.cxx,
 test/test092.cxx, test/test_helpers.hxx, test/unit/test_escape.cxx,
 test/unit/test_pipeline.cxx, test/unit/test_simultaneous_transactions.cxx,
 test/unit/test_sql_cursor.cxx, test/unit/test_test_helpers.cxx:
  - New TestCase::run() so normal tests don't need pqxx::test::pqxxtest()
  - Rigged up test setup so it runs with nullconnection
  - Standard main() macro for tests, so later we can do all tests in 1 program
  - Improved PQXX_CHECK_THROWS
  - More thorough testing of test helpers
2008-08-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test000.cxx, test/test002.cxx, test/test004.cxx, test/test007.cxx,
 test/test085.cxx, test/test090.cxx, test/test092.cxx, test/test_helpers.hxx,
 test/unit/test_float.cxx, test/unit/test_pipeline.cxx,
 test/unit/test_sql_cursor.cxx, test/unit/test_stateless_cursor.cxx,
 test/unit/test_test_helpers.cxx:
  - Fixed PQXX_CHECK_THROWS ignoring std::exception-derived exceptions
  - Made PQXX_CHECK_* macros rely more on functions--less preprocessor magic
  - PQXX_CHECK_* macros consistently require semicolon at end of invocation
  - Fixed some signedness warnings in PQXX_CHECK_[NOT_]EQUAL invocations
  - Reused PQXX_CHECK_NOTREACHED to simplify PQXX_CHECK_THROWS
2008-08-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Fixed ordering of library search, thanks Jorgen Austvik
 src/connection.cxx:
  - Fixed memory leak when connection fails, thanks Matthew Fanto
 test/test_helpers.hxx, test085.cxx:
  - Moved string_traits<result> into test helpers for reuse.
 test/test008.cxx, test/test009.cxx:
  - Converted to test framework.
2008-08-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test004.cxx, test/test005.cxx, test/test006.cxx, test/test007.cxx:
  - Converted to test framework.
2008-08-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test002.cxx:
  - Converted to test framework.
2008-07-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test085.cxx, test/test092.cxx:
  - Converted to test framework.
 test/test_helpers.hxx, test/unit/test_test_helpers.cxx:
  - PQXX_CHECK_THROWS() swallowed all std::exception throws!
2008-07-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Don't escape whitespace (which isn't always isprint())
  - Closer match to what libpq's escaping functions seem to do
 test/test_helpers.hxx:
  - New "fail if you got here" macro
  - Check for bad_alloc as a special case
 test/test000.cxx, test/test001.cxx, test/test090.cxx, test/test092.cxx:
  - Use test helpers.  Really helps!
2008-07-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/connection_base.cxx, src/util.cxx:
  - Retired old, unsafe escaping functions.
  - Moved last-ditch escaping workaround into only place it's used.
  - Made escape_param() safe where possible.
  - Moved explanation of SQL injection from util to connection.
2008-07-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/gcc-4.2/config-internal-compiler.h,
 config/sample-headers/compiler/gcc-4.2/config-public-compiler.h,
 config/sample-headers/compiler/VisualC++.NET-2003/config-public-compiler.h:
  - Enable "long long" support.
 config/sample-headers/libpq/8.3/config-internal/libpq.h:
  - Added sample headers for more recent gcc and libpq.
 include/pqxx/compiler-public.h, win32/vc-libpqxx.mak.template:
  - New PQXX_AUTOLINK for Visual C++, thanks Kirit Saelensminde
2008-07-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Removed -Wno-long-double; current gcc doesn't know it--thanks Roger Leigh
 include/pqxx/compiler-internal.hxx:
  - Sun Studio fix: use ptrdiff_t, not iterator_traits, thanks Jorgen Austvik
  - distance() workaround for Sun Studio was completely broken
 src/util.cxx:
  - Hopefully fixed gcc 4.3 warning, thanks Roger Leigh
2008-07-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 test/unit/test_escape.cxx:
  - New quote() function templates, using string_traits
  - New test
 include/pqxx/except.hxx, include/pqxx/util.hxx, src/util.cxx:
  - New exception type conversion_error
  - Added name() and has_null() to string_traits<>
  - Better error messages for null conversions
 test/unit/test_sql_cursor.cxx:
  - Simpler way of running multiple tests from one main()
2008-06-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, include/pqxx/result.hxx, src/connection_base.cxx,
 src/cursor.cxx, src/except.cxx, src/largeobject.cxx, src/result.cxx,
 src/robusttransaction.cxx, src/tablereader.cxx, src/transaction_base.cxx,
 src/util.cxx:
  - Throw pqxx_exception-derived exceptions instead of std ones, thanks yrs90.
2008-06-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablewriter.hxx:
  - Peephole optimization, thanks Daniel Frey.
2008-06-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_simultaneous_transactions.cxx:
  - Added test against being allowed to have two nontransactions open.
2008-06-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-internal.hxx, src/pipeline.cxx, test/test085.cxx:
  - Re-did workaround for missing std::distance() in safer way.
2008-06-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Don't force LC_ALL=C; breaks on Solaris, thanks Bjorn Munch & Geir Green.
2008-06-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Make streaming operator act on basic_ostream, thanks Richard B. Kreckel
  - Should resolve ambiguity error, sorry Carlos Moreno!
2008-06-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx.pipeline.hxx, src/pipeline.cxx:
  - Auto-detach after complete() or flush().
 test/unit/Makefile.am.template:
  - Added new pipeline unit test.
 test/unit/test_pipeline.cxx:
  - Added
  - Test detaching of pipeline after complete() or flush().
2008-06-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/basic_connection, include/pqxx/basic_connection.hxx,
 include/pqxx/binarystring, include/pqxx/binarystring.hxx,
 include/pqxx/connection, include/pqxx/connection.hxx,
 include/pqxx/connection_base, include/pqxx/connection_base.hxx,
 include/pqxx/connectionpolicy, include/pqxx/connectionpolicy.hxx,
 include/pqxx/cursor, include/pqxx/cursor.hxx,
 include/pqq/dbtransaction, include/pqq/dbtransaction.hxx,
 include/pqxx/except, include/pqxx/except.hxx, include/pqxx/isolation,
 include/pqxx/isolation.hxx, include/pqxx/largeobject,
 include/pqxx/largeobject.hxx, include/pqxx/nontransaction,
 include/pqxx/nontransaction.hxx, include/pqxx/notify-listen,
 include/pqxx/notify-listen.hxx, include/pqxx/pipeline,
 include/pqxx/pipeline.hxx, include/pqxx/prepared_statement,
 include/pqxx/prepared_statement.hxx, include/pqxx/result,
 include/pqxx/result.hxx, include/pqxx/robusttransaction,
 include/pqxx/robusttransaction.hxx, include/pqxx/subtransaction,
 include/pqxx/subtransaction.hxx, include/pqxx/tablereader,
 include/pqxx/tablereader.hxx, include/pqxx/tablestream,
 include/pqxx/tablestream.hxx, include/pqxx/tablewriter,
 include/pqxx/tablewriter.hxx, include/pqxx/transaction,
 include/pqxx/transaction.hxx, include/pqxx/transaction_base,
 include/pqxx/transaction_base.hxx, include/pqxx/transaction,
 include/pqxx/transaction.hxx, include/pqxx/transactor,
 include/pqxx/transactor.hxx, include/pqxx/trigger, include/pqxx/trigger.hxx,
 include/pqxx/util, include/pqxx/util.hxx:
  - Moved double-inclusion check from <pqxx/foo> to <pqxx/foo.hxx>.
  - Made header-guard #defines more recognizable.
 include/pqxx/result.h:
  - Removed (was still from 1.0 API).
2008-06-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/basic_connection.hxx:
  - Typo in documentation.
2008-06-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/util.cxx:
  - Clean up from_string null checking (Daniel Frey)
  - Other minor cleanups (Daniel Frey)
  - Broke some overlong lines
2008-06-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, src/pipeline.cxx, test/test085.cxx:
  - Workaround for missing distance() in Sun compiler.
2008-05-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx, src/pipeline.cxx:
  - Fixes for Sun Studio, thanks jgilje.
2008-05-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Fixed bug in replacing GNU-ism in sed.
2008-05-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Removed some GNU-isms.
 configure.ac.in, src/util.cxx, test/test_helpers.hxx,
 test/unit/test_float.cxx:
  - Support floating-point infinity.
  - Added PQXX_CHEC_NOT_EQUAL to test helpers.
  - Fixed mis-spelled macro in is_NaN()
 include/pqxx/compiler-public.hxx:
  - Defined PQXX_PRIVATE for SunPro compiler.
 include/pqxx/util.hxx, src/util.cxx:
  - Moved builtin to_string and from_string specializations into traits class.
2008-05-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/prepared_statement.hxx, include/pqxx/result.hxx,
 include/pqxx/util.hxx:
  - Handle nulls in string conversions using traits, thanks Daniel Frey
 src/util.cxx:
  - Use numeric_limits to get infinity, if possible.  Thanks Andrew.
2008-05-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-public.hxx, include/pqxx/connection_base.hxx,
 include/pqxx/dbtransaction.hxx, include/pqxx/except.hxx,
 include/pqxx/notify-listen.hxx, include/pqxx/robusttransaction.hxx,
 include/pqxx/tablestream.hxx, include/pqxx/transaction_base.hxx:
  - Suppress vtables for abstract classes on Visual C++, thanks Kirit.
2008-05-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction_base.hxx, src/connection_base.cxx, src/pipeline.cxx:
  - Check for errors during PQconsumeInput()
  - Fixed "endless network timeout."  Thanks Dragomir Ivanov!
  - transaction_base::consume_input() now returns success value.
2008-05-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Changed fix for Visual C++ warning (was bad overload).
2008-05-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/connection_base.cxx, src/pipeline.cxx,
 src/prepared_statement.cxx, src/util.cxx:
  - Fixes for Visual C++ 8 warnings (correct ones)--thanks Kirit Saelensminde
2008-04-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Also look for compilers in /usr/local/bin
2008-04-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/binarystring.cxx, src/connection_base.cxx,
 src/cursor.cxx, src/pipeline.cxx, src/tablereader.cxx, src/util.cxx:
  - Fixed warnings in g++ 4.3
2008-04-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/unit/test_stateless_cursor.cxx:
  - Test most likely usage pattern: batched sequential retrieval
2008-04-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Doxyfile.in:
  - Removed some unused options to improve Doxygen version compatibility
 src/robusttransaction.cxx:
  - Log failures while creating log table
2008-04-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Removed fetch_current_row() (it was odd, and hard to guarantee)
 test/unit/test_sql_cursor.cxx:
  - Test cursor existence using FETCH, not MOVE (to make failure more likely)
  - On older backends, test for cursor existence differently
  - Re-create series table when opening new transaction
  - WITH HOLD cursors require backend 7.4 or better
2008-04-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Made init_empty_result() conditional on backend version
 test/test_helpers.hxx, test/unit/test_stateless_cursor.cxx,
 test/unit/test_sql_cursor.cxx:
  - Workaround for pre-8.0 backends, which lack generate_series()
 include/pqxx/transaction.hxx:
  - Cosmetic
2008-04-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Doxyfile.in:
  - Upgraded from Doxygen 1.4.6 to 1.5.5.
2008-04-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, include/pqxx/cursor.h, src/oldcursor.cxx,
 test/src/cachedresult.cxx, test/test040.cxx, test/test041.cxx,
 test/test044.cxx, test/test047.cxx:
  - Deleted
  - Removed cachedresult and old Cursor classes
 include/Makefile.am, src/Makefile.am:
  - Retiring old *.h files and old cursor/cachedresult classes
 include/pqxx/cursor.hxx:
  - Made cursor_base::m_name const
 include/pqxx/nontransaction.h, include/pqxx/robusttransaction.h:
  - Deleted
  - Retired 1.x-style "*.h" headers
2008-04-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Create some directories on demand
  - Run under bash, not /bin/sh (pushd/popd are bash-specific)
  - Default to default postgres FTP server, not mirror.in.th
  - Make SVNURL overridable
2008-04-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh, configure.ac.in, test/Makefile.am.template,
 test/test_helpers.hxx, test/unit/, test/unit/Makefile.am.template,
 test/unit/test_sql_cursor.cxx, test/unit/test_stateless_cursor.cxx,
 test/test_test_helpers.css:
  - New test framework for less verbose tests
  - Proper unit tests
 include/pqxx/cursor.hxx, include/pqxx/result.hxx,
 include/pqxx/transaction_base.hxx, src/cursor.cxx, test/Makefile.am.template,
 test/test050.cxx, test/test084.cxx:
  - Made sql_cursor "internal"
  - New stateless_cursor: better API, fewer bugs, smaller code
  - Made cursor_base entirely stateless
 include/pqxx/connection_base.hxx:
  - Documentation fix
 src/connection_base.cxx:
  - Cosmetic
 src/util.cxx:
  - Infinity support
 test/test003.cxx, test/test019.cxx, test/test022.cxx, test/test038.cxx,
 test/test042.cxx, test/test043.cxx, test/test045.cxx, test081.cxx,
 test/test091.cxx:
  - Removed tests for old cursor classes
2008-02-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx:
  - <limits> fix for gcc 3.4, thanks Richard B. Kreckel
2008-01-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction_base.hxx:
  - Let cursor_base access m_reactivation_avoidance, thanks Richard B. Kreckel
2007-11-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, src/result.cxx:
  - More detailed constraint error classes, thanks Peter Geoghegan
2007-10-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - Made the way result objects work clearer, thanks Carlos Moreno
2007-09-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx, src/transaction_base.cxx, test/test003.cxx, test/test011.cxx,
 test/test022.cxx, test/test030.cxx, test/test092.cxx:
  - Added <cstring> and <cstdlib> includes where missing, thanks Roger Leigh
2007-09-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx, src/connection_base.cxx, src/result.cxx:
  - Added <cstring> include
2007-09-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Made esc() and esc_raw() public
2007-08-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for PQdescribePortal()
2007-08-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test088.cxx:
  - Test error handling in subtransactions, thanks Bert Hubert
2007-08-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
  - Solution to application link problems, thanks Peter Geoghegan
2007-08-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Guess float precision if no numeric_limits, thanks Denis Dzyubenko
 win32/INSTALL.txt:
  - Yet more clarificatin, thanks Peter Geoghegan
2007-08-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Convert float types with full precision, thanks Denis Dzyubenko
 win32/INSTALL.txt:
  - Don't use same libpq for debug and release, thanks Peter Geoghegan
2007-08-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
  - Made the bit about copying config headers a bit clearer.
2007-07-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, src/cursor.cxx, test/test043.cxx:
  - Use difference_type instead of size_type to indicate positions
2007-07-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Documented PGPASSWORD, thanks Andrew Maclean
  - Documented how to set environment variables, thanks Andrew Maclean
 src/tablewriter.cxx:
  - Double-escape binary data, thanks Peter Schuller
 win32/INSTALL.txt:
  - Documented how to create Windows makefiles, thanks Andrew Maclean
2007-07-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/tablewriter.cxx:
  - Fix for escaping binary data in COPY mode, thanks Peter Schuller
2007-07-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/prepared_statement.hxx:
  - Exported prepared_def, thanks Daniel Frey
2007-06-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/trigger.hxx:
  - Fixed wrong doxygen tag
2007-06-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/Makefile.am:
  - Added notify-listen headers
 tools/preprelease:
  - Print errors to stderr
2007-06-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, libpqxx.spec.in, NEWS, README:
  - The thaiopensource.org hostname no longer works; it's now pqxx.org
2007-05-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx:
  - Fixed some raw HTML that was showing up wrong in docs, thanks Trigve Siver
2007-05-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added some warning options for g++ 4.2.0
 doc/libpqxx.xml, include/pqxx/connection_base.hxx, include/pqxx/pqx,
 src/connection_base.cxx, test/test004.cxx, test/test023.cxx,
 test/test078.cxx, test/test079.cxx, test/test087.cxx:
  - Renamed trigger to notify_listener
 include/pqxx/notify-listen, include/pqxx/notify-listen.hxx:
  - New
 include/pqxx/trigger, include/pqxx/trigger.hxx:
  - Marked as obsolete
 VERSION:
  - Proceeding to 3.0.0
2007-05-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx:
  - More explanation, particularly on exceptions.  Thanks Gary Jefferson.
2007-05-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection.cxx:
  - Pass on more error messages in broken_connection exceptions, thanks JuJu
2007-05-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Removed unnecessary retrieval of error message, thanks JuJu
  - Moved code around a bit
2007-05-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler-public.hxx, win32/INSTALL.txt:
  - Define PQXX_PQ_STATIC to link to static libpq in Windows.  Thanks JuJu.
2007-05-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/robusttransaction.cxx:
  - Fixed constraint name clash in multi-user use, thanks anonymous
 test/test092.cxx:
  - Test "one parameter per line" style of invoking prepared statements
2007-04-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/prepared_statement.hxx:
  - m_statement shouldn't be a reference, thanks John Mudd
2007-04-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/result.cxx:
  - Missing include: cstdlib, thanks Martin Michlmayr
2007-03-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablewriter.hxx:
  - A bit more explanation about column lists
2007-02-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Compile fix for libpq without PQserverVersion()
2007-02-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/common-sample, win32/vc-libpqxx.mak.template:
  - Removed quotes to fix problems with spaces, thanks Curran Schiefelbein
  - Thanks Bart Samwel for confirming
2007-02-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
  - Check for PQclientEncoding()
  - Check for PQmblen()
 include/pqxx/connection_base.hxx, include/pqxx/result.hxx,
 src/connection_base.cxx, src/cursor.cxx, src/pipeline.cxx, src/result.cxx,
 src/tablereader.cxx:
  - Keep track of client encoding in connections and results
 src/util.cxx:
  - Oops: strlcpy() is supposed to return something
 include/pqxx/transaction.hxx, include/pqxx/trigger.hxx, src/tablewriter.cxx:
  - Updated copyright notices
2007-02-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, src/util.cxx:
  - Use strlcpy() instead of strncpy() where available
2007-02-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - freemem_result_data() needs PQXX_LIBEXPORT, thanks drankevich@cosmostv.by
 tools/pqxx-fulltest:
  - Use pqxx.org instead of full thaiopensource.org URL
  - Ensure that local postgres instance is private
 win32/vc-libpqxx.mak.template:
  - Replaced obsolete /GZ option with /RTC1, thanks Trigve Siver
2007-02-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/robusttransaction.hxx, include/pqxx/transaction.hxx,
 include/pqxx/trigger.hxx, src/tablereader.cxx, src/tablewriter.cxx:
  - disable_noticer incorrectly qualified as internal::, thanks Trigve Siver
 include/pqxx/compiler-internal-pre.hxx:
  - Suppress warning that strncpy() "may be" unsafe, thanks Trigve Siver
 win32/vc-libpqxx.mak.template:
  - Always create lib directory, thanks Trigve Siver
  - Replace obsolete /GX compiler option with /EHsc, thanks Trigve Siver
2007-01-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, src/except.cxx, test/test000.cxx:
  - New mixin base class pqxx_exception, thanks Marcel Loose
 VERSION:
  - Bumped to 2.6.10
2007-01-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test010.cxx:
  - Work around gcc bug with -fprofile-arcs in string initializer
 tools/pqxx-fulltest:
  - Allow FTPSERVER and FTPDIR to be overridden
  - Keep log of postgres builds--may require packages to be installed
2007-01-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, test/test000.cxx:
  - Test password encryption
 include/pqxx/cursor.hxx, test/test003.cxx:
  - Test cursor_base::close()
  - Made cursor fetch()/move() functions pure-virtual
  - Full test coverage
2007-01-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test085.cxx:
  - Skip if backend version does not support prepared statements
  - Work around syntax error with prepared-statement parameters on 7.3 backend
 test/test091.cxx:
  - "Inert cursor" problem is fixed in backend 7.4, not 7.3.
 tools/maketemporary, tools/pqxx-fulltest, tools/preprelease:
  - Made "export" usage compatible with more shells
  - export TMPDIR
  - Skip documentation builds after the very first build
2007-01-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Added simulate_failure() for testing, thanks Joshua Moore-Oliva
 test/test094.cxx:
  - New
  - Tests transactor in-doubt handling, thanks Joshua Moore-Oliva
 tools/pqxx-fulltest:
  - Set TMPDIR to test directory to keep /tmp clean
 tools/preprelease:
  - Can leave its files in other places than /tmp (set by TMPDIR variable)
2007-01-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Eliminated unnecessary check_result()
  - Exec() cached protocol version across connection resets
  - PQprepare()/PQexecPrepared() only work with protocol 3.0
  - Estimate server version if libpq doesn't have PQserverVersion()
  - Keep (estimated) server version in connection object
 src/result.cxx:
  - If result contains an error but has no PG_DIAG_SQLSTATE, throw sql_error
 test/test056.cxx:
  - Don't always get syntax_error even if we do have PQresultErrorField()
2006-12-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction_base.hxx, src/transaction_base.cxx:
  - Just one version of exec(), taking const string references
  - May fix lifetime-of-temporaries bug (query string was dying early)
2006-12-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Print libpq/backend configurations to test logs
2006-12-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/connection_base.hxx,
 src/connection_base.cxx:
  - Support password encryption, thanks tometzky
2006-12-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/pqxx-fulltest:
  - Check for existence of /proc/cpuinfo before reading it
  - Set CONCURRENCY_LEVEL to 1 if no other value available
2006-12-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/splitconfig:
  - Blank lines before grep warnings (looks better in configure)
  - replaced "grepcode" variable with "GREPCODE"
  - Use "test -n" instead of "! test -z"
2006-12-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx:
  - absolute_cursor is about ready for use
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Added capability cap_table_column
  - Warning about deactivated connections and supports()
  - Re-use server_version() and protocol_version()
  - Activate connection before checking prepared-statements capability
  - Don't use PQexecPrepared() with old backends
 src/cursor.cxx:
  - Activate connection before checking scroll capability
 test/test085.cxx, test/test091.cxx, test/test092.cxx, test/test093.cxx:
  - Skip test if essential backend features missing
 tools/pqxx-fulltest:
  - New
  - Tests across all available combinations of frontends and backends
2006-12-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, src/result.cxx:
  - New exception class: undefined_column
  - New exception class: undefined_function
2006-12-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/result.hxx,
 include/pqxx/util.hxx, src/connection_base.cxx, src/pipeline.cxx,
 src/result.cxx, src/util.cxx:
  - result::swap() didn't swap protocol fields
  - Keep shared result data (apart from PGresult) in new "shared_data" object
  - Early provision for thread synchronization in result
  - Results remember the queries that yielded them
  - result::CheckStatus() no longer takes argument (no longer need 2 versions)
  - Radically changed result class definition
 test/test070.cxx:
  - Test new result::query()
2006-12-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/except.hxx:
  - Documented SIGPIPE when connection breaks, thanks Leandro Lucarella
  - More grouping in connection documentation
 include/pqxx/connection.hxx:
  - Fleshed out "connections" documentation module
 test/test056.cxx:
  - Expected exception type is sql_error if PQresultErrorField() not available
 test/test091.cxx:
  - Don't test full cursor mobility on backend <= 7.3 (just wouldn't work)
2006-11-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Try for automake 1.9
  - Minor cleanup
 test/test056.cxx, test/test091.cxx:
  - Fail with postgres/libpq 7.3
 tools/preprelease:
  - Suppress a bit of unwanted output
2006-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Add trigger even if connection not open, thanks Markus Schmidleitner
2006-10-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Published some more utility classes from pqxx::internal
 src/util.cxx:
  - Don't allocate 5n+1 bytes for escaping; 2n+1 really is enough
 test/test005.cxx, test/test013.cxx, test/test018.cxx, test/test032.cxx,
 test/test056.cxx, test/test060.cxx, test/test061.cxx, test/test064.cxx,
 test/test070.cxx, test/test072.cxx, test/test073.cxx, test/test083.cxx,
 test/test085.cxx, test/test086.cxx:
  - Suppress expected error output from notice processor
  - Correct typo: "existant" should be "existent"
 test/test089.cxx:
  - Account for different ways of detecting nested-transactions capability
2006-10-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Removed meaningless const in return type, thanks Jo Ellen Brandmeyer
2006-10-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test090.cxx:
  - Test esc_raw() as well as plain esc()
  - Test nul bytes only with esc_raw(), not with esc()
2006-10-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Fixed typo.  How did this ever come through the regression test?
  - Fixed constness problem in esc_raw() for old libpq versions
 src/subtransaction.cxx:
  - If nested transactions not supported, throw feature_not_supported
 test/test093.cxx:
  - Work around missing PQftableCol() in older libpq versions
2006-09-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, configitems, src/util.cxx, include/pqxx/util.hxx,
 test/test000.cxx:
  - Support "long long" and "unsigned long long" types
  - Redid from_string implementations as template
2006-09-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h:
  - Include pqxx/result, not old pqxx/result.h
 test/test083.cxx
  - Fixed problem found by Visual Studio 8, thanks Xiaofeng Zhao
2006-09-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test085.cxx:
  - Fixed problem found by Visual Studio 8, thanks Xiaofeng Zhao
2006-09-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Fixed bug in removing trigger, thanks Xiaofeng Zhao and Bart Samwel
2006-09-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx:
  - Convenience typedef abscursor for most common type of absolute_cursor
 test/test043.cxx:
  - Migrated from old Cursor to new absolute_cursor
 win32/INSTALL.txt
  - Need to run VCVARS32.BAT before building postgres as well as libpqxx
  - Thanks Bart Samwel and Jonathan Blitz
2006-09-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/Makefile.am, include/pqxx/all.h, include/pqxx/connection.h,
 include/pqxx/connection_base.h, include/pqxx/connectionitf.h,
 include/pqxx/dbtransaction.h, include/pqxx/except.h,
 include/pqxx/isolation.h, include/pqxx/largeobject.h,
 include/pqxx/tablereader.h, include/pqxx/tablestream.h,
 include/pqxx/tablewriter.h, include/pqxx/transaction.h,
 include/pqxx/transaction_base.h, include/pqxx/transactionitf.h,
 include/pqxx/transactor.h, include/pqxx/trigger.h:
  - Retired old 1.x-style ".h" headers
 include/pqxx/result.hxx, include/pqxx/tablereader.hxx,
 include/pqxx/tablestream.hxx, include/pqxx/tablewriter.hxx:
  - Retired deprecated 1.x API functions
 include/pqxx/transaction_base.hxx, src/oldcursor.cxx, test/test041.cxx,
 src/cursor.cxx:
  - Forgot to quote cursor name in cursor_base::close()
 test/test043.cxx:
  - Retired deprecated 1.x API functions
 include/pqxx/transactor.hxx, test/test052.cxx, test/test054.cxx,
 test/test057.cxx:
  - Retired deprecated OnCommit() etc. callbacks
 include/pqxx/trigger.hxx:
  - Removed deprecated Name() function
 include/pqxx/util.hxx, src/utils.cxx, tools/rmlo.cxx:
  - Removed 1.x ToString(), FromString(), and Quote() functions
2006-09-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, config/sample-headers/libpq/*/libpq-internal.h:
  - Check for PQftablecol()
 include/pqxx/result.cxx, src/result.cxx, src/connection_base.cxx:
  - Removed private assignment-to-PGresult * operator
  - Results can keep track of backend protocol
 test/test093.cxx:
  - New
  - Test querying of table columns' origins
 TODO:
  - Cleaned up old items
  - Being phased out in favour of online Trac environment
 win32/vc-libpqxx.mak.template:
  - Create $(OUTDIR) if needed, thanks xf10036@hotmail.com
2006-09-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx, test/test085.cxx:
  - New function prepare_now(), thanks theo@crazygreek.co.uk
2006-09-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Removed old pqxx.tk URL
 src/connection_base.cxx:
  - Forgot to check result of PQprepare(), thanks theo@crazygreek.co.uk
2006-08-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, src/cursor.cxx, test/test091.cxx:
  - Got absolute_cursor working, I think
  - Fixed infinite recursions on fetch() and move()
  - Extra two-argument move_to()
  - Test didn't account for "end()" element
 include/pqxx/util.hxx, src/util.cxx:
  - Factored reference-counting out of PQAlloc
 *:
  - Whitespace cleanup: spaces before tab
  - Whitespace cleanup: whitespace before end-of-line
2006-08-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/util.hxx, src/connection_base.cxx, src/prepared_statement.cxx,
 src/transaction_base.cxx, src/util.cxx:
  - Binary args to prepared statements got truncated at 0! Thanks Lumir Vanek
  - New from_string<>() with length argument
 include/pqxx/pqxx:
  - Also include binarystring
 include/pqxx/result.hxx:
  - Use new from_string() for strings
  - No longer include field names in conversion errors
 test/test000.cxx:
  - Test new from_string<>() versions
 test/test091.cxx:
  - Still doesn't work
  - Now throw exception rather than go into infinite recursion
 test/test092.cxx:
  - New
  - Tests nul byte in binary parameter to prepared statement
2006-08-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, test/test001.cxx, test/test090.cxx:
  - Test new functions protocol_version() and server_version()
  - Test adorn_name()
  - Back to full test coverage for connection classes
 include/pqxx/cursor.hxx:
  - Now testing most of absolute_cursor (but not ready for use yet)
 test/test091.cxx:
  - New
  - Tests absolute_cursor
2006-08-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction_base.hxx, test/test062.cxx:
  - Test esc_raw(const unsigned char[], size_t)
  - Back to full test coverage for transaction classes
2006-08-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Makefile.am:
  - More now-unnecessary output filtering removed
2006-08-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Finally resolved Doxygen problems!
  - Corrected prepared-statement execution example
 include/pqxx/except.hxx:
  - too_many_connections is a broken_connection, not an insufficient_resources
  - New undefined_table class (too useful not to have)
 include/pqxx/subtransaction.hxx:
  - Documented class
 src/result.cxx:
  - Recognize undefined_table error
2006-08-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Doxyfile.in:
  - Include libpqxx version number
  - Suppress unneeded output
  - Ignore PQXX_LIBEXPORT and PQXX_PRIVATE
 doc/Makefile.am:
  - No longer need to suppress unnecessary Doxygen output using grep
 include/pqxx/pipeline.hxx, src/connection.cxx, src/connection_base.cxx,
 src/cursor.cxx, src/dbtransaction.cxx, src/except.cxx, src/largeobject.cxx,
 src/pipeline.cxx, src/prepared_statement.cxx, src/result.cxx,
 src/robusttransaction.cxx, src/subtransaction.cxx, src/tablereader.cxx,
 src/tablestream.cxx, src/tablewriter.cxx, src/transaction.cxx,
 src/transaction_base.cxx:
  - Qualified parameter types identically between declarations and definitions
  - Works around Doxygen problem
 include/pqxx/transactor.hxx:
  - connection_base::perform() was documented in two places
2006-08-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/trigger.hxx:
  - Forbid copy construction and copy assignment (thanks Bart Samwel)
2006-08-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, config/sample-headers/libpq/7.4,
 config/sample-headers/libpq/8.0, config/sample-headers/libpq/8.1,
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Allow server version to be queried
  - Allow protocol version to be queried
  - Compatibility fix: check for "std" namespace and gcc 3.4
 include/pqxx/util.hxx:
  - Removed PQXX_LIBEXPORT directive from PQAlloc class template
2006-08-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Allow test for gcc visibility attribute to fail if not GNU C++
2006-08-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, configitems, src/connection_base.hxx:
  - Use GNU/Linux poll() instead of select(), if available
2006-07-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 pqxx-config.in:
  - Is deprecated, and now says so (thanks Roger Leigh)
2006-07-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Test for pkg-config (Roger Leigh)
2006-07-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - Missing parenthesis.  Thanks Koen Stegen.
2006-07-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx, include/pqxx/result.hxx, src/result.cxx:
  - Lots of new, more specific sql_error-derived exception types
  - Thanks Tomek Rydzynski for getting me going with this
2006-07-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease, tools/splitconfig:
  - Use new "maketemporary" script to work around mktemp differences
 tools/maketemporary:
  - New
  - Slightly more portable wrapper for mktemp
2006-06-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/Makefile.am:
  - Needed fixing after template2mak stopped changing directories
2006-06-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for socket library before checking for libpq.  Thanks Jason Sheets!
 win32/INSTALL.txt:
  - Warned MSYS users to update grep & install mktemp, thanks Jason Sheets
  - Rewrote some text to be a little clearer
  - Reduced duplication in description of "common" file
  - Updated description of "common" file to current way of working
2006-06-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt, win32/mingw.mak.template, tools/template2mak.py,
 win32/vc-test.mak.template, win32/vc-libpqxx.mak.template:
  - Make "make" work from main directory, thanks Trigve Siver
2006-06-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - MinGW socket library detection patch by tometzky@batory.org.pl
 tools/preprelease:
  - Fixed md5sum generation (wrote empty file before)
  - Use "--" option on mv, rm, etc.
2006-06-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Moved detection of and workaround for broken grep to tools/splitconfig
 tools/Makefile.am:
  - Added tools/splitconfig
 tools/preprelease:
  - Don't erase reference documentation every time (takes too much time)
 tools/splitconfig:
  - New
  - Encapsulates workaround for broken greps
  - Should now also detect latest bug with "grep -w -F" in some GNU greps
  - Major cleanup of grep failure detection
2006-06-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems:
  - One item said "private" instead of "internal"
 configure.ac.in:
  - Fixed warning in PQprepare() (can't have those in maintainer mode)
 include/pqxx/binarystring.hxx:
  - Documented escape_binary() as deprecated
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx, src/transaction_base.cxx:
  - Implemented bytea equivalents of esc()
 test/test062.cxx:
  - Use new transaction_base::esc_raw() function
2006-06-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/vc-libpqxx.mak.template:
  - Replaced backslashes in paths with slashes
  - Fixes "incomplete makefile" problem
2006-05-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Compile fix  for old libpq versions, thanks Pawel Sikora
2006-05-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Removed -R option (thanks Pawel Sikora and Roger Leigh for explaining)
 doc/libpqxx.xml:
  - Replaced sqlesc() with esc()
 test/test000.cxx:
  - Include <locale> if appropriate
 tools/svnignore:
  - New
  - Updates svn:ignore properties of files/dirs based on .cvsignore files
 tools/preprelease:
  - Clean up old files from reference documentation--saved tons of space!
2006-05-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for new PQescapeStringConn()
  - Check for new PQescapeByteaConn()
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/util.hxx, src/connection_base.cxx, src/transaction_base.cxx,
 src/util.cxx:
  - Use PQescapeStringConn() where available
  - New escaping functions
 test/test000.cxx:
  - Removed now obsolete sqlesc() tests
 test/test090.cxx:
  - New
  - Tests new string-escaping functions
 tools/preprelease:
  - Also test against g++ 4.1
2006-05-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/template2mak.py:
  - Fixed case where input file argument has no path component (Bart Samwel)
 win32/vc-test.mak.template:
  - Fixed usage of LIBPATH variables (Bart Samwel)
2006-05-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Test for gcc's "deprecated" attribute
  - Don't try to enable gcc's mudflap
  - Remove redundant -lpq arguments
 include/pqxx/compiler-public.hxx, include/pqxx/connection_base.hxx,
 include/pqxx/result.hxx, include/pqxx/tablereader.hxx,
 include/pqxx/tablestream.hxx, include/pqxx/tablewriter.hxx,
 include/pqxx/transaction_base.hxx, include/pqxx/trigger.hxx,
 include/pqxx/util.hxx:
  - Apply gcc's "deprecated" attribute to deprecated functions
 src/connection_base.cxx:
  - Quote prepared statement names so they can contain upper-case letters
 test/Makefile.am.template
  - Fixed empty line after escaped newline that automake stumbled over
 test/test0085.cxx:
  - Test upper-case letters in prepared-statement names
2006-05-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh
  - Use templating script to generate test/Makefile.am as well
 tools/template2mak.py:
  - Don't change directories until after output file has been opened
 tools/*.pl:
  - Got rid of all Perl scripts!
2006-05-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Use Bart Samwel's templating script to generate all Windows Makefiles
  - Skip Windows Makefile generation scripts if Python not installed
 config/sample-headers/compiler/VisualC++.NET-2003/config-internal-compiler.h:
  - This compiler has vsnprintf(), thanks Bart Samwel
 doc/Doxyfile.in:
  - Disabled collaboration graphs (not of much use to end-users)
 include/pqxx/compiler-public.hxx:
  - Select appropriate libpq/libpqxx binaries in Visual C++ (Bart Samwel)
 include/pqxx/connection_base.hxx, include/pqxx/libpq-forward.hxx,
 src/connection_base.cxx:
  - Fix for nasty bug in notice processor handling (Bart Samwel)
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Made check_displacement() const (Bart Samwel)
  - Removed unnecessary PQXX_LIBEXPORT directives (Bart Samwel)
  - Workaround for disagreement between Visual C++ and g++, thanks Bart Samwel
 src/largeobject.cxx:
  - Fixed "long" return types; should be pos_type
 test/test000.cxx:
  - Visual C++ workaround: no stringstream << operator (Bart Samwel)
 test/test061.cxx:
  - Fixed "unreferenced local variable" warning (Bart Samwel)
 tools/template2mak.py:
  - New (written by Bart Samwel)
  - Generates Visual C++ makefiles from templates
  - Replaces the maketestvcmak.pl and makevcmake.pl scripts
  - Now also replaces makemingwmak.pl
  - Now sorts files in loops
  - Now checks for superfluous arguments
  - Fixed bug in two-argument format (opend output for reading only)
  - Moved "don't edit this file" from templates to script
 win32/common-sample:
  - Generalized for use by MinGW and Visual C++ makefiles
  - Warning about slashes and backslashes, thanks Bart Samwel
 win32/mingw.mak.template:
  - New
  - Major cleanup of MinGW makefile (does it even work?)
  - Now also includes "common"
 win32/vc-libpqxx.mak.template, win32/vc-test.mak.template
  - New (written by Bart Samwel)
  - Slightly improved naming scheme (easier with Subversion than with CVS)
 win32/INSTALL.txt:
  - Updated for new, truly shared "common" file
2006-05-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - Fixed bugs that caused validation to fail
2006-05-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - Updated copyright string
  - Added middle initial to my name
  - Only one transaction (per connection) at a time
2006-04-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - No big performance gain with nontransaction (thanks Markus Schaber)
  - Use nontransaction for metadata modifications
 include/pqxx/connection_base.hxx:
  - Documented fact that PQhost() returns NULL if no host *specified*
2006-04-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - nontransaction is only faster when read-only, thanks Markus Schaber
2006-04-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Remove unsafe loop optimizations with g++ 4.1; breaks standard library
 src/util.cxx:
  - Fixed conversion of non-negatable signed numbers (breaks with g++ 4.1)
 test/test000.cxx:
  - List tests as they proceed, to facilitate debugging
  - Use stringstreams as example for LONG_MIN/LONG_MAX strings
 test/test004.cxx, test/test006.cxx, test/test007.cxx, test/test013.cxx,
 test/test015.cxx, test/test017.cxx, test/test018.cxx, test/test023.cxx,
 test/test025.cxx, test/test026.cxx, test/test032.cxx, test/test034.cxx,
 test/test036.cxx, test/test037.cxx, test/test048.cxx, test/test050.cxx,
 test/test051.cxx, test/test052.cxx, test/test054.cxx, test/test057.cxx,
 test/test059.cxx, test/test065.cxx, test/test078.cxx, test/test079.cxx,
 test/test087.cxx:
  - Converted OnCommit()/OnAbort()/OnDoubt() to 2.x-style equivalents
2006-03-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Fixed workaround code for missing PQexecPrepared()
2006-03-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx:
  - Fixed conversion warning, thanks Bart "what, AGAIN?" Samwel
2006-03-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Replaced AC_TRY_LINK loop for socket library with AC_SEARCH_LIBS
  - Should fix MinGW socket problems, thanks Bart "doesn't ring a bell" Samwel
2006-03-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Compile fix for change in subtransaction (Bart Samwel)
 include/pqxx/pipeline.hxx:
  - Previous Visual C++ fix broke compilers without "limits" header
 include/pqxx/prepared_statement.hxx:
  - Help older compilers disambiguate invocation operator() templates
 tools/maketestvcmak.pl, win32/common:
  - More little fixes by Bart "who was that again?" Samwel
 tools/preprelease:
  - Fix md5sum generation
 win32/common, win32/common-sample, win32/INSTALL.txt:
  - Updated with help from Alexandre Hanft
  - No longer edit win32/common; copy from common-sample first (Bart Samwel)
2006-03-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/*:
  - Disable pointless Visual C++ warnings in headers (Bart Samwel)
 include/pqxx/compiler-internal-post.hxx,
 include/pqxx/compiler-internal-pre.hxx:
  - New
  - Wrap libpqxx headers in temporary warning suppression on Visual C++
  - Designed by Bart Samwel
 include/pqxx/prepared_statement.hxx, src/prepared_statement.cxx:
  - Fixed bug that was hidden with some string implementations (Bart Samwel)
 include/pqxx/util.hxx:
  - Work around yet another pointless Visual C++ warning (Bart Samwel)
 tools/maketestvcmak.pl:
  - Removed obsolete linker function /pdbtype (Bart Samwel)
  - Make ALL the default target (Bart Samwel)
 tools/makevcmak.pl:
  - Copy libpq libraries into our own directories (Bart Samwel)
 tools/preprelease:
  - Check for matching compiler-internal-pre/post.hxx headers
 win32/common:
  - Single definition for use in all relevant paths (Bart Samwel)
2006-03-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/libpq/8.1/config-internal-libpq.h
  - New
  - Adds PQserverVersion()--thanks Bart Samwel
  - Adds PQprepare()
 include/pqxx/compiler-public.hxx:
  - Use debug build of libpq when building debug libpqxx, (Bart Samwel)
 include/pqxx/basic_connection.hxx, include/pqxx/connection_base.hxx,
 include/pqxx/connectionpolicy.hxx, src/connection_base.cxx,
 src/connection.cxx:
  - Moved workaround for MSVC++ "output in destructor" bug to leaf destructor
  - Fixed late activation in "direct" connections (thanks Bart Samwel)
  - Explicitly zero-initialize capabilities (thanks Bart Samwel)
  - Allow friends to set capabilities explicity (handy if proven present)
 include/pqxx/compiler-internal.hxx, include/pqxx/compiler-public.hxx:
  - Moved Visual C++ "silence stupid warning" pragmas to "internal" header
  - Silence Visual C++ warning 4800 from here
  - No longer require config-internal-autotools header
 include/pqxx/subtransaction.hxx, src/subtransaction.cxx:
  - More intelligent check for nested-transactions support on the backend
 src/except.cxx:
  - Forgot to include compiler-internal.hxx
 test/test074.cxx:
  - More work on silencing pointless Visual C++ warning, thanks Bart Samwel
 tools/maketestvcmak.pl, tools/makevcmake.pl:
  - Made compatible with Windows, thanks Bart Samwel
  - Missing compiler options from Bart's previous patch
  - Deal with release/debug mode incompatibility, (Bart Samwel)
  - Run tests after building them (Bart Samwel)
  - Don't silence libpqxx warnings from makefile
 tools/preprelease:
  - Compute MD5 checksum of release tarball
 win32/common, win32/INSTALL.txt:
  - Add debug-library path, not just release-library path (Bart Samwel)
2006-03-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx:
  - Missing include: limits.  Thanks Bart Samwel.
 include/pqxx/tablereader.hxx, include/pqxx/tablewriter.hxx:
  - Work around Visual C++.NET 2003 bugs, thanks Bart "Handyman" Samwel!
 include/pqxx/util.hxx:
  - Forgot to export pqxx::internal::freepqmem (Bart "you-know-who" Samwel)
 test/test040.cxx, test/test041.cxx, test/test044.cxx:
  - Emit warnings about warnings about obsolete headers (still Bart Samwel)
 test/test060.cxx, test/test064.cxx, test/test089.cxx:
  - Unused but named exception references (Bart "him again" Samwel)
 test/test074.cxx:
  - Silenced silly Visual C++ 2003 warning (Bart "yes yes we know" Samwel)
 test/test083.cxx:
  - Worked around Visual C++'s silly warnings about "for scope"
 test/test087.cxx:
  - Prevent Visual C++ sabotage of min()/max() (Bart "you done yet?" Samwel)
 tools/maketestvcmak.pl, tools/makevcmake.pl:
  - Enable RTTI
  - Generate correct range of available test programs in comments
  - Use "del" instead of "erase"
  - Typo in comments
  - Suppress less Make output
  - Use REM for comments, not #
  - A big thanks to Bart ("apparently not") Samwel!
 win32/INSTALL.txt:
  - Cleared up procedure for config headers a bit (yes, Bart Samwel again)
2006-02-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Use -lws2_32 on Windows (not -lws32_2), thanks Allysson Costa
2006-02-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - LDFLAGS broke in move to AC_LINK_IFELSE, thanks ltramuset@club-internet.fr
2006-02-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Fixed broken std namespace check
  - Fixed broken --with-std option
  - Make std namespace check check most-preferred namespaces first
  - Made output for std namespace check a little clearer
  - Finally fixed some messy output lines in configure script
  - Check for extra socket libraries that may need to be linked in
  - Finally fixed "NULL fdsets in select()" check
 test/test087.cxx:
  - Fixed includes for Cygwin, thanks Bert Hinrichs
2006-02-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Always include winsock2.h/unistd.h if available, thanks Bert Hinrichs
2006-02-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
  - Retired some old TODO items
2006-01-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Doxyfile.in:
  - Enable treeview sidebar
2006-01-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for stlport _STL namespace
  - Option for enabling/disabling "long long" support
2006-01-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease:
  - No longer test against g++ 2.95
 include/pqxx/util.hxx:
  - Minor change to PQAlloc, in preparation for threading/locking support
2006-01-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
  - Check for PQprepare()
 doc/libpqxx.xml:
  - Added encoding specification
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx, src/transaction_base.cxx, test/test085.cxx:
  - Redid prepared statements API and implementation
  - Incompatible change!
 include/pqxx/prepared_statement, include/pqxx/prepared_statement.hxx,
 src/prepared_statement.cxx:
  - New
  - Part of new prepared-statements system
 test/test002.cxx:
  - Verify that default connection class reports errors immediately
2006-01-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Doxyfile.in:
  - Updated to Doxygen 1.4.6
  - Show directory structure
  - Predefined PGSTD to std for Doxygen's purposes; enabled STL support
 include/pqxx/binarystring.hxx:
  - Explicitly relate binarystring class to escape_binary() functions
 tools/preprelease:
  - Check for missing reference documentation or tutorial
2005-12-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/basic_connection, include/pqxx/basic_connection.hxx,
 include/pqxx/connectionpolicy, include/pqxx/connectionpolicy.hxx:
  - New
 include/pqxx/compiler.h, include/pqxx/libcompiler.h:
  - Renamed to compiler-internal.hxx and compiler-public.hxx, repsectively
 include/pqxx/connection.hxx, include/pqxx/connection_base.hxx,
 src/connection.cxx, src/connection_base.cxx:
  - Refactored connection hierarchy
2005-12-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 *:
  - Migrated from CVS to Subversion
 config/Makefile.am, debian/rules, doc/Makefile.am:
  - Remove .svn directories (as well as CVS ones) from distribution tarball
 src/util.cxx:
  - Fixed typo: called strnlen() instead of pqxx_strnlen()
 tools/preprelease:
  - Use rm's -f option when removing .svn directories
2005-12-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/util.cxx, test/test000.cxx:
  - Nul characters are not allowed inside PostgreSQL strings
2005-12-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
  - Check for strnlen()
 src/util.cxx:
  - Fixed serious sqlesc() encoding bug, thanks tometzky@batory.org.pl!
 test/test000.cxx:
  - Fixed nul character escape tests
2005-12-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - New --with-std= option
 include/Makefile.am, include/pqxx/Makefile.am:
  - Fixed incorrect header installation directory, thanks cbou@mail.ru
2005-11-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added some gcc 4.x options to maintainer mode
 src/binarystring.cxx:
  - Fixed Effective C++ warning
 src/pipeline.cxx, src/robusttransaction.cxx:
  - Removed unused-variable warnings in catch clauses
2005-11-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/*.hxx, src/*.cxx:
  - Made namedclass a virtual base of transactionfocus & transaction_base
  - Child classes no longer pass their names to base classes
  - Switched arguments to namedclass constructor around
  - Made object name optional
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Fixed bug: SetupState() was not always called!
  - More connection capabilities detected
  - Option not to register with transaction (used for subtransaction)
  - New class for connection reactivation avoidance "exemptions"
  - Function to adorn names with unique numbers
 include/pqxx/cursor.hxx, include/pqxx/transaction_base.hxx, src/cursor.cxx,
 src/oldcursor.cxx:
  - Spliced out unique cursor numbering, moved to connection_base
 include/pqxx/dbtransaction.hxx, src/dbtransaction.cxx:
  - Sensible defaults for overridable virtual functions
 include/pqxx/pqxx:
  - Added subtransaction.hxx
 include/pqxx/subtransaction, include/pqxx/subtransaction.hxx,
 src/subtransaction.cxx, test/test088.cxx, test/test089.cxx:
  - New
  - Nested transactions for PostgreSQL 8.x
 test/test001.cxx:
  - Catch sql_error
2005-11-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx, src/connection.cxx:
  - Fixed gcc 4.0 shared library link problem, thanks Axel Waggershauser
2005-11-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Strip trailing semicolons off query, thanks Rupert Kittinger
2005-10-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, src/util.cxx:
  - Greatly simplified strerror_r recognition.  Thanks Bart Samwel!
  - No longer need configuration items for different strerror_r versions
  - Missing include: cstring
2005-10-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - More work on strerror_r guessing logic
 src/util.cxx:
  - Zero-terminate error strings that overflow buffer
2005-10-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
  - Removed thread-safety configure option
  - Removed --disable-shared from sample configuration options
  - Documented PQXX_SHARED
2005-10-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Include <cmath>.  Thanks rdieter.
2005-09-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, src/largeobject.cxx:
  - Stop using libpq/libpq-fs.h, thanks DGCh-Geschaeftsstelle@t-online.de
 test/test062.cxx:
  - More extensive logging of discrepancies
  - strncmp() was wrong (locale-sensitive), thanks jmc@astro.caltech.edu
 win32/common:
  - Clearer explanations
  - Only need two libpq headers
2005-09-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - One more tweak on the auto_ptr problem
 include/pqxx/cursor.hxx:
  - Fixed Doxygen warning
 include/pqxx/largeobject.hxx, test/test050.cxx:
  - Test tell() and ctell()
 include/pqxx/util.hxx:
  - Arg 2 in ambiguous from_string()s was const, thanks Matthias Fischaleck
2005-09-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Removed thread-safety option.
2005-09-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/largeobject.hxx,
 src/largeobject.cxx:
  - Added ctell() and tell() functions
2005-09-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
  - Added missing -c to sample compiler command line, thanks Johnson Zhao
2005-09-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx:
  - Documented thread safety constraints
 include/pqxx/cursor.hxx, include/pqxx/transaction_base.hxx, src/cursor.cxx,
 src/transaction_base.cxx:
  - Removed unnecessary "mutable" in icursor_iterator
  - Made variable cache non-mutable
  - transaction_base::get_variable() is no longer const
2005-09-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/connection_base.hxx:
  - Hopefull fixed auto_ptr issue, thanks Maximiliano Pin.
2005-09-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Removed spurious "return," thanks Maximiliano Pin
  - RogueWave's auto_ptr doesn't copy-construct from const (Max again)
2005-09-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Added <cassert>, thanks a.maclean@cas.edu.au
2005-09-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Replaced some assertions with exceptions
2005-08-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.xml:
  - Wrong variable name in example.  Thanks Marc Herbert.
  - Mentioned outdated OnCommit() etc. names--thanks Lolke Dijkstra
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Made capabilities check immediate (was deferred) for thread safety
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - New move/fetch functions correct for weird row accounting
 include/pqxx/result.hxx, src/result.cxx:
  - reverse_iterators now "point at" same element as embedded iterator
  - reverse_iterators' base() now use temporaries, which is safe
  - reverse_iterators' mutable m_tmp member no longer needed
  - reverse_iterators' dereference operators now inherited unchanged
  - Improved thread safety on reverse_iterators
  - Simplified difference computation on reverse_iterators
 test/test042.cxx:
  - Use displacements returned by new cursor fetch/move functions
2005-08-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, include/pqxx/cursor.hxx,
 include/pqxx/util.hxx:
  - Documentation on thread safety
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Moved all fd_set-related things from class to implementation
  - Improved thread safety
 Makefile.am
  - Removed include/pqxx from include path
 src/Makefile.am, tools/maketestam.pl:
  - Removed unnecessary and incorrect include paths
 test/test087.cxx
  - Fixed compile problem with older gcc
2005-08-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx, include/pqxx/cursor.hxx:
  - Full test coverage
 src/except.cxx:
  - New
  - Here to reduce inline code and library relocations
  - New exception class internal_error for libpqxx bugs
 src/connection_base.cxx, src/cursor.cxx, src/oldcursor.cxx, src/pipeline.cxx,
 src/result.cxx, src/robusttransaction.cxx, src/tablereader.cxx,
 src/transaction_base.cxx, src/util.cxx:
  - Replaced logic_error throws with internal_errors
 test/test038.cxx, test/test042.cxx, test/test045.cxx:
  - Converted to new cursor interface
 test/test087.cxx:
  - New
  - Tests waiting on bare connection socket
2005-08-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/compiler.h, include/pqxx/libcompiler.h,
 tools/makemingwak.pl, tools/makevcmake.pl:
  - New preprocessor macro PQXX_SHARED replaces old DLL guessing logic
  - Updated fd_set using extern "C" workaround
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - New capability: cap_cursor_scroll
  - New capability: cap_cursor_with_hold
  - New capability: cap_cursor_update
  - Documentation: WITH HOLD cursors are not self-restoring, like temp tables
  - Avoid connection {d,r}eactivation while unscoped cursors are active
  - Clear reactivation inhibition while closing connection
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Templatized cursor_base on access/update policies
  - Moved basic cursor operations up even further, to cursor_base
  - Support FOR {UPDATE|READ ONLY} (but no update function yet)
  - Support [NO] SCROLL
  - User-definable cursor destruction policy
  - Implemented cursors in nontransactions using WITH HOLD
  - Convenience typedef "cursor"
  - Avoid connection {d,r}eactivation while unscoped cursors are active
  - Use PQcmdTuples() for MOVE count if possible
 include/pqxx/Makefile.am:
  - Removed include/pqxx from include path
 include/pqxx/result.hxx:
  - result now has cursor_base, not its child basic_cursor, as its friend
 include/pqxx/transaction_base.hxx, src/robusttransaction.cxx,
 src/transaction.cxx:
  - Keep track of allocated reactivation-inhibiting resources
 test/test003.cxx, test/test019.cxx:
  - Converted to new cursor interface
 tools/maketestvcmak.pl
  - Removed Clinton James' email address--he probably doesn't want email
2005-08-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - If no strerror_r(), assume strerror() is safe (as in HP-UX, Solaris)
  - Use strerror_r() if available, even without --enable-threadsafety
  - Warn for missing strerror_r(), don't fail
  - Work around problem with HP-UX "grep -F"
  - Work around problem with "\<" & "\>" in HP-UX grep
  - Thanks Maximiliano Pin for HP-UX fixes
  - Thanks lundgren@byu.net for noting strerror() on Solaris is threadsafe
2005-08-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Introduced basic_cursor (the cursor class you really want in most cases)
  - Get accurate row counts when moving cursors
  - Removed workarounds for Visual C++ attempts to sabotage min()/max()
 include/pqxx/pipeline.hxx:
  - Removed workarounds for Visual C++ attempts to sabotage min()/max()
 include/pqxx/result.hxx:
  - Made basic_cursor a friend of result
 src/connection_base.cxx:
  - Worked around gcc/GNU libc warning for FD_SET
  - Removed my own comment that was, I recently found, unfair to Tom Lane
 test/test081.cxx:
  - Print number of lines in result set being tested
2005-07-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Makefile.am:
  - Filter out more uninteresting Doxygen output
 include/pqxx/binarystring.hxx, include/pqxx/connection_base.hxx,
 include/pqxx/connection.hxx, include/pqxx/dbtransaction.hxx,
 include/pqxx/except.hxx, include/pqxx/nontransaction.hxx,
 include/pqxx/robusttransaction.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/transaction.hxx, include/pqxx/transactor.hxx,
 include/pqxx/trigger.hxx, include/pqxx/util.hxx:
  - More grouping in Doxygen documentation
  - Used @code/@endcode tags in documentation
  - Documented PGSTD
 src/dbtransaction.cxx:
  - Use PGSTD instead of std
2005-07-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Rewrote libpq CONNECTION_OK workaround
2005-07-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Documentation: await_notification() also processes, thanks Szucs Gabor
2005-07-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Documented get_notifs() better, thanks Szucs Gabor
 src/connection_base.cxx:
  - Better workaround for problem with libpq's connection failure detection
2005-07-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Marked inhibit_reactivation() as tested
  - Restored full test coverage
 test/test086.cxx:
  - New
  - Tests inhibition of connection reactivation
2005-07-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/VisualC++.NET-2003/config-public-compiler.h:
  - Removed PQXX_HAVE_CPP_WARNING, thanks Christian Nettesheim
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Removed s_dummy to fix Visual C++ incompatibility (Christian Nettesheim)
 src/connection_base.cxx:
  - Workaround for a Visual C++ warning (Christian Nettesheim)
 tools/makevcmake.pl, tools/maketestvcmak.pl:
  - More patches by Christian:
  - Disable incremental builds on tests
  - Don't delete debug info
  - Remove unneeded Windows libraries
  - Added wsock32.lib for test programs
2005-07-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Missing parenthesis, thanks hys545@dreamwiz.com
2005-07-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, include/pqxx/cursor.hxx,
 include/pqxx/largeobject.hxx, include/pqxx/result.hxx,
 include/pqxx/transaction_base.hxx, include/pqxx/transactor.hxx:
  - Grouped documentation into semantic sections
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Factored result::CheckStatus()-related code into new check_result()
  - Try to deal with libpq "CONNECTION_OK after connection error" problem
  - Grouped member documentation into semantic sections
  - Implemented inhibition of connection reactivation
 include/pqxx/libcompiler.h:
  - Don't define NOMINMAX if it exists, thanks christian@cnetconsulting.de
 include/pqxx/util.hxx, src/largeobject.cxx, src/util.cxx:
  - Moved strerror_wrapper() from largeobject into util
  - Removed PQXX_LIBEXPORT from some inline function templates
  - Grouped string conversion documentation
 test/test000.cxx:
  - Add warning to compiler.h include, thanks Ron Peterson
 test/test056.cxx:
  - Fixed typo in output
2005-07-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems:
  - New item PQXX_HAVE_PQSERVERVERSION
 configure.ac.in:
  - Check for PQserverVersion()
 include/pqxx/connection_base.hxx:
  - Introduced infrastructure for session capabilities
  - Defined capability for use of "WITH OIDS" on CREATE TABLE
 src/robusttransaction.cxx:
  - Use WITH OIDS for transaction log table, if backend supports it
  - Add UNIQUE constraint on transaction log oid
  - Detect special case of "legacy" oid-less transaction log table
 test/test073.cxx:
  - Fixed typo in output
2005-07-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Support strerror_r() even in standard namespace
  - Clarified that strerror_r() return char * is GNU-specific
2005-07-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Replaced AM_CONFIG_HEADER with AC_CONFIG_HEADER, thanks Patrick Welche
  - Apparently "function" is nonstandard shell syntax (Patrick Welche)
 tools/preprelease:
  - Removed more nonstandard "function" syntax
2005-07-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction_base.hxx, src/test085.cxx:
  - Support null parameters in exec_prepared, thanks Morgan Kita
  - Accept NULL pointers as null args, thanks Joshua Moore-Oliva
2005-07-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 pqxx-config.in:
  - Trust pg_config --libdir for libpq options, thanks crweb@vwords.com
2005-06-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/transaction_base.hxx:
  - Use new utility template scoped_array
 include/util.hxx:
  - New utility class template scoped_array
 src/connection_base.cxx:
  - Check connection state after retrieving result, thanks Szucs Gabor
 src/util.cxx:
  - Use new utility template scoped_array
2005-06-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Set LC_ALL=C
  - Finally worked around Fedora Core 4 grep bug, thanks Graham Hudspith!
 include/pqxx/compiler.h, include/pqxx/connection.hxx,
 include/pqxx/connection_base.hxx, include/pqxx/cursor.hxx,
 include/pqxx/largeobject.hxx, include/pqxx/libcompiler.h,
 include/pqxx/pipeline.hxx, include/pqxx/result.hxx,
 include/pqxx/robusttransaction.hxx, include/pqxx/tablereader.hxx,
 include/pqxx/tablewriter.hxx, include/pqxx/transaction_base.hxx:
  - Give private symbols "hidden" ELF visibility where possible
2005-06-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems:
  - Added PQXX_HAVE_GCC_VISIBILITY for g++ 4.0's ELF visibility attribute
 configure.ac.in:
  - Hide private symbols in shared library with g++ 4.0
  - Reordered grep command line in hopes of fixing FC4 problem
 include/pqxx/compiler.h:
  - Define PQXX_LIBEXPORT to g++-4.0 "default" visibility attribute
2005-06-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Missing from_string() error overloads, thanks l.cobai@applicam.com
2005-06-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Factored testing for compiler option support into a function
  - Use g++ 4.0's -fvisibility-inlines-hidden and -fvisibility=hidden
  - Many more warning options
 include/pqxx/util.hxx:
  - Described how to get around overflow checking in string conversion
  - New functions digit_to_number(), number_to_digit()
 src/binarystring.cxx, src/tablereader.cxx:
  - Introduced use of digit_to_number()
 src/connection_base.cxx, src/cursor.cxx, src/tablewriter.cxx, src/util.cxx:
  - Moved a few more end()s out of loops (according to gprof it may matter)
  - Rewrote some frequently executed code
  - Factored out some decimal-number handling fragments
 src/tablewriter.cxx:
  - Introduced use of number_to_digit()
2005-06-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Updated PGHOST documentation to reflect FHS
 tools/preprelease:
  - Add g++-4.0 to list of default test compilers
  - Skip unavailable compilers
  - If no PGHOST set, look for postgres socket in standard places before test
2005-06-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Use __declspec(dllimport) under any Windows compiler, thanks Ducky Yazy
2005-06-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Makefile.am:
  - "clean" target didn't erase reference-stamp/tutorial-stamp
  - Scratch code to remove any pre-existing "html" file (why was that there?)
  - Create Reference and Tutorial subdirectories if they don't exist
2005-06-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/connection_base.hxx, include/pqxx/pipeline.hxx,
 test/test000.cxx, test/test014.cxx:
  - Work around -Wctor-dtor-privacy bug in Debian's gcc 4.0
2005-06-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - More, much more work on that stupid grep command line; works again
  - Fixed progress message for NAN C macro
 include/pqxx/libcompiler.h:
  - Replaced "!defined(_LIB)" with "defined(_DLL)", thanks gzh
 include/pqxx/util.hxx:
  - Added warning about thread-safety of PQAlloc usage
 tools/makevcmake.pl:
  - Removed _USRDLL definition, thanks gzh
2005-05-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Skip "outer grep" in generating config files if result is empty
  - Should fix endless-loop problem in grep with Fedora Core 4
2005-05-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
  - Bugfix in workaround for missing PQunescapeBytea()
2005-05-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, src/largeobject.cxx:
  - Prepared for optimization in case seek parameters match C-style values
 include/pqxx/largeobject.hxx, include/pqxx/result.hxx:
  - Stream c'tors relied on GNU implementation--thanks German Zhivotnikov!
  - Removed broken checks in lostreams, thanks again German Zhivotnikov
2005-05-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablewriter.hxx, src/tablewriter.cxx:
  - Replaced generate() loop with use of separated_list()
  - Restructured escaping functions
2005-05-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for stlp_std (stlport) namespace, let it override std
 win32/INSTALL.txt:
  - Greatly simplified MSYS build--thanks Michael J. Pedersen!
2005-05-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems:
  - New item PQXX_HAVE_C_NAN for C-language NAN macro
 configure.ac.in:
  - Added some escaping to configuration header generation code
  - Add check for NAN macro
 config/sample-headers/compiler/MinGW-3.4/config-internal-compiler.h,
 config/sample-headers/compiler/gcc-3.4/config-internal-compiler.h,
 config/sample-headers/compiler/gcc-3.3-apple/config-internal-compiler.h:
  - Added PQXX_HAVE_QUIET_NAN
 include/pqxx/isolation.hxx:
  - Removed export directive from enum; confused Doxygen, probably not needed
 include/pqxx/util.hxx:
  - Fixed PQAlloc::freemem() specializations, thanks Rupert Kittinger!
  - Should fix memory leak
  - Documented fact that libpq headers no longer needed to compile clients
 src/connection_base.cxx:
  - Made pqxxNoticeCaller static so maybe it won't get external linkage
 src/util.cxx, test/test000.cxx:
  - Use NAN macro if available
  - No longer use tolower() in NaN string recognition--locale-dependent!
  - Special-case NaN output
2005-05-05  J.H.M. Dassen (Ray) <jdassen@debian.org>
 configure.ac.in:
  - Check for availability of "dot".
 doc/Doxyfile.in:
  - Use HAVE_DOT value determined at configure time.
2005-05-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Result for libpq check was inverted; was masked by code typo!
  - Oid check was also inverted, masked by gcc bug--thanks Kathy
2005-05-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/INSTALL.txt:
  - Cleaned up Windows documentation somewhat
2005-04-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Made inclusion of sys/select.h in tests conditional on config macro
  - Made inclusion of unistd.h in tests conditional on config macro
  - Included <ctime> rather than <time.h> in tests
  - Added <winsock2.h> include to select()-related tests
 config/sample-headers/MinGW-3.4:
  - New, thanks Alankar Karol
  - Like gcc-3.3, but without sleep() and <sys/select.h>
 win32/INSTALL.txt:
  - No longer mentions config-public-libpq.h, thanks Alankar Karol
2005-04-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/Makefile.am:
  - Factored out duplicated conditional re-creation of html directory
  - Tutorial included in distribution archive again
2005-04-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease:
  - New variable: CONFIGDIST_ARGS (for "./configure" prior to "make dist")
  - Use maintainer mode for make dist so docs are built, thanks Steve Butler
2005-04-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Fixed help string for --disable-thread-safety, thanks Patrick Welche
2005-04-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test085:
  - Fixed typo in output.
2005-03-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/VisualC++.NET-2003/config-internal-compiler.h:
  - Added PQXX_HAVE_QUIET_NAN, thanks Marvin Bellamy!
2005-03-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Perform strerror_r() tests in C++, thanks Christopher Barkley
 include/pqxx/result.hxx:
  - Added warning about thread safety of results
  - Added note about lightweight copying of results
 include/pqxx/tablewriter.hxx, src/dbtransaction.cxx, src/util.cxx:
  - Made it a little easier for Doxygen to resolve certain functions
 include/pqxx/transactor.hxx:
  - Always call the new abort/doubt/commit handlers!
2005-03-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Work around displacement overflow in backend, thanks Christopher Barkley
  - Added stridestring() to generate proper SQL string for given offset
2005-03-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Fixed Oid type check, thanks Manuel Fernandez Montecelo.
2005-03-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 src/connection_base.cxx:
  - Moved prepared statements execution from connection to transaction
 include/pqxx/result.hxx:
  - Documented some const_reverse_iterator assignments as tested
  - Full test coverage on result.hxx
 include/pqxx/util.hxx, test/test000.cxx:
  - Test most flexible version of separated_list<>()
  - Full test coverage on util.hxx
 test/test085.cxx:
  - New
  - Tests prepared statements
  - Full test coverage on prepared statements
2005-03-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
  - Fixed wrong bitshift for octal digit: 6, not 9--thanks thomasae@online.no
  - Use octal notation for all chars < 0x20
 test/test062.cxx:
  - Don't just compare unsigned char to char--signedness may differ
 tools/preprelease:
  - Create lib directory if it doesn't exist yet
2005-03-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test062.cxx:
  - Added non-ASCII bytes to test case, thanks thomasae@online.no
2005-03-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Moved NOMINMAX even further towards the top
2005-03-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems:
  - Added PQXX_HAVE_STRERROR_R
  - Added PQXX_STRERROR_R_INT
 configure.ac.in:
  - New option: --enable-thread-safety (enabled by default)
  - Check for strerror_r and its signature
 include/pqxx/largeobject.hxx:
  - Reason() functions take errno (as it was at time of failure) as argument
 src/largeobject.cxx:
  - Replaced calls to strerror() with strerror_r() where possible
  - Fixed possible polluted errno in error strings
  - Throw bad_alloc instead of runtime_error where appropriate
 src/util.cxx:
  - sleep_seconds() no longer uses non-threadsafe strerror()
  - sleep_seconds() for sleep()-less systems no longer fails on EINTR
2005-03-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Try multiple alternatives for "std"
  - Cope with C library in std namespace
  - Added -Wno-div-by-zero to avoid warnings about compile-time NaNs
 include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - At last!  Use spruced-up separated_list to concatenate queries
 include/pqxx/util.hxx:
  - Generalize dereference operator in pqxx::internal::separated_list<>()
 tools/preprelease:
  - Set only CXX to current compiler; leave CC as it is
  - Don't run configure from autogen.sh
2005-03-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/compiler.h,
 src/connection_base.cxx, src/util.cxx:
  - Workarounds for g++ 2.95
  - New config items PQXX_HAVE_NAN and PQXX_HAVE_QUIET_NAN
 test/test000.cxx:
  - Workaround for missing std::numeric_limits<>::quiet_NaN in g++ 2.95
 tools/preprelease
  - Disable maintainer mode again. Can't do NaNs in g++ 2.95 without warnings.
2005-03-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Expanded explanations of the most critical, error-prone checks
  - Added some intermediate steps to libpq checks to help pinpoint any problems
  - Removed redundant help string for --enable-maintainer-mode
  - Check for expected Oid type
  - Check for g++/glibc problem with FD_SET, -Werror, and -Wold-style-cast
 include/pqxx/connection_base.hxx, include/pqxx/connection.hxx,
 include/pqxx/result.hxx, include/pqxx/util.hxx,
 src/connection_base.cxx, src/connection.cxx, src/largeobject.cxx,
 src/pipeline.cxx, src/result.cxx, src/util.cxx:
  - No longer include libpq headers in libpqxx headers
  - Include libpq headers only from a few source files, as needed
  - No longer need pqxx::internal::pq in most source files
 include/pqxx/libpq-forward.hxx:
  - New
  - Forward declarations of all libpq types needed in libpqxx headers
 include/pqxx/result.hxx, src/result.cxx:
  - Made result::empty() nothrow
  - result::affected_rows() checks for null pointer
 README:
  - Removed wordy brag section from introduction
  - Made things a bit more lively
  - Updated error message for missing pg_config
  - More help on things that may go wrong
  - Expanded example
  - Removed shell-specific syntax from "make check" explanation
 src/connection_base.cxx:
  - Erase trigger before doing UNLISTENing it.  Thanks Dragan Milenkovic!
  - Getter functions only activate connection if there's no PGconn yet
 tools/preprelease:
  - Test with multiple compilers (by default: g++-2.95, g++, g++-3.4)
  - Test in maintainer mode by default
  - Test building of shared library by default
2005-02-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease:
  - Respect CONCURRENCY_LEVEL in compiling regression test
2005-02-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Convert NaN string to float type, thanks edmund@greenius.ltd.uk
 test/test000.cxx:
  - Test NaN conversion
2005-02-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Use pipeline for setting up or restoring triggers and variables
  - Renamed Connect() to activate(); they were really the same thing
 src/pipeline.cxx:
  - Added description to dummy string for error reporting, just in case
2005-02-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 *:
  - Removed trailing whitespace
 include/pqxx/connection_base.hxx:
  - Made Sun compiler workaround for perform() the general case
2005-02-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added some braces to variable expansions, just to be sure
2005-02-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, config/sample-headers/libpq/7.4/config-internal-libpq.h,
 config/sample-headers/libpq/8.0/config-public-libpq.h,
 include/pqxx/Makefile.am, include/pqxx/util.hxx, test/test002.cxx:
  - Made PQXX_HAVE_PQFTABLE an internal config item
  - Removed config-public-libpq.h
  - Trying to use unavailable PQftable() now gives link error
2005-02-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test058.cxx:
  - Work around another Visual C++ bug, thanks Christian Nettesheim
2005-02-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Replaced problematic halfconnect() by full activate()
  - Included missing pqxx/libcompiler.h
  - Introduced nonnoticer, disable_noticer
 include/pqxx/connection.hxx, include/pqxx/dbtransaction.hxx,
 include/pqxx/except.hxx, include/pqxx/isolation.hxx,
 include/pqxx/nontransaction.hxx, include/pqxx/result.hxx,
 include/pqxx/robusttransaction.hxx, include/pqxx/tablereader.hxx,
 include/pqxx/tablewriter.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/transaction.hxx, include/pqxx/transactor.hxx,
 include/pqxx/trigger.hxx:
  - Included missing pqxx/libcompiler.h (just in case)
 include/pqxx/libcompiler.h:
  - New Visual C++ workaround macro PQXX_QUIET_DESTRUCTORS
 include/pqxx/robusttransaction.hxx, include/pqxx/transaction.hxx,
 include/pqxx/trigger.hxx, src/connection_base.cxx, src/largeobject.cxx,
 src/pipeline.cxx, src/tablereader.cxx, src/tablewriter.cxx,
 src/transaction_base.cxx:
  - Silence message noticer during destructors in Visual C++
2005-02-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Fixed Debian autobuild, thanks Roger Leigh
 include/pqxx/compiler.h:
  - Moved PQXX_LIBEXPORT definition up a little, just to be sure
 include/pqxx/util.hxx:
  - Added PQXX_LIBEXPORT to non-inline symbols, thanks Christian Nettesheim!
 src/dbtransaction.cxx:
  - Included missing pqxx/compiler.h
2005-02-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/SunStudio-8/config-internal-compiler.h,
 config/sample-headers/compiler/SunStudio-8/config-public-compiler.h:
  - Added, thanks Mark Round
 include/pqxx/transactor.hxx:
  - Fixed incorrect comment, thanks Joshua Moore-Oliva
 src/pipeline.cxx:
  - Worked around last SunC++ problem, thanks Mark Round
  - Removed unneeded header
2005-02-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Fixed typo in automake check
  - Used "which" so $PATH is respected (thanks Pawel Niewiadomski)
 include/pqxx/cachedresult.h, include/pqxx/cursor.h:
  - error_permitted_isolation_level() is no longer a template
  - no longer needs incorrect workarounds for Visual C++ and old Sun compilers
 include/pqxx/compiler.h, include/pqxx/libcompiler.h:
  - Moved Visual C++ NOMINMAX fix to libcompiler.h
  - Retired workarounds for problematic error_permitted_isolation_level()
2005-02-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 pqxx-config.in:
  - Fixed painful typo in help output, thanks Tommi Maekitalo
2005-02-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Fixed broken workaround for SunC++ problem, thanks again Mark Round
 src/pipeline.cxx:
  - Added missing include
  - Should fix that last remaining SunC++ error
2005-02-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler.h:
  - Check if evil min() and max() aren't defined already, thanks Bart Samwel!
 src/pipeline.cxx:
  - More fixes for SunC++
  - One error with SunC++ remains (std::distance() won't work)
2005-01-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cachedresult.cxx, src/cursor.cxx:
  - Fixes for SunC++, thanks Mark Round
2005-01-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/compiler.h:
  - Finally defined NOMINMAX, thanks Trevor Morgan!
  - Should solve large object test failures on Windows
2005-01-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Workaround for BSD grep which doesn't support "-f -"
2005-01-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h:
  - Fixed typo in Sun compiler workaround, thanks Mark Round
2004-12-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Apply PQXX_LIBEXPORT to sleep_seconds(), thanks Chris Piker
2004-12-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test000.cxx:
  - Added min()/max() workaround, thanks Chris Piker
2004-11-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/dbtransaction.hxx, src/dbtransaction.cxx:
  - Added out-of-line destructor so Visual C++ knows where to put vtable
2004-11-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/maketestvcmak.pl:
  - Removed some unneeded (presumably) libraries
2004-11-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, include/pqxx.pipeline.hxx:
  - Made inclusion of <limits> conditional on PQXX_HAVE_LIMITS
  - Fall back on INT_MAX/INT_MIN workaround if no <limits> available
 include/pqxx/result.hxx:
  - Remove assignment, comparison between reverse and regular iterators
  - Fixes problems with g++ 2.95
 src/util.cxx:
  - Include <unistd.h> if available
  - Make uses of locale conditional on PQXX_HAVE_LOCALE
 test/test058.cxx:
  - Removed unused largeobject variable
2004-11-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/VisualC++.NET-2003/config-internal.compiler.h,
 config/sample-headers/libpq/7.4/config-internal-libpq.h,
 config/sample-headers/libpq/7.4/config-public-libpq.h:
  - Fixed PQXX_SELECT_ACCEPTS_NULL
  - Disabled PQXX_HAVE_SLEEP
  - Enabled PQXX_HAVE_PQEXECPREPARED
  - Thanks Patrick Kimber
 include/pqx/connection.hxx:
  - Call PQconnectdb() inside PQXXPQ namespace, thanks Patrick Kimber
 include/pqxx/result.hxx:
  - Workarounds for Visual C++.NET 2003, thanks Patrick Kimber
 win32/common:
  - Enabled STD definition, thanks Patrick Kimber
2004-11-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transactor.hxx:
  - Renamed OnCommit/OnAbort/OnDoubt to on_commit/on_abort/on_doubt
  - Anonymized unused (but significant) OnAbort() parameter to silence warning
 src/transaction_base.cxx:
  - Check for broken connection before going into commit attempt
2004-11-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 - doc/Makefile.am:
  - Filter progress messages out of doxygen output
 - include/pqxx/*.hxx:
  - Retouched Doxygen documentation
  - Removed unneeded includes
 - include/pqxx/dbtransaction.hxx:
  - Removed startcommand() and StartCmd()
  - Un-inlined code
 - include/pqxx/util.hxx, src/pipeline.cxx, src/cursor.cxx:
  - Removed assert code
 - src/dbtransaction.cxx:
  - New
 - src/Makefile.am:
  - Added dbtransaction.cxx
2004-11-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/compiler/*/*, configitems:
  - Add PQXX_HAVE_LONG_DOUBLE
 configure.ac.in:
  - Check for "long double" support (it's a standard type, but...)
  - Add -Wno-long-double in maintainer mode, if available
 include/pqxx/util.hxx, src/util.cxx, test/test046.cxx, test/test074.cxx:
  - Made references to "long double" conditional on compiler support
2004-11-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers/VisualC++.NET-2003/config-internal-compiler.h,
 config/sample-headers/VisualC++.NET-2003/config-internal-compiler.h:
  - New.  Thanks Patrick Kimber!
 include/pqxx/connection.hxx:
  - Added missing "inline" for Windows case.  Thanks Michael J. Pedersen
 README, win32/INSTALL.txt:
  - Documented sample-headers
  - Documented object-file-style linking (as opposed to -lpqxx argument)
2004-11-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for PG_DIAG_STATEMENT_POSITION as well as PQresultErrorField()
  - Add <cstring> include for select() check; needed for OS X w/gcc-3.3
2004-11-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 config/sample-headers:
  - New
  - For distributing sample configuration headers
 configure.ac.in:
  - Replace autoconf's function checks with -Werror-proof code
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Took out a lot of inlining
  - Added </<=/>/>= operators to icursor_iterator
  - Full test coverage
 include/pqxx/Makefile.am:
  - Reinstated compiler.h as a distributed (but not installed) file
  - Reinstated config-internal-autotools.h as distributed (but not installed)
 include/pqxx/result.hxx, src/result.hxx:
  - Took out a lot of inlining
 test/test081.cxx:
  - Test stride()
 test/test084.cxx:
  - Licked icursor_iterator problems (most bugs were in test program :)
  - Test </<=/>/>= operators
 tools/preprelease:
  - Fixed symbols listing; used to cut off function before second argument
2004-11-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/util.cxx:
  - Lots more work on icursor_iterator but still not quite right
 test/test084.cxx:
  - Removed some illegal tricks
2004-10-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Set stringstream in to_string fallback code to C locale
2004-10-31  Roger Leigh <rleigh@debian.org>
 debian/control.in:
  - postgresql-dev depends on pkg-config
 debian/rules:
  - Remove all examples that include internal headers
2004-10-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Warning: icursor_iterator constructors may now throw execptions
  - Made icursorstream keep track of its iterators
  - icursor_iterators no longer read data unless really needed
  - Made icursorstream/icursor_iterator "lazy," skipping over unread data
  - Fixed icursor_iterator equality comparison
  - Allow for generic icursor_iterator comparison, not just for end-of-stream
  - icursor_iterators should no longer get confused when mixing operations
2004-10-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx:
  - Nothrow specs on destructors (Windows only).  Thanks reina_ga@hotmail 
 include/pqxx/result.hxx, test/test075.cxx, test/test082.cxx:
  - Full test coverage
 include/pqxx/cursor.hxx:
  - icursor_iterator::operator+= now thinks in strides, like operator++ etc.
  - Fixed icursor_iterator comparison operators
  - Fixed icursor_iterator freshness bookkeeping
  - Removed m_pos from icursor_iterator
  - Made icursor_iterator constructor taking istream_type explicit
  - Added adopted-cursor feature
  - Documented use with nontransactions and WITH HOLD
  - No longer marked experimental
  - Full test coverage
 src/util.cxx:
  - Missing <windows.h> include, thanks Stephan Schuetz
 test/test000.cxx:
  - Test signedness of cursor_base's prior() and backward_all()
 test/test084.cxx:
  - New
  - Test adopted cursor
  - Test icursor_iterator
 tools/makevcmak.pl:
  - Fixed typo, thanks Stephan Schuetz
2004-10-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
  - Fixed swap(): forgot to call superclass swap()
2004-10-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Use home-grown reverse_iterators
  - Fixes "returning reference-to-temporary" problem in operator*()
 src/result.cxx:
  - Working on field comparison.  Nulls are not trivial!
 test/test082.cxx
  - No longer requires PQXX_HAVE_REVERSE_ITERATOR
  - Verifies reverse_iterator traversal with regular traversal
2004-10-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, src/binarystring.cxx, test/test062.cxx:
  - Full test coverage
  - Comparison operators ==, !=
 include/pqxx/result.hxx, src/result.cxx, test/test002.cxx, test/test007.cxx:
  - Removed tentative <, <=, >, >= operators
  - Full test coverage
  - Use new reference counting from internal::PQAlloc
 include/pqxx/util.hxx:
  - PQAlloc now reference-counted (doubly-linked smart pointers, actually)
  - Specialized free function for PGresult
2004-10-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Fixed "cut" problem.  Again
 include/pqxx/binarystring.hxx, include/pqxx/result.hxx:
  - Gave begin(), end(), size() and capacity() empty throw specifications
  - Defined const_reference
  - Implemented front(), back(), and swap()
2004-10-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/Makefile.am:
  - Don't install compiler.h--thanks Roger Leigh
2004-10-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in, include/pqxx/binarystring.hxx,
 include/pqxx/libcompiler.h:
  - Removed ptrdiff_t check and workaround
  - Replaced use of ptrdiff_t with long
  - Fixes problem with autoconf ptrdiff_t check
  - Compile with -Werror in maintainer mode
 doc/libpqxx.xml:
  - Replaced "transaction<>" introduction with "work"
  - Hinted at field iteration
  - unique is internal now
  - Test programs are numbered from zero now
  - Fixed split infinitives
  - Re-justified some text to 80 columns
 include/pqxx/cachedresult.h, include/pqxx/cursor.h, include/pqxx/cursor.hxx,
 include/pqxx/result.hxx, src/cachedresult.cxx, src/cursor.cxx,
 include/pqxx/tablewriter.hxx:
  - Empty throw specifications for iterator constructors and assignments
 include/pqxx/pqxx:
  - Added "pqxx/cursor"
  - Fixed filename description (still called itself "pqxx/all")
 include/pqxx/result.hxx, include/cachedresult.hxx, include/cursor.h,
 include/cursor.hxx, src/oldcursor.cxx, src/result.cxx:
  - Turned size_type into unsigned types
  - Introduced difference_type where necessary
  - Added int versions of at() and operator[] etc. to avoid ambiguity for 0
  - Empty throw specifications for iterator constructors and assignments
 include/pqxx/util.h:
  - Only warn once about deprecated headers
 src/cachedresult.cxx, src/oldcursor.cxx, test/test003.cxx:
  - Silence warning about deprecated headers
 src/result.cxx:
  - Fixed broken check for PQresultErrorField()
 src/util.cxx:
  - Included <cerrno>
 test/test019.cxx, test022.cxx, test/test038.cxx, test/test040.cxx,
 test/test041.cxx, test/test042.cxx, test/test043.cxx, test/test045.cxx,
 test/test049.cxx:
  - Fixed signed/unsigned comparisons etc. caused by new unsigned size_type
  - Changed size_type to difference_type where needed
  - Some casts around formerly mismatched comparisons now unnecessary
2004-10-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx, test/test082.cxx:
  - Full test coverage for field iterators
  - Lifted iterator classes' num() functions into tuple / field
 include/pqxx/tablewriter.hxx:
  - Full test coverage for tablewriter back_insert_iterator
 include/pqxx/util.hxx, test/test000.cxx:
  - Full test coverage for items<>
 test/test083.cxx:
  - New
  - Tests tablewriter back_insert_iterator
2004-10-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxxx/result.hxx:
  - Replaced private inheritance of field from tuple by membership
  - Yet Another Field Conversion Function: result::field::operator>>
 test/test007.cxx:
  - Test result::field::operator>>
 test/test082.cxx:
  - New
  - Test field iterators
2004-09-28  Roger Leigh  <rleigh@debian.org>
 include/pqxx/Makefile.am:
  - Don't install generated private config-*.h headers.
2004-09-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems, configure.ac.in:
  - Added PQXX_HAVE_SLEEP for POSIX sleep() (internal/compiler)
 include/pqxx/util.hxx, src/util.cxx, test/test004.cxx, test/test023.cxx:
  - New sleep_seconds() to hide POSIX sleep() / Windows Sleep() / select()
 include/pqxx/robusttransaction.hxx, src/robusttransaction.cxx:
  - Add m_backendpid field
  - Wait until old backend dies, or query is finished (thanks Tom Lane)
2004-09-02  Roger Leigh  <rleigh@debian.org>
 configure.ac.in:
  - Put the configitems in an AC_CONFIG_COMMANDS macro, so that they
    are generated by config.status
  - Source configitems from ${srcdir}, so that VPATH builds with
    separate source and build trees work
 tools/Makefile.am:
  - Distribute makemingwmak.pl and makevcmake.pl
 debian:
  - Add chrpath to build dependencies to strip rpath from binaries
  - Depend on at least version 7.4.2-1 of postgresql for binary
    compatibility reasons.
  - Don't package tests which make use of internal headers as
    examples.
2004-08-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Moved "cut" field option before filename, thanks Ralf Engelschall
2004-08-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx, include/pqxx/connection_base.hxx,
 src/connection.cxx, src/connection_base.cxx:
  - Delegated overridables to nonvirtuals to avoid calls from ctors/dtors
  - Inlined lots of trivial or near-trivial functions
  - Made connection_base::Connection() private
  - completeconnect() doesn't need to check for success
  - connection_base::halfconnect() didn't always SetupState()
  - Moved dropconnect() out of close() because it's called from destructor
 include/pqxx/cursor.hxx, test/test081.cxx:
  - Increased test coverage
 include/pqxx/transaction_base.hxx, test/test009.cxx:
  - Test coverage for stringstream version of exec()
 include/pqxx/util.hxx, test/test080.cxx:
  - Warning for items<> interface not being stable yet
  - Increased test coverage for items<>
 src/cursor.cxx:
  - Removed "NO SCROLL," which older backends don't support
2004-08-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Minor updates to appendices
 win32/INSTALL.txt:
  - MinGW documentation.  Thanks Michael J. Pedersen!
2004-08-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Generates MinGW Makefile
 src/connection_base.cxx:
  - activate() also when don't have PQexecPrepared()
 tools/Makefile.am:
  - Removed pqxxbench
 tools/makemingwmak.pl:
  - New
  - Generates win32/MinGW.mak
 tools/pqxxbench.cxx, tools/pqxxbench.in:
  - Deleted
2004-08-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/result.cxx:
  - Workaround for missing PQresultErrorField(), thanks webmaster@tsukaeru.net
2004-08-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configitems:
  - Added PQXX_PQ_IN_NAMESPACE (under "compiler" for now)
 configure.ac.in:
  - Added several warning options
 include/pqxx/connection.hxx, src/connection.cxx:
  - New nullconnection class for testing
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Updated activate()/deactivate() documentation to lower-case API
  - Made Status() throw ()
  - Made ErrMsg() throw ()
  - Qualified libpq functions with PQXXPQ::
 include/pqxx/result.hxx, src/result.cxx:
  - Removed initialize()'s empty throw specification
  - Qualified libpq functions with PQXXPQ::
 include/pqxx/robusttransaction.hxx, include/pqxx/transaction.hxx:
  - Separate single-arg and "named" constructors instead of default arg
 include/pqxx/util.hxx, src/util.cxx:
  - Removed namedclass::description()'s empty throw specification
  - Separate namespace for libpq is optional
 src/connection_base.cxx:
  - Forgot to read result after removing trigger
  - No longer list open triggers when closing connection
  - Extra checks for connection being open
 src/pipeline.cxx:
  - Qualified libpq functions with PQXXPQ::
 test/test000.cxx:
  - Add nullconnection checks
 test/test005.cxx, test/test013.cxx, test/test018.cxx, test/test032.cxx,
 test/test037.cxx, test/test040.cxx, test/test041.cxx, test/test056.cxx,
 test/test070.cxx, test/test072.cxx, test/test073.cxx:
  - Send "expected" messages to cout instead of cerr
2004-08-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh: 
  - Check for PQexecPrepared()
 configitems:
  - Added PQXX_HAVE_PQEXECPREPARED
 src/connection_base.cxx:
  - Workaround for missing PQexecPrepared()
2004-08-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Made automake version checks a loop
  - Check for automake-1.9
2004-08-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Documented Debian package and Arjen Baart's RPM packages
  - Rewrote config stuff, referring to win32/INSTALL.txt
 win32/INSTALL.txt:
  - Took configuration header details out of the step-by-step list for brevity
  - Removed documentation about Visual C++ makefile being out of date
  - Documented new configuration system
2004-08-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Reinstated autoheader
 configitems:
  - New
  - Lists configuration items and where they should go
 configure.ac.in:
  - Generate only include/pqxx/config.h with automake
  - Generate partitioned config headers based on configitems
 include/pqxx/config-internal-autotools.h,
 include/pqxx/config-internal-compiler.h,
 include/pqxx/config-internal-libpq.h, include/pqxx/config-public-compiler.h,
 include/pqxx/config-public-libpq.h, include/pqxx/config.h,
 include/pqxx/config.h.in:
  - New
  - Automatically generated by configure script
  - Partition configuration items by public/private, and determining factor 
 include/pqxx/Makefile.am:
  - Added config.h
  - Added new partitioned config headers
 include/pqxx/compiler.h, include/pqxx/libcompiler.h, include/pqxx/util.hxx,
 test/test049.cxx:
  - Use partitioned config headers
 include/pqxx/internalconfig.h, include/pqxx/libconfig.h:
  - Removed
 Makefile.am:
  - Added configitems to distribution
2004-08-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Removed InvalidOid check
  - Removed <iterator> check
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Moved libpq into pqxx::internal::pq namespace
  - Removed unused status code argument to MakeEmpty()
 include/pqxx/largeobject.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/util.hxx, src/binarystring.cxx, src/largeobject.cxx,
 src/pipeline.cxx, src/result.cxx, src/util.cxx:
  - Moved libpq into pqxx::internal::pq namespace
 include/pqxx/result.hxx:
  - Replaced InvalidOid with oid_none
  - Moved libpq into pqxx::internal::pq namespace
 tools/rmlo.cxx:
  - Replaced Oid with oid
2004-08-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/makevcmake.pl:
  - New
  - Generates win32/libpqxx.mak
 tools/autogen.sh:
  - Call makevcmake.pl
 win32/libpqxx.cxx:
  - Removed unused crud (basically everything) generated by VC++
 win32/libpqxx.mak:
  - Automatically generated
2004-07-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Disabled (inaccurately worded) Visual C++ warning "this" use in result.hxx
 win32/INSTALL.txt:
  - Lots new documentation
  - Changed config.h to internalconfig.h
 win32/libpqxx.mak:
  - Added oldcursor.obj.  Thanks Alexandre Hanft.
2004-07-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx:
  - Corrected icursor_iterator copy comparison (required for input_iterator)
  - Updated documentation
 include/pqxx/tablewriter.hxx:
  - Added copy assignment operator to disambiguate templated version
  - Marked iterator functions not explicitly tested
2004-07-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx, src/connection_base.cxx:
  - Better error reporting for some hard-to-tell cases
2004-07-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/connection.hxx:
  - References to README for connection string documentation
 README:
  - Minor changes to connection string documentation
2004-07-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - Removed debug code inserted while debugging new version
 src/util.cxx:
  - from_string() didn't accept LONG_MIN, thanks Yannick Boivin!
  - Removed assertions
 test/test000.cxx:
  - Added test cases for largest and smallest long values
2004-06-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/nontransaction.cxx, src/robusttransaction.cxx:
  - Removed unsafe query retries
2004-06-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - Made m_issuedrange a pair of iterators
  - Many related changes
2004-06-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/pipeline.cxx:
  - Removed disaster-handling code for exceptions in result constructor
2004-06-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx, src/result.cxx:
  - Changed garbage collection mechanism to double circular linked lists
  - Wrapping a PGresult * in a result object is now exception-free!
  - No more heap allocations when constructing
2004-06-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx:
  - Wrap PQconsumeInput() and PQisBusy()
 include/pqxx/cursor.hxx:
  - Replaced _WIN32 conditionals with more appropriate _MSC_VER
 include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - Excruciating 26-hour complete rewrite!
  - Much better exception safety
  - New pipeline stays registered throughout its lifetime, for now
  - No longer supports is_running()
  - retain() sets maximum number of queries to retain before trying to issue
 test/test071.cxx:
  - New retain() calls
  - No longer looks at is_running()
2004-06-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - Declared from_string() for char an ambiguous conversion (thanks Lee Sam)
2004-06-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added -funit-at-a-time for g++ 3.4
 doc/libpqxx.html:
  - Replaced Exec() with exec()
  - Replaced Perform() with perform()
  - Replaced Commit() with commit()
  - Replaced Quote() with sqlesc()
  - Replaced Cursor with icursorstream
  - Replaced ToString()/FromString() with resp. to_string()/from_string()
  - Removed FmtString()
  - Introduced sql_error
  - Expanded namespace explanation a little
 include/pqxx/connection_base.hxx, include/pqxx/tablewriter.hxx,
 include/pqxx/transaction_base.hxx, src/connection_base.cxx,
 src/tablewriter.cxx, src/transaction_base.cxx:
  - Removed async buffering code from tablewriter, thanks Rico Schiekel
 include/pqxx/cursor.hxx:
  - Documentation
  - Added test tags to function declarations
  - Added += operator to iterator
2004-06-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.hxx, src/cursor.cxx:
  - Rewrote forward-only cursor as a stream
  - Iterator interface for forward-only cursor through an "istream_iterator"
 README:
  - LD_LIBRARY_PATH should be valid on all Unix-like systems
 test/test081.cxx:
  - New
2004-06-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pxx/cursor, include/pqxx/cursor.hxx:
  - New
  - Early work on new iterator/container-style cursor interface
 include/pqxx/cursor.h:
  - Renamed guard macro to PQXX_OLD_CURSOR_H
 include/pqxx/Makefile.am:
  - Added new cursor, cursor.hxx
 src/cursor.cxx:
  - Now contains new-style cursor code
 src/oldcursor.cxx:
  - New
  - Holds obsolete Cursor code
2004-06-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, test/test000.cxx:
  - string conversions for std::stringstream
 test/test005.cxx, test/test006.cxx:
  - Added rows ending in empty-string fields, thanks slava@perlx.com
2004-06-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction_base.hxx:
  - Removed erroneous "throw ()" for EndCopyWrite(), thanks Simon Elbaz
  - Experimental version of exec() taking a stringstream
 src/connection_base.cxx:
  - Trimmed some fat, possible bug out of EndCopyWrite()
 src/result.cxx:
  - Accepts null query string
 src/tablestream.cxx:
  - Made base_close() idempotent, or at least more obviously so
2004-05-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/result.hxx, src/util.cxx:
  - Workarounds for the infamous non-release "gcc 2.96", thanks Arjen Baart
 libpqxx.spec.in:
  - Added --enable-shared (Arjen Baart)
2004-05-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Strip newlines off COPY TO STDOUT lines in old-libpq code
 src/tablereader.cxx:
  - Fix parse error when line ends in empty field.  Thanks slava@perlx.com!
2004-05-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - Made prepended "SELECT 0" query explicit to pave way for partial retrieval
  - Syntax error reporting tries to narrow down problematic query
 include/pqxx/tablestream.hxx:
  - Made columnlist() use new separated_list()
 include/pqxx/util.hxx:
  - New class template items<> to make container initialization easy
  - separated_list() generates comma/semicolon/...-separated lists
 src/transaction_base.cxx:
  - No longer go async in BeginCopyWrite()
 test/test008.cxx, test/test010.cxx:
  - Use separated_list() instead of output loop
 test/test010.cxx, test/test080.cxx:
  - Use items<> instead of hand-filling containers
2004-05-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx, src/result.cxx:
  - Added errorposition()
 README:
  - Added KPoGre to list of libpqxx-based projects
2004-05-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/all.h:
  - Added transactionitf.h, thanks Bart Samwel
  - Which doesn't mean that these files aren't still deprecated, of course...
2004-05-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablewriter.hxx:
  - Complete test coverage
 include/pqxx/util.hxx, src/robusttransaction.cxx, src/util.cxx, test/test018.cxx,
 test/test045.cxx:
  - Added sqlesc() functions
  - Deprecated Quote() functions
 src/connection_base.cxx:
  - Removed unnecessary PGSTD:: scope qualifiers
  - Added some missing quotes in LISTEN/UNLISTEN statements
 src/connection.cxx, src/largeobject.cxx:
  - Removed unnecessary PGSTD:: scope qualifiers
 src/util.cxx:
  - When escaping, check for isprint rather than isgraph
  - Escape single quote to double single quote, as per SQL
 test/test000.cxx:
  - New
  - Should succeed even if there is no database to connect to
 test/test009.cxx:
  - Renamed test table to have standard "pqxx" prefix
  - Test tablewriter's column specifiers
 test/test004.cxx, test/test078.cxx:
  - Properly quoted trigger names
2004-05-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Should generate libpqxx.spec now, thanks Arjen Baart
2004-05-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 tools/preprelease:
  - Fixed nm line (tried to list dynamic symbols in static library!)
2004-05-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added gcc 3.4's -Wextra, which replaces -W
2004-05-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/transaction_base.cxx:
  - Fixed syntax error in COPY column specifications
 test/test080: 
  - Can't compare a const_reverse_iterator to rend() if container non-const :( 
  - Works now!
2004-05-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx:
  - g++-3.4.0 fixes (for any compiler, really).  Thanks Michael Krelin!
 include/pqxx/tablereader.hxx, include/pqxx/tablestream.hxx,
 include/pqxx/tablewriter.hxx, include/pqxx/transaction_base.hxx,
 src/transaction_base.cxx:
  - Column list specification support for tablestreams
 test/test068.cxx:
  - Corrected typo in comment
 test/test080.cxx:
  - New
  - Tests column list specifications for tablereader
2004-04-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection_base.cxx:
  - Accept double-quoted trigger names, thanks slava@perlx.com
 test/test078.cxx:
  - Test with unusual trigger name, as intended
2004-04-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Notification-related functions return number of notifications received
  - New await_notification() functions sleep until notification arrives
 test/test004.cxx, test/test023.cxx:
  - Check get_notifs() return value
 test/test078.cxx:
  - New
  - Tests await_notification()
 test/test079.cxx:
  - New
  - Tests await_notification(long,long)
2004-04-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test004.cxx:
  - Added #include <ctime>, just in case
2004-04-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/trigger.hxx:
  - Added missing include, thanks slava@perlx.com
2004-04-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Enable standard I/O streams library on Compaq C++ compiler
 include/pqxx/result.hxx:
  - Include ios.  Thanks Fahad Gilani.
2004-04-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/Makefile.am:
  - Renamed config.h.in to internalconfig.h.in
 include/pqxx/compiler.h:
  - Renamed config.h to internalconfig.h to avoid confusion
 include/pqxx/config.h.in:
  - Deleted
 include/pqxx/internalconfig.h.in:
  - New
 include/pqxx/libconfig.h.in:
  - Removed some macros not used in library headers
 test/test045.cxx:
  - Quelled compiler warning
 test/test049.cxx:
  - Include internalconfig.h instead of libconfig.h
2004-04-05  Roger Leigh <rleigh@debian.org>
 tools/Makefile.am:
  - Add $(top_builddir)/include to INCLUDES.
2004-04-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.hxx, include/pqxx/connection_base.hxx:
  - Made dropconnect() throw ()
2004-03-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/util.cxx:
  - Added missing include <locale>, thanks darx@darxi.purk.ee
2004-03-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Replaced field_streambuf::underflow()
  - May fix problems with various compilers when reading strings from fields
2004-03-21  Roger Leigh <rleigh@debian.org>
 test/Makefile.am, tools/maketestam.pl
  - Correct includes and libs search paths.
  - VPATH builds now work.
 tools/Makefile.am
  - Don't try to install pqxxbench and rmlo.
2004-03-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libconfig.h.in, include/pqxx/util.hxx, src/util.cxx:
  - Moved PQfreemem() and PQfreeNotify() calls out of header
  - Moved PQXX_HAVE_PQFREEMEM and PQXX_HAVE_PQFREENOTIFY out of header
  - Moved PQXX_HAVE_PQFREE* out of libconfig.h
 include/pqxx/result.hxx:
  - to_string() and from_string() templates for result::field
 include/pqxx/util.hxx, test/test*.cxx:
  - Test coverage for from_string() functions
  - Test coverage for to_string() functions
 test/test076.cxx:
  - New
  - Completes test coverage for from_string() and to_string()
 test/test077.cxx:
  - New
  - Tests result::swap()
2004-03-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx:
  - Included compiler.h instead of libcompiler.h, thanks Markus Bertheau
2004-03-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pqxx:
  - Included pqxx/result (though not really needed)
 include/pqxx/result.hxx, src/result.cxx:
  - Added swap()
 README:
  - Documented link command line for Unix-style compilers
  - Documented difference between "foo" and "foo.hxx" headers
2004-03-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx, include/pqxx/result.hxx,
 include/pqxx/tablewriter.hxx, src/binarystring.cxx, src/connection_base.cxx,
 src/cursor.cxx, src/largeobject.cxx, src/pipeline.cxx, src/result.cxx,
 src/robusttransaction.cxx, test/test*.cxx:
  - Replaced ToString() calls with to_string() (and same for FromString etc)
2004-03-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx, src/util.cxx:
  - Implemented to_string() functions to replace ToString()
 tools/Makefile.am
  - rmlo and pqxxbench still built, but not installed; thanks Markus Bertheau
2004-03-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, include/pqxx/cursor.h:
  - Added "@deprecated" doxygen tag to classes
 include/pqxx/result.hxx, include/pqxx/util.hxx, src/util.cxx:
  - New template from_string<>() (stricter, faster, no locale problem)
  - Deprecated FromString<>()
2004-02-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README, win32/INSTALL.txt:
  - Documented the need to edit win32/common
 tools/rmlo.cxx:
  - Ported to 2.x API (thanks GB Clark)
2004-02-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh, configure.ac.in:
  - Fixes for using config/m4 directory (Patrick Welche)
2004-02-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 .cvsignore:
  - Added configure.lineno (Patrick Welche)
 autogen.sh:
  - Made aclocal work with config/m4 instead of . (Patrick Welche)
 doc/libpqxx.xml:
  - Typos fixed (Patrick Welche)
2004-02-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/largeobject.cxx: 
  - Fixed risk of incorrect errno 
2004-02-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test075.cxx:
  - g++ 2.95 compile fix
 tools/maketestam.pl:
  - Removed redundant -I option
 tools/Makefile.am:
  - Added pqxxbench
  - Added rmlo
 tools/pqxxbench.cxx, tools/pqxxbench.in:
  - New
2004-02-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test049.cxx:
  - Make count_if() compile on Sun CC (thanks Jon Meinecke)
2004-02-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh, configure.ac.in:
  - Patrick Welche patch: make libtoolize "copy over the necessary .m4 files
  into ., then aclocal looks in . and adds them to aclocal.m4, and everything
  is happy."
  - Patrick Welche cont'd: "Didn't need to remove RANLIB, but as you require a
  reasonably new autoconf, int won't hurt..)"
  - Moved m4 stuff into config/m4, thanks Patrick Welche
 include/pqxx/cachedresult.h, include/pqxx/cursor.h:
  - Workaround for Sun CC compile problem (thanks Jon Meinecke)
2004-02-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Back to full test coverage
 test/test071.cxx:
  - Made reverse_iterator part conditional on PQXX_HAVE_REVERSE_ITERATOR
 test/test075.cxx:
  - New
  - Tests reverse result iteration (including rbegin() and rend())
 win32/libpqxx.mak:
  - Added winsock32 library to link options (thanks Fred Moyer)
2004-02-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/config.h.in:
  - Removed redundant definitions
 src/connection_base.cxx:
  - Made unistd.h include conditional (thanks Fred Moyer)
2004-02-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/isolation.hxx:
  - Removed unused implemented() functions
 include/pqxx/libcompiler.h:
  - Trying PQXX_TYPENAME workaround for SUN compiler...
 test/test046.cxx, test/test049.cxx, test/test074.cxx:
  - Compile fixes, thanks Greg Webber!
2004-02-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Fixed SUN compiler version check (thanks Jon Meinecke, Greg Webber)
2004-02-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Check for functional count_if() (Jon Meinecke)
  - Several AC_TRY_COMPILE checks fixed
  - Stay in C++ mode, less Fortran stuff etc. in configure
 include/pqxx/connection_base.hxx, include/pqxx/libcompiler.h:
  - Workaround for Sun CC default argument problem (thanks Jon Meinecke)
 include/pqxx/largeobject.hxx
  - Workaround for Sun CC namespace lookup problem (Jon Meinecke)
 include/pqxx/largeobject.hxx, include/pqxx/result.hxx, src/largeobject.cxx,
 src/result.cxx:
  - Added some throw () where appropriate
 include/pqxx/result.hxx:
  - Fixed long-standing bug in LoseRef() - thanks Jon Meinecke!
 pqxx-config.in:
  - Added missing -L in --libs option (Arjen Baart)
 test/test049.cxx:
  - count_if() workaround (thanks Jon Meinecke)
 win32/libpqxx.mak:
  - Added pipeline
2004-02-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Set up for SUN Workshop workaround
2004-02-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h:
  - Workaround for SUN Workshop 6 (thanks Jon Meinecke)
 include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - Typedef-wrapped container types to reduce std::pair<> trouble
  - Should fix SUN Workshop problems (thanks Jon Meinecke)
2004-02-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/binarystring.hxx, include/pqxx/libcompiler.h,
 include/pqxx/libconfig.h.in, include/pqxx/result.hxx, test/test062.cxx:
  - Added check for functional reverse_iterator template
  - Skip reverse_iterator typedefs & functions if template not available
  - VC7 workaround implies no functional reverse_iterator template
2004-02-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libcompiler.h:
  - Documented PGSTD
 include/pqxx/result.hxx:
  - Added reverse_iterator
 include/util.hxx:
  - Documented pqxx::internal so that Doxygen picks it up
 README-UPGRADE:
  - Documented 2.2.0 changes
 src/cachedresult.cxx:
  - SUN Workshop compiler fix, thanks Jon Meinecke
2004-01-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Documented exception guarantees
  - Added throw () here or there
  - Made process_notice() throw ()
  - More work on process_notice() robustness
2004-01-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - process_notice() can handle messages without the trailing newline
2004-01-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added lost patch from Arjen to generate pqxx-config
 include/pqxx/result.hxx:
  - Added reverse_iterator support
2004-01-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Changed default installation prefix to /usr/local, thanks Arjen Baart!
 Makefile.am:
  - Added bin_SCRIPTS (patch by Arjen Baart)
 pqxx-config.in:
  - New (Arjen Baart)
  - Similar to PostgreSQL pg_config script for configuration parameters
2004-01-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/util.hxx, src/connection_base.cxx, src/transaction_base.cxx,
 src/util.cxx:
  - Split namedclass base class out of transactionfocus 
  - Added description() to easily construct a full name for a namedclass
  - Moved unique<> to internal namespace
  - Made unique<> assume its guest is a namedclass
  - Simplified error message generation using namedclass
  - Rewrote unique<> error checking
 include/pqxx/pipeline.hxx, include/pqxx/tablereader.hxx,
 include/pqxx/tablestream.hxx, include/pqxx/tablewriter.hxx,
 include/pqxx/transaction_base.hxx, src/pipeline.cxx, src/tablereader.cxx,
 src/tablestream.cxx, src/tablewriter.cxx, src/transaction_base.cxx:
  - Finally introduced transactionfocus class
  - Reworked Classname() system
2004-01-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Created fieldstream
 include/pqxx/util.hxx:
  - Added PQXX_LIBEXPORT where needed, thanks david@firepro.co.za.
 test/test074.cxx:
  - New
  - Tests fieldstream
2004-01-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/*.hxx:
  - Introduced "internal" namespace
  - Changed "test1" in comment to "test001"
  - Made all destructors throw () (and inspected them to verify this)
2004-01-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx, src/pipeline.cxx, test/test072.cxx:
  - Pipeline refuses to (re-)issue queries behind a failure
 src/pipeline.cxx:
  - Implemented Bart's trick
  - In nontransactions, manages to pinpoint queries causing syntax errors
 test/test073.txt:
  - New
2004-01-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in:
  - Added warning about auto-generation of configure.ac
  - Peter Eistentraut's patch for finding postgres headers & libraries
 README:
  - No longer need --with-postgres etc. (thanks Peter!)
 TODO:
  - Bart Samwel found great solution for pipeline's one major weakness
 win32/Makefile.am:
  - Added MinGW.mak to distribution
 win32/MinGW.mak:
  - New.  Thanks Pasquale Fersini!
2004-01-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx:
  - Warning about syntax errors
 src/pipeline.cxx:
  - Better handling of awkward error situations
 src/util.cxx:
  - Fixed bool conversion (missing break), thanks Roger Leigh!
 test/test072.cxx:
  - Tests runtime error rather than SQL syntax error
  - Succeeds now
2004-01-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/pipeline.hxx:
  - Full test coverage
  - Added retain() and resume()
  - Better error message when retrieving result for unknown query
 src/connection_base.cxx:
  - Fix: combination of asyncconnection/nontransaction/pipeline didn't connect
 test/test069.cxx, test/test070.cxx, test/test071.cxx, test/test072.cxx:
  - New
  - Test pipeline class
2004-01-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Check for automake 1.8
 README, win32/README:
  - Minor updates wrt Windows-specific material
2004-01-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/util.h:
  - Re-included std::string.clear() check which had been lost
  - Replaced #pragma warning with #pragma message, thanks key88sf@hotmail.com
 README:
  - Documented manual editing of configuration headers
 include/connection_base.hxx, src/connection_base.cxx:
  - Changed Windows workarounds for select(), thanks key88sf@hotmail.com
 src/cursor.cxx:
  - Workaround for min()/max() problem in Windows, thanks key88sf@hotmail.com
 test/test004.cxx, test/test023.cxx:
  - Updated Windows vs. select() workarounds
2003-12-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/pipeline.cxx:
  - Compiles
2003-12-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.hxx:
  - Empty throw specification for sql_error::query() 
 include/pqxx/largeobject.hxx, src/largeobject.cxx:
  - Empty throw specification for largeobjectaccess::close()
 include/pqxx/pipeline, include/pqxx/pipeline.hxx, src/pipeline.cxx:
  - New
 include/pqxx/result.hxx, include/pqxx/transaction_base.hxx:
  - Prototyped facilities for pipeline
2003-12-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - No longer runs autoheader, which would overwrite config.h.in
 configure.ac, include/pqxx/config.h.in, include/pqxx/libconfig.h.in:
  - Renamed some more HAVE_... macros to PQXX_HAVE
  - Removed some unnecessary macros
  - Workaround for missing clear() in standard string
 src/connection_base.cxx:
  - Fixed broken tablewriter for pre-7.4 postgres--thanks Roger Leigh!
2003-12-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Made async argument to WriteCopyLine() default to false
 src/transaction_base.cxx:
  - Fixed some double spaces in error strings
2003-12-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 debian/*:
  - Applied Debian patches by Roger Leigh
 include/pqxx/result.hxx:
  - More general implementation of operator<<(), thanks Hubert-Jan Schaminee!
2003-11-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Removed obsolete ABI versioning
 configure.ac.in:
  - Now sets PQXXVERSION
 src/Makefile.am:
  - Implemented "-release" ABI versioning.  Thanks Roger Leigh!
 tools/preprelease:
  - Fixed nm invocation used to generate library symbols
 win32/libpqxx.mak:
  - Fixed some wrapped lines.  Thanks Paresh Patel!
  - Fixed some carriage return/line feed problems (Paresh Patel)
2003-11-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Removed "OnReconnect" parameter from Exec()
  - Moved EndCopy() into old versions of line-read & end-write functions
  - Support for async (nonblocking) mode
  - Factored out & optimized select() code
 include/pqxx/result.hxx, src/result.cxx:
  - Split StatusError() out of CheckStatus()
  - Added CheckStatus() version taking const char[]
 include/pqxx/tablereader.hxx, src/tablereader.cxx:
  - Moved field parsing out of the header, into new function extract_field()
  - Rewrote field parsing
 include/pqxx/tablewriter.hxx, src/tablewriter.cxx:
  - Do writes in async mode
  - Buffer up to 1 pending line (could support more in the future)
 include/pqxx/transaction_base.hxx:
  - COPY queries no longer delegated to connection_base
  - COPY now treated as regular query; follows transaction's retry policy
  - EndCopy() no longer needed
 win32/INSTALL.txt
  - Replaced part about copying config.h by part about editing it
 win32/libpqxx.mak
  - Fixed some apparently wrapped lines!
2003-11-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/dbtransaction.hxx:
  - Use old-style isolation level syntax, thanks koun@sina.com!
  - "Start command" no longer starts transaction; only sets isolation level
  - Isolation level only set if not the default
  - New function start_backend_transaction()
 include/pqxx/dbtransaction.hxx, include/pqxx/robusttransaction.hxx,
 include/pqxx/transaction.hxx, src/robusttransaction.cxx, src/transaction.cxx:
  - Factored out identical implementations of do_exec()
 include/pqxx/transaction_base.hxx, src/transaction_base.cxx:
  - Removed OnRetry parameter from DirectExec()
  - Made Retries parameter for DirectExec() default to the safe choice of 0
 src/robusttransaction.cxx:
  - Forgot to set isolation level!
  - Use start_backend_transaction()
 src/transaction.cxx:
  - Use start_backend_transaction()
2003-11-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac.in, include/pqxx/tablereader.hxx, include/pqxx/tablewriter.hxx,
 src/tablereader.cxx, src/tablewriter.cxx:
  - Got tablestreams to work with the new functions
 include/pqxx/except.h:
  - Made single-argument constructor of sql_error explicit
2003-11-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/tablereader.hxx, include/pqxx/tablewriter.hxx,
 src/tablereader.cxx, src/tablewriter.cxx:
  - Now allow user-settable null string, as intended
  - Major cleanups and optimizations
  - Some probable off-by-one errors in escaping fixed
 test/test005.cxx:
  - Added double-tab combination to test set to test subsequent escapes
2003-11-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Reads version numbers from VERSION
  - Generates configure.ac
 configure.ac:
  - Bumped abi revision for first time
  - Disabled check for new COPY interface for now (doesn't work yet)
  - Now generated by autogen.sh
 configure.ac.in:
  - New
  - Used to generate configure.ac with appropriate version numbers
 doc/html/CVS, doc/html/Reference/CVS, doc/html/Tutorial/CVS:
  - Removed
 include/pqxx/libconfig.h.in:
  - Check for PQputCopyData() and friends
 include/pqxx/connection_base.hxx, include/pqxx/result.hxx,
 include/pqxx/tablereader.hxx, include/pqxx/transaction_base.hxx,
 include/pqxx/trigger.hxx:
  - Moved all deprecated functions to bottom of public class sections
 include/pqxx/connection_base.hxx, src/connection_base.cxx:
  - Use new COPY interface, if available
 include/pqxx/tablereader.hxx:
  - Support escaping of carriage returns
 include/pqxx/tablereader.hxx, include/pqxx/tablestream.hxx,
 include/pqxx/tablewriter.hxx, src/tablereader.cxx, src/tablestream.cxx,
 src/tablewriter.cxx:
  - New complete() function to check for errors before constructor
 include/pqxx/tablestream.hxx, include/pqxx/transaction_base.hxx, 
 src/tablestream.cxx, src/transaction_base.cxx:
  - Added "pending" errors facility for tablereaders
 Makefile.am:
  - Remove doc/CVS from distribution archive if present
 src/connection_base.cxx, src/result.cxx, src/robusttransaction.cxx,
 src/transaction_base.cxx:
  - Rewrote "Internal libpqxx" error messages to "libpqxx internal error"
 src/connection_base.cxx:
  - For old COPY interface, increase line buffer to 10000 chars
  - Added lots of error checking
 src/tablewriter.cxx:
  - Delegated EndCopyWrite() to transaction
 tools/preprelease:
  - Create HTML documentation directories, and make sure they're empty
  - Check for up-to-date debian/changelog and NEWS
 VERSION:
  - New
  - Feeds version numbers into auto-generation process
2003-11-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.hxx, src/binarystring.cxx, src/util.cxx:
  - Included <new>.  Thanks Jaroslaw Staniek!
2003-11-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx:
  - Use PQAlloc's content_type
 include/pqxx/libcompiler.h:
  - "Broken iterator" workaround includes cstdlib for size_t
  - "Broken iterator" workaround includes cstddef for ptrdiff_t
  - char_traits workaround also typedefs char_type
  - Added char_traits workaround for unsigned char
  - Added workaround for missing ptrdiff_t
  - Thanks Adam Pigg for making me persist in resolving this!
 include/pqxx/util.hxx:
  - PQAlloc typedefs content_type
2003-11-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Invokes maketestam.pl before running automake
  - Invokes maketestvcmak.pl
 README:
  - Kexi project confirmed by Adam Pigg
 tools/maketestam.pl
  - New
  - Generates test/Makefile.am
  - Generates win32/
 test/Makefile.am
  - Now automatically generated by tools/maketestam.pl
 win32/test.mak:
  - Now automatically generated by tools/maketestvcmak.pl
2003-11-13  J.H.M. Dassen (Ray) <jdassen@debian.org>
 include/pqxx/Makefile.am: follow --includedir value.
2003-11-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, include/pqxx/compiler.h, include/pqxx/config.h.in:
  - Removed abs(long) workaround
 include/pqxx/cachedresult.h:
  - Removed const from CacheMap for SUN Workshop, thanks jluu@cdcixis-cm.com
 include/pqxx/connection.h:
  - Complete test coverage for asyncconnection
 src/cursor.cxx:
  - Replaced abs(long) by labs(long) (jluu@cdcixis-cm.com)
 test/test065.cxx:
  - Test asyncconnection's std::string constructor
2003-11-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/libconfig.h.in:
  - PQXX_HAVE_PQESCAPESTRING no longer visible during client compilation
 include/pqxx/util.hxx:
  - Moved some code to new util.cxx source file
 src/util.cxx:
  - New
  - Stricter input check on conversion to bool
 test/test064.cxx, test/test065.cxx, test/test066.cxx, test/test067.cxx, 
 test/068.cxx:
  - New
  - Test asyncconnection
 win32/libpqxx.mak:
  - Added util.cxx/util.obj
 win32/test.mak:
  - Added new tests starting with number 60
2003-11-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Added check for #pragma warning("...")
  - See if select() accepts NULL fd_set arguments
 include/pqxx/config.h.in, include/pqxx/libconfig.h.in:
  - Moved <sys/select.h> check to public configuration file
 include/pqxx/connection.hxx, include/pqxx/connection_base.hxx:
  - New overridables startconnect(), completeconnect(), dropconnect()
  - New class asyncconnection
  - Getters/setters only require a PQconn, not a working connection
  - Made is_open() more strict
  - New function halfconnect(): ensure just that there is a valid PQconn
 include/pqxx/util.h:
  - Issue #pragma warning if #warning not available
 src/connection.cxx, src/connection_base.cxx:
  - Connect() while already connected is no longer an error
  - New class asyncconnection
 test/test001.cxx:
  - Check for nonempty result
 test/test004.cxx, test/test023.cxx:
  - No longer include <pqxx/compiler.h>
 test/test058.cxx:
  - Quenched some comparison sign warnings
 test/test063.cxx
  - New
  - Tests asyncconnection
2003-10-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, include/pqxx/config.h.in:
  - Check for PQescapeBytea() and PQunescapeBytea() (thanks Costin Musteata)
 Doxyfile:
  - Removed obsolete doxygen parameters
 src/binarystring.cxx:
  - Workarounds for missing PQescapeBytea() / PQunescapeBytea()
  - Removed reference to namespace std (should be PGSTD)
 test/test004.cxx, test/test023.cxx:
  - Made Sleep() revert to WIN32 version on Windows (thanks Costin)
 README:
  - Added related links
  - Added more libpqxx-using projects
2003-10-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Checks for preprocessor #warning support
 include/pqxx/binarystring.hxx:
  - Exclude reverse iterator definitions on Visual C++, thanks Costin!
 include/pqxx/compiler.h:
  - Defines PQXX_LIBEXPORT if compiling library as Windows DLL
 include/pqxx/cursor.hxx:
  - Exclude some required typename keywords on Visual C++ (Costin)
  - error_permitted_isolation_level() workaround for Visual C++ (Costin)
 include/pqxx/libcompiler.h:
  - Included Windows workaround definitions here
 include/pqxx/libconfig.h.in:
  - Added PQXX_HAVE_CPP_WARNING, set better default for PGSTD
 include/pqxx/util.h:
  - Fixed flaw in inclusion of new-style util header
 include/pqxx/util.hxx:
  - Includes libcompiler.h
 README:
  - Revamped Windows section
  - PQXX_NO_PARTIAL_CLASS_TEMPLATE_SPECIALISATION no longer needed!
  - Updated programming introduction
 src/*.cxx:
  - All now include pqxx/compiler.h at the top (Costin)
 src/robusttransaction.cxx:
  - Made unused catch argument anonymous to silence warning (Costin)
 win32/config.h:
  - Removed
2003-10-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - to() now throws domain_error if conversion fails (thanks Rune Jortveit)
  - New as() without argument; throws if null
  - Throw specifications for at() and operator[] where appropriate
 include/pqxx/transaction.hxx
  - Introduced "work" typedef for default transaction type
 test/test045.cxx:
  - Test new zero-argument result::field::as()
 test/test0??.cxx:
  - Replaced "transaction<>" by new typedef "work"
2003-10-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/binarystring.cxx:
  - Workaround for missing const in Bytea escape functions in postgres 7.3
2003-10-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/binarystring.hxx, src/binarystring.cxx:
  - New
  - Reworked binarystring, now more std::string-like
 include/pqxx/result.hxx:
  - Moved binarystring into its own set of files
2003-10-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection_base.hxx:
  - Test coverage for set_variable()
 include/pqxx/result.hxx, src/result.cxx:
  - binarystring::size() doesn't include terminating zero!
  - Test coverage for binarystring
  - Added escape_binary() functions
 include/pqxx/transaction_base.hxx:
  - Test coverage for set_variable()
 include/pqxx/util.hxx:
  - String conversions with unsigned char * now supported
 test/test060.cxx, test/test061.cxx, test/test062.cxx:
  - New
2003-10-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.hxx:
  - More helpful link error for unsupported string conversions
2003-09-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h, src/cursor.cxx:
  - Moved ALL() and BACKWARD_ALL() to cursor.cxx so they can use config.h.
2003-09-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, include/pqxx/*, test/test*.cxx:
  - Renamed configure macros used in header files
  - New libcompiler.h/libconfig.h for inclusion in headers
  - compiler.h/config.h only needed when compiling library
 include/pqxx/libcompiler.h, include/pqxx/libconfig.h:
  - New
 README:
  - Renamed NO_PARTIAL_CLASS_TEMPLATE_SPECIALISATION
2003-09-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.hxx:
  - Some PGSTD::string & parameters should have been const
 test/test002.cxx
  - Fixed some mistakes in testing PQftable support
2003-09-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/*:
  - Moved header contents to .hxx files for filetype recognition
2003-09-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result:
  - Replaced two obsolete calls to Column() by column()
  - Test coverage for column type / column name functions
2003-09-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Added check for PQfreeNotify()
  - Check for using-declaration overloading problem in gcc 2.95.3
 include/pqxx/largeobject:
  - Workaround for using-declaration overloading problem
 include/pqxx/util:
  - Use PQfreeNotify() if available and appropriate
  - Added <cctype> include
2003-07-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result:
  - Added support for PQftable().  Thanks Adam Pigg!
  - Deprecated tuple::Row() in favour of row_number()
2003-07-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/all:
  - Replaced with include/pqxx/pqxx to fix automake problem
 include/pqxx/*, src/*.cxx, test/test*.cxx:
  - Deprecated lots of functions with upper-case letters in names
  - Made old functions available if old-style headers are included
2003-06-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.sgml:
  - Replaced by libpqxx.xml
 doc/libpqxx.xml:
  - New.  Thanks Wichert Akkerman!
 DoxyFile:
  - Added new header files
 include/pqxx/connection_base, include/pqxx/transaction_base,
 src/tablestream.cxx:
  - Fix crash closing tablestream on nonexistant table (thx Sean [Rogers?])
 include/pqxx/except:
  - Moved exception classes back into pqxx namespace where they belong
2003-06-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/*.h:
  - Deprecated; new headers have names not ending in ".h"
  - All backwards compatibility support restricted to old headers
2003-06-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.h:
  - Fixed compile error in a basic_ilostream() constructor
  - Complete test coverage
 include/pqxx/result.h:
  - Updated test coverage; only binarystring remains to be done
 test/test057.cxx, test/test058.cxx, test/test059.cxx:
  - New
 win32/libpqxx.mak:
  - Added dbtransaction
 win32/test.mak:
  - Added tests 21 through 59
  - Added leading zeroes to all test names
2003-06-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h:
  - Deprecated ColumnNumber() and ColumnName()
  - New column_number() and column_name() throw on error
  - Replaced some std:: with PGSTD::
2003-06-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test*.cxx:
  - Prefixed test table names (events and orgevents) with "pqxx"
2003-06-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Started list of projects using libpqxx
 include/pqxx/cursor.h:
  - Workaround for MetroWerks 8.3
2003-06-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 COPYING:
  - Finally written out
 README-UPGRADE:
  - New
 include/pqxx/largeobject.h, include/pqxx/result.h, 
 include/pqxx/tablewriter.h:
  - Added some forgotten PQXX_LIBEXPORTs
 include/pqxx/tablereader.h:
  - Renamed TableReader to tablereader
 include/pqxx/tablestream.h:
  - Renamed TableStream to tablestream
 include/pqxx/tablewriter.h:
  - Renamed TableWriter to tablewriter
 include/*.h, src/*.cxx:
  - Added reference to COPYING
2003-06-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h:
  - Renamed CachedResult to cachedresult
  - Renamed Tuple to tuple
 include/pqxx/result.h:
  - Renamed Result to result
  - Renamed Tuple to tuple
  - Renamed Field to field
 include/pqxx/trigger.h:
  - Renamed Trigger to trigger
2003-06-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h:
  - Independently checks for correct isolation level
  - Made constructor private
  - Improved documentation
 include/pqxx/connection_base.h:
  - Renamed Noticer to noticer
  - Derived noticer from std::unary_function
 include/pqxx/connection.h:
  - Renamed Connection to connection
  - Renamed LazyConnection to connection
  - Improved documentation
 include/pqxx/dbtransaction.h:
  - Made constructor private
 include/pqxx/largeobject.h:
  - Renamed LargeObject to largeobject
  - Renamed LargeObjectAccess to largeobjectaccess
  - Gave largeobjectaccess an off_type and pos_type
  - Improved documentation
 include/pqxx/result.h:
  - Renamed BinaryString to binarystring
 include/pqxx/transaction_base.h:
  - Made constructor private
 include/pqxx/util.h:
  - Added oid and oid_none
 include/pqxx/*.h:
  - Fixed some includes
2003-05-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, src/cachedresult.cxx:
  - Templatized, inlined constructor to provide Cursor's with isolation level
 include/pqxx/cursor.h, src/cursor.cxx:
  - Requires serializable isolation level at link time
  - Shuffled constructor around to implement isolation level requirement
 include/pqxx/dbtransaction.h:
  - New
 include/pqxx/isolation.h:
  - New
 include/pqxx/largeobject.h, src/largeobject.cxx:
  - Requires dbtransaction, not merely a transaction_base
 include/pqxx/robusttransaction.h:
  - Removed unnecessary and wrong "BEGIN WORK" retry string (harmless though)
  - Just reports serializable as its isolation level for now
  - Is now derived from dbtransaction
 include/pqxx/transaction_base.h:
  - Reports committed_read as its isolation level
 include/pqxx/transaction.h:
  - Reports serializable as its isolation level
  - Is now derived from dbtransaction
 include/pqxx/transactor.h:
  - Templatized on transaction class
  - Now derived from std::unary_function
 include/*, src/*:
  - Renamed Connection_base to connection_base
  - Renamed Transaction_base to transaction_base 
 tools/preprelease:
  - Rewrote output generation
2003-05-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h
  - Added Field::as() by popular request
  - Documented annoying locale sensitivity of Field::to()
 include/pqxx/util.h
  - Documented annoying locale sensitivity of ToString()/FromString()
2003-05-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h:
  - Fixed wrong argument type for PQfreemem() on systems that have it
  - Fixed missing export directive on Unique
2003-05-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test056.cxx:
  - New
 win32/libpqxx.mak:
  - Fixed apparent whitespace problem, thanks key88sf
2003-05-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, include/pqxx/largeobject.h, test/test051.cxx, test/test052.cxx,
 test/test053.cxx, test/test055.cxx:
  - Got large object support to compile with gcc 2.95
 include/pqxx/*.h, src/*.cxx, test/test*.cxx:
  - Renamed ConnectionItf to Connection_base, similar for TransactionItf
2003-05-05  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, include/pqxx/compiler.h:
  - Workaround for gcc 2.95: missing std::char_traits
 configure.ac, include/pqxx/largeobject.h:
  - Workaround for gcc 2.95: missing <streambuf>
 include/pqxx/largeobject.h:
  - Workaround for gcc 2.95: missing std::ios_base
 include/pqxx/util.h:
  - Workaround for gcc 2.95: default args in template function specializations
2003-05-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Declare all cursors SCROLL for now
2003-05-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connectionitf.h, include/pqxx/transactionitf.h, 
 include/pqxx/util.h, src/connectionitf.cxx, src/transactionitf.cxx:
  - Made lots of things non-const in Unique<>, ConnectionItf, TransactionItf
  - Session variables interface in ConnectionItf, TransactionItf
  - SetClientEncoding() now just sets CLIENT_ENCODING variable
2003-05-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connectionitf.h, src/connectionitf.cxx:
  - Restore client encoding upon recovering connection
  - Added some documentation
 include/pqxx/result.h:
  - Moved template operator<<(..., Field) into pqxx namespace
 include/pqxx/util.h:
  - More documentation for PQAlloc
2003-05-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h, src/connectionitf.cxx:
  - Moved PQAlloc<> from connectionitf.cxx to util.h
 include/pqxx/result.h:
  - Added BinaryString
2003-04-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 debian/*:
  - Replaced Ray Dassen's Debian packaging with Greg Hookey's.  Thanks to both!
2003-04-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h:
  - Changed Field::size() from int to size_type
2003-04-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test007.cxx:
  - Use PSQL_ASCII instead of utf8 as the test encoding
2003-03-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Also looks for postgres in /usr/local/pgsql
2003-03-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Added libpq's location to dynamic link path.  Thanks Bjorn Wingman!
2003-03-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h:
  - Added ColumnNumber() to Tuple, at key88sf's request
2003-03-30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.h:
  - Removed superfluous to_file functions for const char[]
  - Extended test coverage
 include/pqxx/tablereader.h:
  - Removed nonexistant operator>> versions for Result, string
 test/test007.cxx:
  - Test ConnectionItf::SetClientEncoding()
 test/test052.cxx, test/test053.cxx, test/test054.cxx, test/test055.cxx:
  - New
2003-03-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test014.cxx:
  - Increased test coverage
2003-03-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/except.h:
  - New
  - New exception class: sql_error
 include/pqxx/result.h, src/connectionitf.cxx, src/result.cxx: 
  - Failed queries now throw sql_error, including query text
2003-03-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, src/connection.cxx, test/test001.cxx, 
 test/test023.cxx:
  - Default constructors for Connection and LazyConnection
 include/pqxx/largeobject.h:
  - Better test coverage
  - Added LargeObjectAccess::seek()
  - Documented LargeObjectAccess::cseek() return value
  - Added Reason() functions to LargeObject, LargeObjectAccess
 src/largeobject.cxx:
  - Added Reason() functions to LargeObject, LargeObjectAccess
  - Use Reason() to describe some errors more accurately
 test/test050.cxx:
  - More devious mixed-mode access
 test/test051.cxx:
  - New
2003-03-27  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Check for PQfreemem()
 include/pqxx/connectionitf.h:
  - Better documentation for SetNoticer
  - Made destructor inline to reduce pain for Windows users
  - Added SetClientEncoding()
 include/pqxx/largeobject.h:
  - Fixed missing BufSize arguments in basic_[o]lostream constructors
 include/pqxx/result.h:
  - Default constructor for const_iterator
 src/connectionitf.cxx:
  - Use PQfreemem() for notifications, if available
 test/test050.cxx:
  - New
2003-03-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h:
  - Support string conversion of signed/unsigned shorts
2003-03-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Also checks for <libpq/libpq-fs.h> header
 include/pqxx/util.h:
  - New Quote<>() template for string constants
 test/test018.cxx:
  - Tests new version of Quote<>()
2003-03-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Include Doxyfile in distribution archive
2003-03-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transactionitf.h, src/transactionitf.cxx:
  - Preliminary support for "named" statements
2003-03-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, src/connection.cxx:
  - Explicit destructors to work around another problem with Sun CC 5.1
2003-03-18  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Changed check for abs(long) to be more likely to fail
2003-03-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/libpqxx.mak:
  - Replaced by more up-to-date version (thanks Key88sf)
2003-03-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.h:
  - Documentation improvements
  - ilostream, olostream, lostream now have user-definable buffer size
 include/pqxx/result.h, include/pqxx/tablewriter.h:
  - More work on reducing Visual C++ workarounds, thanks Key88sf!
 test/test049.cxx:
  - Uses a few standard algorithms on Result
2003-03-16  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.h, src/largobject.cxx:
  - Added C++-style read/write to LargeObjectAccess
  - Documented return values of cread(), cwrite()
  - largeobject_streambuf now has user-definable buffer size
2003-03-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connectionitf.h:
  - New
 include/pqxx/connection.h:
  - Removed deprecated C-style NoticeProcessors
  - Removed deprecated IsOpen()
  - Split Connection into class hierarchy
 include/pqxx/largeobject.h, src/largeobject.cxx:
  - Silence warning about C-style cast in InvalidOid macro
 test/test001.cxx, test/test002.cxx, test/test014.cxx, README:
  - Moved optional complexity out of test001 for clarity
 test/test049.cxx:
  - New
2003-03-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Documented connection strings
2003-03-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README, include/pqxx/result.h, include/pqxx/tablewriter.h:
  - Killed NO_PARTIAL_CLASS_TEMPLATE_SPECIALISATION. Thanks key88sf@hotmail.com!
2003-03-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Tests now respect different definitions of PGSTD
2003-03-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, include/pqxx/compiler.h:
  - Check & workaround for "ambiguous abs(long)" error on Sun compiler
 src/connection.cxx, src/cursor.cxx:
  - Changes to make Sun compiler happy (thanks Jeroen van Erp)
2003-03-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/html/Reference/*lostream*.html:
  - New
 include/pqxx/largeobject.h:
  - in & out are not from std::ios originally, but from std::ios_base
  - Fix: olostream now syncs itself before closing
  - lostream and olostream sync themselves twice before closing
 include/pqxx/util.h:
  - Added ToString<>() specialization for char *const &
 src/cachedresult.cxx:
  - Compile fixes for Sun compiler (thanks Jeroen van Erp)
2003-03-10  J.H.M. Dassen (Ray) <jdassen@debian.org>
 Generate pkgconfig metadata file; updated debianisation.
2003-03-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Makefile.am:
  - Added debian packaging directory to distribution
 include/pqxx/largeobject.h:
  - Added ilostream, olostream, lostream
 test/test048.cxx:
  - Uses ilostream, olostream
2003-03-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/largeobject.h, src/largeobject.h, test/test048.cxx:
  - Replaced low-level LargeObject::cunlink() with LargeObject::remove()
  - Added default constructor for LargeObject
 test/test048.cxx:
  - Now also removes the large object it creates
2003-03-06  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/all.h:
  - Includes largeobject.h
  - Was missing in archive in 1.5.0
 include/pqxx/connection.h:
  - Made LargeObject a friend, with access to raw connection
 include/pqxx/largeobject.h, src/pqxx/largeobject.cxx:
  - New
 include/pqxx/transactionitf.h:
  - Made Conn() public
 test/test001.cxx:
  - Fixed outdated comment about notice processors & C linkage
 test/test048.cxx:
  - New
2003-02-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, src/cachedresult.cxx:
  - Removed confusing "clear()" method
 include/pqxx/result.h:
  - Can now write Field to any type of stream
 test/test046.cxx, test/test047.cxx:
  - New
2003-02-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Added Documentation section
 doc/libpqxx.sgml, include/pqxx/cursor.h:
  - Various minor updates
 include/pqxx/all.h:
  - New
 test/test001.cxx:
  - Uses new <pqxx/all.h>
2003-02-26  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, include/pqxx/result.h, include/pqxx/tablereader.h:
  - Added/fixed some test coverage tags
 include/pqxx/cursor.h:
  - Test coverage for new "adopt existing SQL cursor" constructor
 src/cursor.cxx:
  - m_Name now includes quotes (to fix trouble with adopted SQL cursors)
 test/test045.cxx:
  - New
2003-02-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, src/cachedresult.cxx:
  - Fixed silly lifetime bug (now returns reference)
  - Removed CacheEntry class for now (uses less memory this way)
 src/cursor.cxx:
  - Oops, forgot to save changes earlier.
2003-02-25  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h, src/cursor.cxx:
  - Cursor may adopt existing SQL cursor returned from function
2003-02-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/*:
  - Great Renaming of all test programs to 0-padded 3-digit test numbers
2003-02-20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, src/cachedresult.cxx:
  - Store a single empty result to return when needed (fixes lifetime bug)
2003-02-17  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, include/pqxx/connection.h,
 include/pqxx/result.h, include/pqxx/robusttransaction.h,
 include/pqxx/tablereader.h:
  - Documented more parameters
2003-02-15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, src/connection.cxx:
  - Removed default constructor completely
2003-02-13  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, src/connection.cxx, test/test43.cxx:
  - #include <memory>
  - Disabled controversial default constructor for now
 include/pqxx/transactionitf.h, test/test*.cxx:
  - Added Exec() version taking query argument in std::string form
2003-02-12  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transaction.h:
  - Fixed little mistake in inline docs.  Thanks Dave Gomboc.
2003-02-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, src/connection.cxx, test/test*.cxx:
  - Connection constructor now accepts null connection string
  - Default constructor for Connection creates lazy connection
2003-02-11  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Bumped revision to 1.4.0
 include/pqxx/connection.h, src/connection.cxx, test/test1.cxx:
  - Rename Connection::IsOpen() to is_open() to conform to Standard Library
 include/pqxx/connection.h, src/connection.cxx, test/test1.cxx,
 test/test10.cxx, test/test14.cxx:
  - Introduced Noticer to replace NoticeProcessor (which had C linkage)
  - Deprecated NoticeProcessor
 test/test13.cxx, test/test15.cxx, test/test16.cxx, test/test17.cxx,
 test/test18.cxx, test/test21.cxx, test/test29.cxx, test/test32.cxx, 
 test/test33.cxx, test/test34.cxx, test/test35.cxx, test/test36.cxx,
 test/test37.cxx:
  - Removed unnecessary custom NoticeProcessors
2003-02-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Fix spurious "yes" (or "no") in configure output
  - No longer go back from C++ to C for just a few checks
2003-02-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Detect problematic consequence of unknown cursor position
2003-01-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Fixed detection of PQescapeString() presence, thanks David Wright
2003-01-28  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Add double-quotes around cursor name in SQL to circumvent case conversion
2003-01-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Documented Windows build essentials
2003-01-24  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Clarified internal error message
 test/test5.cxx:
  - Clarified non-harmful error message
2003-01-19  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h:
  - Support long double type
2003-01-10  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Fixed border case in size detection
 win32/libpqxx.mak:
  - Enabled template workaround for Microsoft's compiler
2003-01-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h:
  - Made "no PQescapeString()" workaround in Quote() slightly more portable
2003-01-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test13.cxx:
  - Added missing <cassert> - thanks postgres@vsservices.com
2003-01-06  J.H.M. Dassen (Ray) <jdassen@debian.org>
 configure.ac:
  - More extensive searching for PostgreSQL headers and libraries.
2003-01-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Fixed positioning bug when walking off right edge of result set
 test/test44.cxx:
  - New
2003-01-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h, src/cursor.cxx:
  - Rewrote positioning code.  SEEMS TO WORK NOW!
  - Added size()
 test/test27.cxx, test/test8.cxx:
  - Aligned test output
 test/test40.cxx:
  - Added test case where Cursor discovers its size spontaneously
2003-01-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h, src/cachedresult.cxx:
  - Make use of Cursor's absolute positioning.  NOT FUNCTIONAL YET.
 *:
  - Updated copyright notices
2002-12-31  Jeroen T. Vermeulen <jtv@xs4all.nl>
 test/test18.cxx, test/test32.cxx, test/test37.cxx, test/test41.cxx:
  - Reduced (expected, but still confusing) error output
2002-12-29  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h, src/cursor.cxx:
  - Added absolute cursor positioning
 src/cursor.cxx:
  - Rewrote Move()/Fetch() row count logic
 test/test24.cxx:
  - Fixed year for Space Oddyssey
 test/test41.cxx:
  - Reduced overrun width being tested
 test/test43.cxx:
  - New
2002-12-23  Jeroen T. Vermeulen <jtv@xs4all.nL>
 include/pqxx/cursor.h, src/cursor.cxx, test/test42.cxx:
  - Cursor::Move() now always returns number of rows moved
 include/pqxx/*.h, src/*.cxx:
  - replaced some string arguments with const string &
2002-12-22  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h:
  - new version of Move() reports number of rows skipped
 include/pqxx/tablewriter.h:
  - inline TableWriter::FieldConverter::Escape()
  - fix Visual C++ version of operator()
 src/cursor.cxx:
  - report negative move distances for backward moves
 test/test42.cxx:
  - New
2002-12-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h:
  - replaced Result_size_type with Result::size_type (now visible in this file)
 include/pqxx/util.h:
  - eliminated Result_size_type_min and Result_size_type_max
2002-12-14  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h, src/cursor.cxx:
  - Introduced size_type typedef
 test/test13, test/test18, test/test32, test/test37:
  - Prepend "(Expected)" to error messages that are supposed to be there
2002-12-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cursor.h:
  - Add warning about not all queries allowing cursors to go backwards
 test/test19.cxx, test/test22.cxx, test/test38.cxx, test/test40.cxx,
 test/test41.cxx:
  - Use events table for cursor test to circumvent trouble with pg_tables in
    postgres 7.3 (has become a view, so cursors don't go backwards)
 test/test5.cxx, test/test24.cxx:
  - Insert some extra rows in events so cursor tests will work
2002-12-09  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h:
  - Added cautionary comment about limitations in PostgreSQL
2002-12-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, src/cursor.cxx, src/robusttransaction.cxx, src/transaction.cxx:
  - Removed DIALECT_POSTGRESQL setting
2002-12-08  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h:
  - Fixed missing PGSTD:: qualification for std::exception
2002-12-04  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Test for presence of PQescapeString()
 include/pqxx/util.h:
  - Fixed Quote() for outlandish characters.  Thanks Bada.
2002-12-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac, test/test23.cxx, test/test4.cxx:
  - Not only test for <sys/select.h>, but also see if it works--thanks Rod 
    Taylor for feedback, testing, and facilities.
2002-12-03  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cachedresult.cxx:
  - Fixed cursor position bug when size was even multiple of granularity
 test/test41.cxx:
  - New
2002-12-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/cachedresult.h:
  - Implemented empty()
  - Added m_Lower
  - clear() no longer forgets size information, just flushes cache
 src/cachedresult.h:
  - Simplified binary search logic using m_Lower
  - Removed special case (-1 for unknown) from m_Upper
  - No longer rely on m_Cache to provide highest known-to-exist block
2002-12-02  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/cursor.cxx:
  - Use ALL and BACKWARD ALL instead of highest/lowest representable numbers
 test/test19.cxx, test/test38.cxx:
  - Replaced hardcoded table name by command-line argument as intended
2002-12-01  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Bumped revision to 1.2.0.
 include/pqxx/CachedResult.h, src/CachedResult.cxx:
  - New
 include/pqxx/compiler.h, include/pqxx/robusttransaction.h:
  - Removed constructs that looked like HTML tags but weren't.
 test/test40.cxx:
  - New
2002-11-07  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Workaround for missing InvalidOid definition
2002-10-23  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h, src/result.cxx:
  - Added AffectedRows() function requested by Peter Novodvorsky
 test/test13.cxx:
  - Tests Result::InsertedOid() and Result::AffectedRows()
 test/test7.cxx:
  - Tests Result::AffectedRows()
2002-10-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h:
  - Changed Tuple constructor arg from Tuple::size_type to Result::size_type
 include/pqxx/cursor.h, include/tablereader.h, include/tablestream.h,
 include/tablewriter.h, src/cursor.cxx, src/tablereader.cxx,
 src/tablestream.cxx, src/tablewriter.cxx:
  - Constructors now take TransactionItf & instead of Transaction &
2002-10-21  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Fixed apparent typo (confflags defined, $conf_flags used)
2002-10-20  J.H.M. Dassen (Ray) <jdassen@debian.org> 
 autogen.sh:
  - Don't silently continue after errors.
 configure.ac:
  - Provide a description for HAVE_SYS_SELECT_H so autoheader doesn't exit with
    an error.
  - Added a few more warnings: -Wmultichar, -Wabi, -Wctor-dtor-privacy.
 debian/rules:
  - [clean] Clean out generated HTML files.
  - [configure] Actually use confflags variable; simplified testing with a 
    different C++ compiler.
 src/Makefile.am:
  - Support building outside the source directory.
2002-10-15  J.H.M. Dassen (Ray) <jdassen@debian.org>
 debian/libpqxx-dev.files: 
  - Include .la file
 debian/rules:
  - Update config.{guess,sub} from autotools-dev if possible.
  - Ensure all files installed by "make install" end up in a package.
  - Relax shlib dependency to >= the upstream version.
 autogen.sh:
  - libtoolize --force
  - Make it possible to skip configure step through an environment variable.
 config/config.guess, config/config.sub, config/ltmain.sh:
  - Regenerated with current libtool
 debian/changelog, debian/control, debian/rules:
  - Updated for new Debian policy revision.
2002-10-13 16:00 Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Check for automake-1.7
 configure, */Makefile.in:
  - Regenerated with automake 1.7
 configure.ac:
  - Check for <sys/select.h>
  - Bumped revision to 1.1.2
 test/test23.cxx, test/test4.cxx:
  - Replaced Sleep()/sleep() and Windows workaround by select()
2002-09-29 14:00 Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/connection.h:
  - Documented log table creation and contents
 src/connection.cxx:
  - GetNotifs() frees notification structs a little earlier
2002-09-27 02:45 Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/connection.cxx:
  - Made GetNotifs() a little more aggressive in freeing PGnotify structs
2002-09-25 03:00 Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Removed several unwanted gcc options, making compile output readable again
  - Bumped revision to 1.1.1
 include/pqxx/connection.h:
  - Made m_Conn, m_NoticeProcessor mutable
  - Made Connect(), Disconnect(), SetupState() const
  - Un-inlined BackendPID()
  - Added Activate(), Deactivate()
 include/pqxx/nontransaction.h:
  - comment added
 src/connection.cxx:
  - Connect() now assumes connection is not already active
  - Fixed bug: Connect() didn't tell libpq about pending notice processor
 src/robusttransaction.cxx:
  - Created local alias for InvalidOid to reduce compiler warnings
 test/test22.cxx:
  - a little less output
2002-09-23 01:00 Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h, src/connection.cxx:
  - Now caches NoticePreprocessor & trace file set by user
  - Implemented lazy connections (requested by Greg Copeland)
 include/pqxx/result.h:
  - Added InsertedOid()
 include/pqxx/trigger.h:
  - Added admonishing comment about backend process ID
 src/robusttransaction.cxx:
  - Use log record's oid instead of explicit id field
  - Only attempt to create log table if creation of log field fails
  - Thanks to Greg Copeland for ideas, criticism & validation
 test/test17.cxx:
  - Fixed comment (used to call itself test15)
 test/test21.cxx, test/test22.cxx, test/test23.cxx, test/test24.cxx,
 test/test25.cxx, test/test26.cxx, test/test27.cxx, test/test28.cxx,
 test/test29.cxx, test/test30.cxx, test/test31.cxx, test/test32.cxx,
 test/test33.cxx, test/test34.cxx, test/test35.cxx, test/test36.cxx,
 test/test37.cxx, test/test38.cxx, test/test39.cxx
  - New
2002-09-20 15:15 Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/connection.h:
  - Added admonishing comment for BackendPID()
 src/connection.cxx:
  - Noted some exceptions that may change to broken_connection
2002-08-13 15:00 J.H.M. Dassen (Ray) <jdassen@debian.org>
 autogen.sh:
  - Use automake 1.6 if available
 include/pqxx/Makefile.am:
  - New
 debian/rules:
  - Enable maintainer-mode for warnings
 debian/libpqxx-dev.dirs:
  - Dir for docs
 debian/libpqxx-dev.doc-base:
  - New
 debian/control:
  - Added section for source package
  - Added Build-depends on doxygen
 debian/.cvsignore:
  - New
 config/.cvsignore, include/pqxx/.cvsignore:
  - Updated
2002-08-11 22:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Makefile.am:
  - added win32 directory to distribution
 include/pqxx/result.h, include/pqxx/tablewriter.h, test/test9.cxx, 
 test/test20.cxx:
  - tests cover all methods again, including remaining 3 (near-)trivial ones
2002-08-10 23:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 win32/*:
  - Build procedure for Visual C++ 7 by Clinton James
 include/pqxx/compiler.h:
  - Visual C++ workarounds moved to win32 directory (Clinton James)
 include/pqxx/result.h, include/pqxx/tablewriter.h:
  - Patches by Clinton James to help Visual C++ 7 port, with modifications for
    gcc's sake
2002-08-11 22:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 debian/*:
  - Debianized by Ray Dassen
 */.cvsignore:
  - Added by Ray Dassen
 */Makefile.am, configure.ac:
  - Various cleanups by Ray Dassen
  - Added HTML reference documentation to distribution
2002-06-12 17:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 src/transactionitf.cxx, test/test20.cxx:
  - Transaction is now detached from Connection on Commit or Abort
2002-06-12 16:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.sgml:
  - Lots of documentation for Transactor
 include/pqxx/connection.h, include/pqxx/transactionitf.h:
  - More brief descriptions
2002-06-12 00:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/nontransaction.h, include/pqxx/result.h, 
 include/pqxx/robusttransaction.h, include/pqxx/tablereader.h, 
 include/pqxx/tablestream.h, include/pqxx/tablewriter.h,
 include/pqxx/transaction.h, include/pqxx/transactionitf.h,
 include/pqxx/transactor.h, include/pqxx/trigger.h:
  - Added brief descriptions for classes
2002-06-08 23:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.sgml:
  - Various minor updates
2002-06-07 17:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Removed unneeded check for <errno.h>
  - Bumped version to 0.5.0
 Makefile.am:
  - Now also installs headers!
2002-06-04 20:00  Jeroen T. Vermeulen <jtv@xsall.nl>
 doc/Makefile.am:
  - Included libpqxx.sgml into list of files to go into distribution
2002-06-04 15:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 doc/libpqxx.sgml:
  - Removed part about unwritten reference (use doxygen now!)
2002-06-04 01:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Removed check for std::multimap
 include/pqxx/connection.h:
  - Made use of multimap for triggers list unconditional
  - Removed overdone sanity check from Perform()
2002-06-03 00:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Added check for std::multimap
 include/pqxx/connection.h:
  - Use std::multimap for triggers, if available
2002-06-02 23:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h:
  - Made design decision on ColumnNumber() (not checked, return -1 on failure)
 include/pqxx/tablereader.h:
  - Now also handles \t and \n coming from backend
2002-06-01 20:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Now checks for PostgreSQL libpq header in /usr/include/postgresql/
  - No longer uses -Wpadded compiler option
 include/pqxx/compiler.h, include/pqxx/result.h:
  - Hopefully fixed "multiple definition of std::iterator" problem
2002-05-29 22:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/util.h:
  - Added ToString()/FromString()/FmtString() specializations for short, bool,
    unsigned char.  Thanks Jonathan C. Bodner.
2002-05-27 22:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Makefile.am:
  - Removed autom4te.cache from MAINTAINERCLEANFILES (won't work for dirs)
 doc/libpqxx.sgml, include/pqxx/result.h, test/test11.cxx:
  - Renamed Result::Field::name() to Name()
 include/pqxx/connection.h:
  - Renamed Transactor::TRANSACTIONTYPE to argument_type
  - Made RemoveTrigger take non-const argument
 include/pqxx/result.h:
  - Fixed documentation comment
 include/pqxx/tablewriter.h:
  - Rewrote ezinekoT() to make more use of STL
  - Low-level optimizations
 include/pqxx/transactor.h, test/test(1[357]|[467]).cxx, doc/libpqxx.sgml:
  - Renamed Transactor::TRANSACTIONTYPE to argument_type
 include/pqxx/util.h:
  - Rewrote Quote() to make more use of STL
 src/connection.cxx:
  - Rewrote RemoveTrigger() to make more use of STL
 test/test5.cxx:
  - Added row with empty field to test data set
2002-05-20 15:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/transactor.h:
  - Made adaptable (argument_type etc. typedefs)
2002-05-20 05:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Moved config.h.in into include/pqxx
  - Removed -Wdisabled-optimization in maintainer mode
  - Removed unnecessary checks AC_STRUCT_TM, AC_FUNC_MALLOC, 
    AC_CHECK_FUNCS(memset).
 doc/libpqxx.sgml:
  - More about transactions, in_doubt_error
  - Documented Quote(), ToString(), FromString()
 Doxyfile:
  - Removed LaTeX output
  - Moved HTML output to doc/html/Reference
  - Tweaked output some more
  - Removed version number
 include/pqxx/compiler.h:
  - Moved config.h into include/pqxx
 include/pqxx/result.h:
  - Fixed some type typos in function parameters
2002-05-17 23:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Removed ${with_postgres_include}/(internal|server) from include path
  - Bumped version to 0.3.1
 include/pqxx/util.h:
  - Removed troublesome postgres_fe.h include!
2002-05-12 23:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 configure.ac:
  - Included ${with_postgres_include}/internal in include path to help users
    of RedHat-like systems find postgres_fe.h. 
 Doxyfile:
  - Created
 include/pqxx/compiler.h:
  - Doxygenized some comments
 include/pqxx/cursor.h:
  - More comments
 include/pqxx/robusttransaction.h:
  - Doxygenized some comments
 include/pqxx/tablereader.h:
  - Doxygenized some comments
 include/pqxx/tablestream.h:
  - Doxygenized some comments
 include/pqxx/tablewriter.h:
  - Doxygenized some comments
 include/pqxx/transaction.h:
  - Doxygenized some comments
 include/pqxx/transactionitf.h:
  - Doxygenized some comments
 include/pqxx/util.h:
  - Doxygenized some comments
2002-05-05 03:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/libpqxx/*.h:
  - Converted many comments to doxygen/javadoc format
 README:
  - More useful information
2002-05-05 01:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 README:
  - Greatly extended build documentation
2002-05-04 20:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 include/pqxx/result.h:
  - Added clear(), capacity()
 include/pqxx/tablewriter.h:
  - Added "range" versions of insert() etc.
  - Added dummy reserve()
 include/pqxx/transactor.h:
  - Protected against multiple inclusion
 include/pqxx/*.h:
  - Changed PG_[...] macros to PQXX_[...]
 test/test5.cxx:
  - Simplified using range versions of TableWriter methods
 test/test6.cxx:
  - Table arguments now default to "orgevents" and "events"
 test/test*.cxx:
  - Included libpqxx headers with <>, rather than ""
2002-04-28 23:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Used automake's --copy option
 config/Makefile.am:
  - Created so config stuff can get packaged
 configure.ac:
  - Added AM_MAINTAINER_MODE
  - Moved generated config files into directory of their own
  - Bumped version to 0.2
 doc/Makefile.am:
  - Got html subdir into package
 include/Makefile.am:
  - Moved pqxx from SUBDIRS to EXTRA_DIST
 Makefile.am:
  - Added doc and config subdirs
2002-04-27 13:20  Jeroen T. Vermeulen <jtv@xs4all.nl>
 autogen.sh:
  - Added --copy option to automake invocation
2002-04-07 02:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Configure.ac:
  - Fixed AM_INIT_AUTOMAKE line
 Readme:
  - Described build & install procedure
 Test6:
  - Fixed handling of (expected) CreateTable failure
2002-04-05 21:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Configure:
  - Finally found out what was missing: VERSION was undefined
  - Added -ffor-scope to compiler command line
  - Changed -fascist to -ffascist
  - Cleaned up --with-postgres code, fixed typo
 test/Makefile.am:
  - Replaced John Anderson's test environment parameters with my own
 Test6:
  - Creates destination table if it didn't already exist
2002-04-02 01:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableWriter:
  - Wrapped back_insert_iterator specialization in namespace PGSTD { ... }
 Test1, Test2, Test4, Test7, Test10, Test14, Test15, Test16, Test17, Test19:
  - Made argc anonymous to silence "unused parameter" warnings
 TransactionItf:
  - Begin() now calls End() on failure (thanks Clinton James for bug report)
  - End() now ignores redundant invocations
  - Destructor checks that End() has been called
  - Added empty throw specification to End()
2002-04-01 01:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Configure:
  - More help from John Anderson
 TableWriter:
  - Enclosed std::back_insert_iterator specialization in namespace PGSTD
2002-03-31 01:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Integrated John Anderson's autoconf/automake files and Ray Dassen's fixes
 Result:
  - Moved some inline functions to silence compiler warnings
2002-03-30  J.H.M. Dassen (Ray) <jdassen@debian.org>
 configure.in:
  - Renamed from configure.ac
  - Added bug report address to AC_INIT
  - Check for and enable several compiler warnings etc.
  - Detect whether <limits> is available
  - Detect whether <iterator> defines 
 Util:
  - Look for postgres_fe.h in a "server" subdirectory
 Compiler:
  - Use configure-determined HAVE_LIMITS
 doc/Makefile:
  - Created
 Docs:
  - Added DOCTYPE, made proper DocBook, use <ulink> for libpq reference.
2002-03-29 01:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
  All:
   - DLL export directives for Windows, thanks Clinton James
  ChangeLog:
   - Created
   - Moved NEWS over to ChangeLog
  News:
   - Created for more high-level changes
  Selftest:
   - Exits when any command fails
  Test4:
   - sleep() workaround for Windows, thanks Clinton James
2002-03-27 01:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 AUTHORS:
  - Created
 CHANGES:
  - Renamed to NEWS
2002-03-26 22:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Makefile:
  - Put regression test into separate script
 Result:
  - Inlined Result::Field methods
 Selftest:
  - Created
2002-03-26 00:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Doc:
  - Added HTML docs, fixed bugs in SGML; thanks Bruce Momjian.
2002-03-23 05:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result, TransactionItf, Transactor:
  - Several compile fixes (especially under MS Visual C++)--Clinton James
2002-03-22 02:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Renamed *.cc to *.cxx for MS Visual C++, thanks Clinton James
2002-03-20 14:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result:
  - Fixed to compile errors on gcc 2.96.x, thanks Vyacheslav Ignatyuk
2002-03-20 02:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Renamed namespace Pg to pqxx for consistency
2002-03-20 01:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Renamed library source files to match new header file names
2002-03-20 01:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Great Renaming of header files (pg_*.h to pqxx/*.h)
2002-03-20 00:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Moved library header files into include directory
  - Moved library source files into src directory
  - Moved test source files into test directory
 Makefile:
  - Reduced use of repetitive explicit rules
2002-03-17 01:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - Full test coverage!
 Cursor:
  - Full test coverage
  - Removed PostgreSQL-specific FORWARD/BACKWARD, previously labeled "ANSI"
  - Kludged BACKWARD_ALL around breakage
  - Implemented += and -=
 NonTransaction, RobustTransaction, Transaction:
  - Documented test coverage of overridables, even though they're private
 Test1:
  - More comments
 Test19:
  - Created
 Test3:
  - Improved Cursor test coverage
 TransactionItf:
  - Updated header comments
2002-03-05 17:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Makefile:
  - Now queries log table at end of regression test; should be empty
 Test4, Test6, Test7, Test13, Test15, Test17:
  - Recommended practice is now to use TRANSACTIONTYPE in Transactors
 Test18:
  - Created
2002-03-05 00:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 RobustTransaction:
  - Initial implementation
 Test14:
  - Oops, tested Transaction instead of NonTransaction
 Test16:
  - Created
 Test17:
  - Created
2002-03-04 22:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 RobustTransaction:
  - Created as outline based on Transaction
2002-03-04 00:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 NonTransaction:
  - Created
 Test14:
  - Created
 Test15:
  - Created
 Transaction:
  - Made subclass of new abstract base class TransactionItf
 TransactionItf:
  - Created
 Transactor:
  - Made choice of transaction class parameterizable
2002-03-03 17:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Transactor:
  - Made Transaction class selectable, so can add more transaction types later
  - Added OnDoubt()
2002-03-03 16:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Connection:
  - In-doubt transactions are no longer retried
 Makefile:
  - Added /usr/include/postgresql/internal to include path
  - Works for PostgreSQL 7.1 and 7.2 now
 Transaction:
  - Introduced checking for in-doubt transactions
  - Minor improvements in error handling
2002-03-02 14:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableReader:
  - Full test coverage
 Test6:
  - Added consistency check for TableReader's operator!()/operator bool()
 Test8:
  - Added consistency check for TableReader's GetRawLine()/Tokenize()
2002-03-01 00:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableStream:
  - Full test coverage
2002-03-01 00:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableWriter:
  - Full test coverage
 Test10:
  - Used TableWriter to insert tuple
2002-02-28 23:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Test13:
  - Created
 Transactor:
  - Full test coverage
2002-02-27 00:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result:
  - Full test coverage
 Test12:
  - Created
2002-02-26 23:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result:
  - Extended test coverage to metadata queries
 Test11:
  - Created
2002-02-24 22:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result:
  - Documented method coverage
 Test10:
  - Disabled trace output
2002-02-24 05:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Transaction:
  - Full method coverage by self-test
  - Found recently introduced bug in implicit abort!
2002-02-24 04:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableStream:
  - Documented method coverage
 TableReader:
  - Documented method coverage
 TableWriter:
  - Documented method coverage
 Test10:
  - Created
 Transaction:
  - Documented method coverage
  - Improved test coverage
 Transactor:
  - Documented method coverage
2002-02-24 01:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 CONCEPT:
  - Removed unneeded old file
 Connection:
  - Full method coverage by self-test
 Cursor:
  - Documented method coverage
 Trigger:
  - Full method coverage by self-test
2002-02-15 01:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Docs:
  - More explanation on transaction bracketing
 Transaction:
  - Deferring commits to destruction time was wrong
2002-02-03 20:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result:
  - Added metadata query methods
  - Removed unnecessary friendship with Tuple
2002-02-03 06:00  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Docs:
  - More examples
 Makefile:
  - No longer removes old library.  Same difference.
  - Abstracted away source tarball, source directory name
2002-02-02 18:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Docs:
  - More on exceptions, more on executing queries.
 Makefile:
  - Now builds an actual (but static) library
2002-01-26 21:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 CVS:
  - Imported into CVS
 Makefile:
  - Fixed "std namespace compiler workaround" breako
  - Added "dist" target
2002-01-26 00:30  Jeroen T. Vermeulen <jtv@xs4all.nl>
 All:
  - New #define PGSTD to replace std if needed
 Compiler:
  - New header pg_compiler.h
  - Genericized workaround for missing numeric_limits
  - Disable braindead Microsoft Visual C++ warnings
2002-01-20 14:50  Jeroen T. Vermeulen <jtv@xs4all.nl>
 Result:
  - Fixed Result::Field::name() -- thanks to Gilberto Ribeiro de Queiroz
2002-01-08 21:50  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableWriter:
  - operator= forgot to return *this
 Test9:
  - Created to test TableWriter's back_insert_iterator
2002-01-07 00:15  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableWriter:
  - Implemented back_insert_iterator<TableWriter>
2002-01-01 23:45  Jeroen T. Vermeulen <jtv@xs4all.nl>
 TableWriter:
  - Forgot to separate fields in output
 Tests:
  - Rearranged to set up their own database environment
  - New test writes orgevents table
 Transaction:
  - Merged "clean" state into "active" state
  - Moved back-end COMMIT into Transaction's destructor
2001-12-30 18:00
 Docs:
  - Added why-a-new-library section
  - Explained transactions
 Transaction:
  - Abort no longer does a redundant ABORT WORK if already aborted
2001-12-23 22:30
 Docs:
  - Mentions Trigger and TableStream now
2001-12-23 14:40
 Connection:
  - Support removal of triggers
  - Reserved AddTrigger() and RemoveTrigger() for use by Trigger
 Test3:
  - Updated for revised Transactor interface
 Test4:
  - Changed "Got [] rows" in output to "Got [] row(s)"
 Test5:
  - Updated for revised Trigger interface
 Test7:
  - Updated for revised Transactor interface
 Transactor:
  - Built name into Transactor as data member
  - Added name as constructor argument
  - Name() returns std::string
 Trigger:
  - Built registering/unregistering into Trigger; constructor change!
  - Name() returns std::string

2001-12-16 00:45
 Connection:
  - Added COPY support
 Makefile:
  - Now sets my personal connect string as CONNSTR for regression test
  - Uses test7 to restore events table clobbered in test3
  - Now requires new table "orgevents"
 TableReader:
  - Basic functionality implemented
 TableWriter:
  - Basic functionality implemented
 Test4:
  - Updated comments to reflect new cursor "count" convention
 Test6:
  - Created
 Test7:
  - Created
 Transaction:
  - Added COPY support
 Util:
  - Added FromString() analogous (but opposite) to ToString()

2001-12-12 22:20
 Connection:
  - Uses new Unique<> template for m_Trans
 TableReader:
  - Created
 TableStream:
  - Created
 TableWriter:
  - Created
 Transaction:
  - Now checks for active stream
  - Destructor catches Abort() exceptions
 Util:
  - Introduced Unique<> class template

2001-12-02 20:30
 All:
  - Inlined more functions
 Connection:
  - Misc. query functions added

2001-12-02 17:30
 Connection:
  - ProcessNotice() to call (possibly client-defined) notice processor
 Transaction:
  - Now calls notice processor when it can't throw exceptions
  - Checks for pending triggers before it begins
 Trigger:
  - Guarantees that no notifications are delivered inside transactions

2001-12-02 16:00
 Makefile:
  - check target now depends on executables
  - Passes more interesting "count" argument to test4
 Connection:
  - MakeEmpty() to create empty result set
  - Stricter error checking on opening/closing transactions
 Cursor: 
  - Irregular meaning of 0 for fetch/move no longer used
  - Added Fetch() and Move()
  - Fixed "done" accounting in SetCount()
  - Separated creation of FETCH command into MakeFetchCmd() method
 Transaction:
  - Added MakeEmpty()
 Util:
  - Added Result_size_type_max
 test4:
  - Seeks to end of query first if backwards retrieval requested
